// Code generated by go-swagger; DO NOT EDIT.

package alerts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new alerts API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for alerts API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	GetQueriesAlertsV1(params *GetQueriesAlertsV1Params, opts ...ClientOption) (*GetQueriesAlertsV1OK, error)

	PatchEntitiesAlertsV1(params *PatchEntitiesAlertsV1Params, opts ...ClientOption) (*PatchEntitiesAlertsV1OK, error)

	PatchEntitiesAlertsV2(params *PatchEntitiesAlertsV2Params, opts ...ClientOption) (*PatchEntitiesAlertsV2OK, error)

	PostAggregatesAlertsV1(params *PostAggregatesAlertsV1Params, opts ...ClientOption) (*PostAggregatesAlertsV1OK, error)

	PostEntitiesAlertsV1(params *PostEntitiesAlertsV1Params, opts ...ClientOption) (*PostEntitiesAlertsV1OK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
GetQueriesAlertsV1 retrieves all alerts ids that match a given query
*/
func (a *Client) GetQueriesAlertsV1(params *GetQueriesAlertsV1Params, opts ...ClientOption) (*GetQueriesAlertsV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewGetQueriesAlertsV1Params()
	}
	op := &runtime.ClientOperation{
		ID:                 "GetQueriesAlertsV1",
		Method:             "GET",
		PathPattern:        "/alerts/queries/alerts/v1",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &GetQueriesAlertsV1Reader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*GetQueriesAlertsV1OK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*GetQueriesAlertsV1Default)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
PatchEntitiesAlertsV1 performs actions on detections identified by detection ID s in request each action has a name and a description which describes what the action does remove tag remove a tag from 1 or more detection s assign to user id assign 1 or more detection s to a user identified by user id eg user1 at example com unassign unassign an previously assigned user from 1 or more detection s the value passed to this action is ignored new behavior processed adds a newly processed behavior to 1 or more detection s update status update status for 1 or more detection s assign to uuid assign 1 or more detection s to a user identified by UUID add tag add a tag to 1 or more detection s remove tags by prefix remove tags with given prefix from 1 or more detection s append comment appends new comment to existing comments assign to name assign 1 or more detection s to a user identified by user name show in ui shows 1 or more detection s on UI if set to true hides otherwise an empty nil value is also valid skip side effects internal only command to skip side effects during beta phase
*/
func (a *Client) PatchEntitiesAlertsV1(params *PatchEntitiesAlertsV1Params, opts ...ClientOption) (*PatchEntitiesAlertsV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPatchEntitiesAlertsV1Params()
	}
	op := &runtime.ClientOperation{
		ID:                 "PatchEntitiesAlertsV1",
		Method:             "PATCH",
		PathPattern:        "/alerts/entities/alerts/v1",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &PatchEntitiesAlertsV1Reader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PatchEntitiesAlertsV1OK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*PatchEntitiesAlertsV1Default)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
PatchEntitiesAlertsV2 performs actions on detections identified by detection ID s in request each action has a name and a description which describes what the action does
*/
func (a *Client) PatchEntitiesAlertsV2(params *PatchEntitiesAlertsV2Params, opts ...ClientOption) (*PatchEntitiesAlertsV2OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPatchEntitiesAlertsV2Params()
	}
	op := &runtime.ClientOperation{
		ID:                 "PatchEntitiesAlertsV2",
		Method:             "PATCH",
		PathPattern:        "/alerts/entities/alerts/v2",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &PatchEntitiesAlertsV2Reader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PatchEntitiesAlertsV2OK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*PatchEntitiesAlertsV2Default)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
PostAggregatesAlertsV1 retrieves aggregates for alerts across all c i ds
*/
func (a *Client) PostAggregatesAlertsV1(params *PostAggregatesAlertsV1Params, opts ...ClientOption) (*PostAggregatesAlertsV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostAggregatesAlertsV1Params()
	}
	op := &runtime.ClientOperation{
		ID:                 "PostAggregatesAlertsV1",
		Method:             "POST",
		PathPattern:        "/alerts/aggregates/alerts/v1",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &PostAggregatesAlertsV1Reader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostAggregatesAlertsV1OK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*PostAggregatesAlertsV1Default)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

/*
PostEntitiesAlertsV1 retrieves all alerts given their ids
*/
func (a *Client) PostEntitiesAlertsV1(params *PostEntitiesAlertsV1Params, opts ...ClientOption) (*PostEntitiesAlertsV1OK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewPostEntitiesAlertsV1Params()
	}
	op := &runtime.ClientOperation{
		ID:                 "PostEntitiesAlertsV1",
		Method:             "POST",
		PathPattern:        "/alerts/entities/alerts/v1",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &PostEntitiesAlertsV1Reader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*PostEntitiesAlertsV1OK)
	if ok {
		return success, nil
	}
	// unexpected success response
	unexpectedSuccess := result.(*PostEntitiesAlertsV1Default)
	return nil, runtime.NewAPIError("unexpected success response: content available as default response in error", unexpectedSuccess, unexpectedSuccess.Code())
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
