// Code generated by go-swagger; DO NOT EDIT.

package alerts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// PostEntitiesAlertsV1Reader is a Reader for the PostEntitiesAlertsV1 structure.
type PostEntitiesAlertsV1Reader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostEntitiesAlertsV1Reader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostEntitiesAlertsV1OK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewPostEntitiesAlertsV1BadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostEntitiesAlertsV1Forbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 429:
		result := NewPostEntitiesAlertsV1TooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostEntitiesAlertsV1InternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPostEntitiesAlertsV1Default(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPostEntitiesAlertsV1OK creates a PostEntitiesAlertsV1OK with default headers values
func NewPostEntitiesAlertsV1OK() *PostEntitiesAlertsV1OK {
	return &PostEntitiesAlertsV1OK{}
}

/*
PostEntitiesAlertsV1OK describes a response with status code 200, with default header values.

OK
*/
type PostEntitiesAlertsV1OK struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.DetectsapiPostEntitiesInvestigatablesV1Response
}

// IsSuccess returns true when this post entities alerts v1 o k response has a 2xx status code
func (o *PostEntitiesAlertsV1OK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this post entities alerts v1 o k response has a 3xx status code
func (o *PostEntitiesAlertsV1OK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post entities alerts v1 o k response has a 4xx status code
func (o *PostEntitiesAlertsV1OK) IsClientError() bool {
	return false
}

// IsServerError returns true when this post entities alerts v1 o k response has a 5xx status code
func (o *PostEntitiesAlertsV1OK) IsServerError() bool {
	return false
}

// IsCode returns true when this post entities alerts v1 o k response a status code equal to that given
func (o *PostEntitiesAlertsV1OK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the post entities alerts v1 o k response
func (o *PostEntitiesAlertsV1OK) Code() int {
	return 200
}

func (o *PostEntitiesAlertsV1OK) Error() string {
	return fmt.Sprintf("[POST /alerts/entities/alerts/v1][%d] postEntitiesAlertsV1OK  %+v", 200, o.Payload)
}

func (o *PostEntitiesAlertsV1OK) String() string {
	return fmt.Sprintf("[POST /alerts/entities/alerts/v1][%d] postEntitiesAlertsV1OK  %+v", 200, o.Payload)
}

func (o *PostEntitiesAlertsV1OK) GetPayload() *models.DetectsapiPostEntitiesInvestigatablesV1Response {
	return o.Payload
}

func (o *PostEntitiesAlertsV1OK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.DetectsapiPostEntitiesInvestigatablesV1Response)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostEntitiesAlertsV1BadRequest creates a PostEntitiesAlertsV1BadRequest with default headers values
func NewPostEntitiesAlertsV1BadRequest() *PostEntitiesAlertsV1BadRequest {
	return &PostEntitiesAlertsV1BadRequest{}
}

/*
PostEntitiesAlertsV1BadRequest describes a response with status code 400, with default header values.

Bad Request
*/
type PostEntitiesAlertsV1BadRequest struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.DetectsapiPostEntitiesInvestigatablesV1Response
}

// IsSuccess returns true when this post entities alerts v1 bad request response has a 2xx status code
func (o *PostEntitiesAlertsV1BadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post entities alerts v1 bad request response has a 3xx status code
func (o *PostEntitiesAlertsV1BadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post entities alerts v1 bad request response has a 4xx status code
func (o *PostEntitiesAlertsV1BadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this post entities alerts v1 bad request response has a 5xx status code
func (o *PostEntitiesAlertsV1BadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this post entities alerts v1 bad request response a status code equal to that given
func (o *PostEntitiesAlertsV1BadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the post entities alerts v1 bad request response
func (o *PostEntitiesAlertsV1BadRequest) Code() int {
	return 400
}

func (o *PostEntitiesAlertsV1BadRequest) Error() string {
	return fmt.Sprintf("[POST /alerts/entities/alerts/v1][%d] postEntitiesAlertsV1BadRequest  %+v", 400, o.Payload)
}

func (o *PostEntitiesAlertsV1BadRequest) String() string {
	return fmt.Sprintf("[POST /alerts/entities/alerts/v1][%d] postEntitiesAlertsV1BadRequest  %+v", 400, o.Payload)
}

func (o *PostEntitiesAlertsV1BadRequest) GetPayload() *models.DetectsapiPostEntitiesInvestigatablesV1Response {
	return o.Payload
}

func (o *PostEntitiesAlertsV1BadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.DetectsapiPostEntitiesInvestigatablesV1Response)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostEntitiesAlertsV1Forbidden creates a PostEntitiesAlertsV1Forbidden with default headers values
func NewPostEntitiesAlertsV1Forbidden() *PostEntitiesAlertsV1Forbidden {
	return &PostEntitiesAlertsV1Forbidden{}
}

/*
PostEntitiesAlertsV1Forbidden describes a response with status code 403, with default header values.

Forbidden
*/
type PostEntitiesAlertsV1Forbidden struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this post entities alerts v1 forbidden response has a 2xx status code
func (o *PostEntitiesAlertsV1Forbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post entities alerts v1 forbidden response has a 3xx status code
func (o *PostEntitiesAlertsV1Forbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post entities alerts v1 forbidden response has a 4xx status code
func (o *PostEntitiesAlertsV1Forbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this post entities alerts v1 forbidden response has a 5xx status code
func (o *PostEntitiesAlertsV1Forbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this post entities alerts v1 forbidden response a status code equal to that given
func (o *PostEntitiesAlertsV1Forbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the post entities alerts v1 forbidden response
func (o *PostEntitiesAlertsV1Forbidden) Code() int {
	return 403
}

func (o *PostEntitiesAlertsV1Forbidden) Error() string {
	return fmt.Sprintf("[POST /alerts/entities/alerts/v1][%d] postEntitiesAlertsV1Forbidden  %+v", 403, o.Payload)
}

func (o *PostEntitiesAlertsV1Forbidden) String() string {
	return fmt.Sprintf("[POST /alerts/entities/alerts/v1][%d] postEntitiesAlertsV1Forbidden  %+v", 403, o.Payload)
}

func (o *PostEntitiesAlertsV1Forbidden) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *PostEntitiesAlertsV1Forbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostEntitiesAlertsV1TooManyRequests creates a PostEntitiesAlertsV1TooManyRequests with default headers values
func NewPostEntitiesAlertsV1TooManyRequests() *PostEntitiesAlertsV1TooManyRequests {
	return &PostEntitiesAlertsV1TooManyRequests{}
}

/*
PostEntitiesAlertsV1TooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PostEntitiesAlertsV1TooManyRequests struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	/* Too many requests, retry after this time (as milliseconds since epoch)
	 */
	XRateLimitRetryAfter int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this post entities alerts v1 too many requests response has a 2xx status code
func (o *PostEntitiesAlertsV1TooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post entities alerts v1 too many requests response has a 3xx status code
func (o *PostEntitiesAlertsV1TooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post entities alerts v1 too many requests response has a 4xx status code
func (o *PostEntitiesAlertsV1TooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this post entities alerts v1 too many requests response has a 5xx status code
func (o *PostEntitiesAlertsV1TooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this post entities alerts v1 too many requests response a status code equal to that given
func (o *PostEntitiesAlertsV1TooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the post entities alerts v1 too many requests response
func (o *PostEntitiesAlertsV1TooManyRequests) Code() int {
	return 429
}

func (o *PostEntitiesAlertsV1TooManyRequests) Error() string {
	return fmt.Sprintf("[POST /alerts/entities/alerts/v1][%d] postEntitiesAlertsV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *PostEntitiesAlertsV1TooManyRequests) String() string {
	return fmt.Sprintf("[POST /alerts/entities/alerts/v1][%d] postEntitiesAlertsV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *PostEntitiesAlertsV1TooManyRequests) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *PostEntitiesAlertsV1TooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header X-RateLimit-RetryAfter
	hdrXRateLimitRetryAfter := response.GetHeader("X-RateLimit-RetryAfter")

	if hdrXRateLimitRetryAfter != "" {
		valxRateLimitRetryAfter, err := swag.ConvertInt64(hdrXRateLimitRetryAfter)
		if err != nil {
			return errors.InvalidType("X-RateLimit-RetryAfter", "header", "int64", hdrXRateLimitRetryAfter)
		}
		o.XRateLimitRetryAfter = valxRateLimitRetryAfter
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostEntitiesAlertsV1InternalServerError creates a PostEntitiesAlertsV1InternalServerError with default headers values
func NewPostEntitiesAlertsV1InternalServerError() *PostEntitiesAlertsV1InternalServerError {
	return &PostEntitiesAlertsV1InternalServerError{}
}

/*
PostEntitiesAlertsV1InternalServerError describes a response with status code 500, with default header values.

Internal Server Error
*/
type PostEntitiesAlertsV1InternalServerError struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.DetectsapiPostEntitiesInvestigatablesV1Response
}

// IsSuccess returns true when this post entities alerts v1 internal server error response has a 2xx status code
func (o *PostEntitiesAlertsV1InternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post entities alerts v1 internal server error response has a 3xx status code
func (o *PostEntitiesAlertsV1InternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post entities alerts v1 internal server error response has a 4xx status code
func (o *PostEntitiesAlertsV1InternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this post entities alerts v1 internal server error response has a 5xx status code
func (o *PostEntitiesAlertsV1InternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this post entities alerts v1 internal server error response a status code equal to that given
func (o *PostEntitiesAlertsV1InternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the post entities alerts v1 internal server error response
func (o *PostEntitiesAlertsV1InternalServerError) Code() int {
	return 500
}

func (o *PostEntitiesAlertsV1InternalServerError) Error() string {
	return fmt.Sprintf("[POST /alerts/entities/alerts/v1][%d] postEntitiesAlertsV1InternalServerError  %+v", 500, o.Payload)
}

func (o *PostEntitiesAlertsV1InternalServerError) String() string {
	return fmt.Sprintf("[POST /alerts/entities/alerts/v1][%d] postEntitiesAlertsV1InternalServerError  %+v", 500, o.Payload)
}

func (o *PostEntitiesAlertsV1InternalServerError) GetPayload() *models.DetectsapiPostEntitiesInvestigatablesV1Response {
	return o.Payload
}

func (o *PostEntitiesAlertsV1InternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.DetectsapiPostEntitiesInvestigatablesV1Response)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostEntitiesAlertsV1Default creates a PostEntitiesAlertsV1Default with default headers values
func NewPostEntitiesAlertsV1Default(code int) *PostEntitiesAlertsV1Default {
	return &PostEntitiesAlertsV1Default{
		_statusCode: code,
	}
}

/*
PostEntitiesAlertsV1Default describes a response with status code -1, with default header values.

OK
*/
type PostEntitiesAlertsV1Default struct {
	_statusCode int

	Payload *models.DetectsapiPostEntitiesInvestigatablesV1Response
}

// IsSuccess returns true when this post entities alerts v1 default response has a 2xx status code
func (o *PostEntitiesAlertsV1Default) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this post entities alerts v1 default response has a 3xx status code
func (o *PostEntitiesAlertsV1Default) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this post entities alerts v1 default response has a 4xx status code
func (o *PostEntitiesAlertsV1Default) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this post entities alerts v1 default response has a 5xx status code
func (o *PostEntitiesAlertsV1Default) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this post entities alerts v1 default response a status code equal to that given
func (o *PostEntitiesAlertsV1Default) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the post entities alerts v1 default response
func (o *PostEntitiesAlertsV1Default) Code() int {
	return o._statusCode
}

func (o *PostEntitiesAlertsV1Default) Error() string {
	return fmt.Sprintf("[POST /alerts/entities/alerts/v1][%d] PostEntitiesAlertsV1 default  %+v", o._statusCode, o.Payload)
}

func (o *PostEntitiesAlertsV1Default) String() string {
	return fmt.Sprintf("[POST /alerts/entities/alerts/v1][%d] PostEntitiesAlertsV1 default  %+v", o._statusCode, o.Payload)
}

func (o *PostEntitiesAlertsV1Default) GetPayload() *models.DetectsapiPostEntitiesInvestigatablesV1Response {
	return o.Payload
}

func (o *PostEntitiesAlertsV1Default) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DetectsapiPostEntitiesInvestigatablesV1Response)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
