// Code generated by go-swagger; DO NOT EDIT.

package cspm_registration

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// GetCSPMAwsAccountScriptsAttachmentReader is a Reader for the GetCSPMAwsAccountScriptsAttachment structure.
type GetCSPMAwsAccountScriptsAttachmentReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetCSPMAwsAccountScriptsAttachmentReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetCSPMAwsAccountScriptsAttachmentOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewGetCSPMAwsAccountScriptsAttachmentBadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewGetCSPMAwsAccountScriptsAttachmentForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 429:
		result := NewGetCSPMAwsAccountScriptsAttachmentTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewGetCSPMAwsAccountScriptsAttachmentInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetCSPMAwsAccountScriptsAttachmentDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetCSPMAwsAccountScriptsAttachmentOK creates a GetCSPMAwsAccountScriptsAttachmentOK with default headers values
func NewGetCSPMAwsAccountScriptsAttachmentOK() *GetCSPMAwsAccountScriptsAttachmentOK {
	return &GetCSPMAwsAccountScriptsAttachmentOK{}
}

/*
GetCSPMAwsAccountScriptsAttachmentOK describes a response with status code 200, with default header values.

OK
*/
type GetCSPMAwsAccountScriptsAttachmentOK struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.RegistrationAWSProvisionGetAccountScriptResponseV2
}

// IsSuccess returns true when this get c s p m aws account scripts attachment o k response has a 2xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get c s p m aws account scripts attachment o k response has a 3xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get c s p m aws account scripts attachment o k response has a 4xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get c s p m aws account scripts attachment o k response has a 5xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get c s p m aws account scripts attachment o k response a status code equal to that given
func (o *GetCSPMAwsAccountScriptsAttachmentOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get c s p m aws account scripts attachment o k response
func (o *GetCSPMAwsAccountScriptsAttachmentOK) Code() int {
	return 200
}

func (o *GetCSPMAwsAccountScriptsAttachmentOK) Error() string {
	return fmt.Sprintf("[GET /cloud-connect-cspm-aws/entities/user-scripts-download/v1][%d] getCSPMAwsAccountScriptsAttachmentOK  %+v", 200, o.Payload)
}

func (o *GetCSPMAwsAccountScriptsAttachmentOK) String() string {
	return fmt.Sprintf("[GET /cloud-connect-cspm-aws/entities/user-scripts-download/v1][%d] getCSPMAwsAccountScriptsAttachmentOK  %+v", 200, o.Payload)
}

func (o *GetCSPMAwsAccountScriptsAttachmentOK) GetPayload() *models.RegistrationAWSProvisionGetAccountScriptResponseV2 {
	return o.Payload
}

func (o *GetCSPMAwsAccountScriptsAttachmentOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.RegistrationAWSProvisionGetAccountScriptResponseV2)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCSPMAwsAccountScriptsAttachmentBadRequest creates a GetCSPMAwsAccountScriptsAttachmentBadRequest with default headers values
func NewGetCSPMAwsAccountScriptsAttachmentBadRequest() *GetCSPMAwsAccountScriptsAttachmentBadRequest {
	return &GetCSPMAwsAccountScriptsAttachmentBadRequest{}
}

/*
GetCSPMAwsAccountScriptsAttachmentBadRequest describes a response with status code 400, with default header values.

Bad Request
*/
type GetCSPMAwsAccountScriptsAttachmentBadRequest struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.RegistrationAWSProvisionGetAccountScriptResponseV2
}

// IsSuccess returns true when this get c s p m aws account scripts attachment bad request response has a 2xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentBadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get c s p m aws account scripts attachment bad request response has a 3xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentBadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get c s p m aws account scripts attachment bad request response has a 4xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentBadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this get c s p m aws account scripts attachment bad request response has a 5xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentBadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this get c s p m aws account scripts attachment bad request response a status code equal to that given
func (o *GetCSPMAwsAccountScriptsAttachmentBadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the get c s p m aws account scripts attachment bad request response
func (o *GetCSPMAwsAccountScriptsAttachmentBadRequest) Code() int {
	return 400
}

func (o *GetCSPMAwsAccountScriptsAttachmentBadRequest) Error() string {
	return fmt.Sprintf("[GET /cloud-connect-cspm-aws/entities/user-scripts-download/v1][%d] getCSPMAwsAccountScriptsAttachmentBadRequest  %+v", 400, o.Payload)
}

func (o *GetCSPMAwsAccountScriptsAttachmentBadRequest) String() string {
	return fmt.Sprintf("[GET /cloud-connect-cspm-aws/entities/user-scripts-download/v1][%d] getCSPMAwsAccountScriptsAttachmentBadRequest  %+v", 400, o.Payload)
}

func (o *GetCSPMAwsAccountScriptsAttachmentBadRequest) GetPayload() *models.RegistrationAWSProvisionGetAccountScriptResponseV2 {
	return o.Payload
}

func (o *GetCSPMAwsAccountScriptsAttachmentBadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.RegistrationAWSProvisionGetAccountScriptResponseV2)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCSPMAwsAccountScriptsAttachmentForbidden creates a GetCSPMAwsAccountScriptsAttachmentForbidden with default headers values
func NewGetCSPMAwsAccountScriptsAttachmentForbidden() *GetCSPMAwsAccountScriptsAttachmentForbidden {
	return &GetCSPMAwsAccountScriptsAttachmentForbidden{}
}

/*
GetCSPMAwsAccountScriptsAttachmentForbidden describes a response with status code 403, with default header values.

Forbidden
*/
type GetCSPMAwsAccountScriptsAttachmentForbidden struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this get c s p m aws account scripts attachment forbidden response has a 2xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get c s p m aws account scripts attachment forbidden response has a 3xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get c s p m aws account scripts attachment forbidden response has a 4xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get c s p m aws account scripts attachment forbidden response has a 5xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get c s p m aws account scripts attachment forbidden response a status code equal to that given
func (o *GetCSPMAwsAccountScriptsAttachmentForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get c s p m aws account scripts attachment forbidden response
func (o *GetCSPMAwsAccountScriptsAttachmentForbidden) Code() int {
	return 403
}

func (o *GetCSPMAwsAccountScriptsAttachmentForbidden) Error() string {
	return fmt.Sprintf("[GET /cloud-connect-cspm-aws/entities/user-scripts-download/v1][%d] getCSPMAwsAccountScriptsAttachmentForbidden  %+v", 403, o.Payload)
}

func (o *GetCSPMAwsAccountScriptsAttachmentForbidden) String() string {
	return fmt.Sprintf("[GET /cloud-connect-cspm-aws/entities/user-scripts-download/v1][%d] getCSPMAwsAccountScriptsAttachmentForbidden  %+v", 403, o.Payload)
}

func (o *GetCSPMAwsAccountScriptsAttachmentForbidden) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *GetCSPMAwsAccountScriptsAttachmentForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCSPMAwsAccountScriptsAttachmentTooManyRequests creates a GetCSPMAwsAccountScriptsAttachmentTooManyRequests with default headers values
func NewGetCSPMAwsAccountScriptsAttachmentTooManyRequests() *GetCSPMAwsAccountScriptsAttachmentTooManyRequests {
	return &GetCSPMAwsAccountScriptsAttachmentTooManyRequests{}
}

/*
GetCSPMAwsAccountScriptsAttachmentTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetCSPMAwsAccountScriptsAttachmentTooManyRequests struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	/* Too many requests, retry after this time (as milliseconds since epoch)
	 */
	XRateLimitRetryAfter int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this get c s p m aws account scripts attachment too many requests response has a 2xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get c s p m aws account scripts attachment too many requests response has a 3xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get c s p m aws account scripts attachment too many requests response has a 4xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get c s p m aws account scripts attachment too many requests response has a 5xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get c s p m aws account scripts attachment too many requests response a status code equal to that given
func (o *GetCSPMAwsAccountScriptsAttachmentTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get c s p m aws account scripts attachment too many requests response
func (o *GetCSPMAwsAccountScriptsAttachmentTooManyRequests) Code() int {
	return 429
}

func (o *GetCSPMAwsAccountScriptsAttachmentTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /cloud-connect-cspm-aws/entities/user-scripts-download/v1][%d] getCSPMAwsAccountScriptsAttachmentTooManyRequests  %+v", 429, o.Payload)
}

func (o *GetCSPMAwsAccountScriptsAttachmentTooManyRequests) String() string {
	return fmt.Sprintf("[GET /cloud-connect-cspm-aws/entities/user-scripts-download/v1][%d] getCSPMAwsAccountScriptsAttachmentTooManyRequests  %+v", 429, o.Payload)
}

func (o *GetCSPMAwsAccountScriptsAttachmentTooManyRequests) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *GetCSPMAwsAccountScriptsAttachmentTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header X-RateLimit-RetryAfter
	hdrXRateLimitRetryAfter := response.GetHeader("X-RateLimit-RetryAfter")

	if hdrXRateLimitRetryAfter != "" {
		valxRateLimitRetryAfter, err := swag.ConvertInt64(hdrXRateLimitRetryAfter)
		if err != nil {
			return errors.InvalidType("X-RateLimit-RetryAfter", "header", "int64", hdrXRateLimitRetryAfter)
		}
		o.XRateLimitRetryAfter = valxRateLimitRetryAfter
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCSPMAwsAccountScriptsAttachmentInternalServerError creates a GetCSPMAwsAccountScriptsAttachmentInternalServerError with default headers values
func NewGetCSPMAwsAccountScriptsAttachmentInternalServerError() *GetCSPMAwsAccountScriptsAttachmentInternalServerError {
	return &GetCSPMAwsAccountScriptsAttachmentInternalServerError{}
}

/*
GetCSPMAwsAccountScriptsAttachmentInternalServerError describes a response with status code 500, with default header values.

Internal Server Error
*/
type GetCSPMAwsAccountScriptsAttachmentInternalServerError struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.RegistrationAWSProvisionGetAccountScriptResponseV2
}

// IsSuccess returns true when this get c s p m aws account scripts attachment internal server error response has a 2xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get c s p m aws account scripts attachment internal server error response has a 3xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get c s p m aws account scripts attachment internal server error response has a 4xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this get c s p m aws account scripts attachment internal server error response has a 5xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this get c s p m aws account scripts attachment internal server error response a status code equal to that given
func (o *GetCSPMAwsAccountScriptsAttachmentInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the get c s p m aws account scripts attachment internal server error response
func (o *GetCSPMAwsAccountScriptsAttachmentInternalServerError) Code() int {
	return 500
}

func (o *GetCSPMAwsAccountScriptsAttachmentInternalServerError) Error() string {
	return fmt.Sprintf("[GET /cloud-connect-cspm-aws/entities/user-scripts-download/v1][%d] getCSPMAwsAccountScriptsAttachmentInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCSPMAwsAccountScriptsAttachmentInternalServerError) String() string {
	return fmt.Sprintf("[GET /cloud-connect-cspm-aws/entities/user-scripts-download/v1][%d] getCSPMAwsAccountScriptsAttachmentInternalServerError  %+v", 500, o.Payload)
}

func (o *GetCSPMAwsAccountScriptsAttachmentInternalServerError) GetPayload() *models.RegistrationAWSProvisionGetAccountScriptResponseV2 {
	return o.Payload
}

func (o *GetCSPMAwsAccountScriptsAttachmentInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.RegistrationAWSProvisionGetAccountScriptResponseV2)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetCSPMAwsAccountScriptsAttachmentDefault creates a GetCSPMAwsAccountScriptsAttachmentDefault with default headers values
func NewGetCSPMAwsAccountScriptsAttachmentDefault(code int) *GetCSPMAwsAccountScriptsAttachmentDefault {
	return &GetCSPMAwsAccountScriptsAttachmentDefault{
		_statusCode: code,
	}
}

/*
GetCSPMAwsAccountScriptsAttachmentDefault describes a response with status code -1, with default header values.

OK
*/
type GetCSPMAwsAccountScriptsAttachmentDefault struct {
	_statusCode int

	Payload *models.RegistrationAWSProvisionGetAccountScriptResponseV2
}

// IsSuccess returns true when this get c s p m aws account scripts attachment default response has a 2xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get c s p m aws account scripts attachment default response has a 3xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get c s p m aws account scripts attachment default response has a 4xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get c s p m aws account scripts attachment default response has a 5xx status code
func (o *GetCSPMAwsAccountScriptsAttachmentDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get c s p m aws account scripts attachment default response a status code equal to that given
func (o *GetCSPMAwsAccountScriptsAttachmentDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get c s p m aws account scripts attachment default response
func (o *GetCSPMAwsAccountScriptsAttachmentDefault) Code() int {
	return o._statusCode
}

func (o *GetCSPMAwsAccountScriptsAttachmentDefault) Error() string {
	return fmt.Sprintf("[GET /cloud-connect-cspm-aws/entities/user-scripts-download/v1][%d] GetCSPMAwsAccountScriptsAttachment default  %+v", o._statusCode, o.Payload)
}

func (o *GetCSPMAwsAccountScriptsAttachmentDefault) String() string {
	return fmt.Sprintf("[GET /cloud-connect-cspm-aws/entities/user-scripts-download/v1][%d] GetCSPMAwsAccountScriptsAttachment default  %+v", o._statusCode, o.Payload)
}

func (o *GetCSPMAwsAccountScriptsAttachmentDefault) GetPayload() *models.RegistrationAWSProvisionGetAccountScriptResponseV2 {
	return o.Payload
}

func (o *GetCSPMAwsAccountScriptsAttachmentDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.RegistrationAWSProvisionGetAccountScriptResponseV2)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
