// Code generated by go-swagger; DO NOT EDIT.

package cspm_registration

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetCSPMScanScheduleParams creates a new GetCSPMScanScheduleParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetCSPMScanScheduleParams() *GetCSPMScanScheduleParams {
	return &GetCSPMScanScheduleParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetCSPMScanScheduleParamsWithTimeout creates a new GetCSPMScanScheduleParams object
// with the ability to set a timeout on a request.
func NewGetCSPMScanScheduleParamsWithTimeout(timeout time.Duration) *GetCSPMScanScheduleParams {
	return &GetCSPMScanScheduleParams{
		timeout: timeout,
	}
}

// NewGetCSPMScanScheduleParamsWithContext creates a new GetCSPMScanScheduleParams object
// with the ability to set a context for a request.
func NewGetCSPMScanScheduleParamsWithContext(ctx context.Context) *GetCSPMScanScheduleParams {
	return &GetCSPMScanScheduleParams{
		Context: ctx,
	}
}

// NewGetCSPMScanScheduleParamsWithHTTPClient creates a new GetCSPMScanScheduleParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetCSPMScanScheduleParamsWithHTTPClient(client *http.Client) *GetCSPMScanScheduleParams {
	return &GetCSPMScanScheduleParams{
		HTTPClient: client,
	}
}

/*
GetCSPMScanScheduleParams contains all the parameters to send to the API endpoint

	for the get c s p m scan schedule operation.

	Typically these are written to a http.Request.
*/
type GetCSPMScanScheduleParams struct {

	/* CloudPlatform.

	   Cloud Platform
	*/
	CloudPlatform []string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get c s p m scan schedule params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetCSPMScanScheduleParams) WithDefaults() *GetCSPMScanScheduleParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get c s p m scan schedule params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetCSPMScanScheduleParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get c s p m scan schedule params
func (o *GetCSPMScanScheduleParams) WithTimeout(timeout time.Duration) *GetCSPMScanScheduleParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get c s p m scan schedule params
func (o *GetCSPMScanScheduleParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get c s p m scan schedule params
func (o *GetCSPMScanScheduleParams) WithContext(ctx context.Context) *GetCSPMScanScheduleParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get c s p m scan schedule params
func (o *GetCSPMScanScheduleParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get c s p m scan schedule params
func (o *GetCSPMScanScheduleParams) WithHTTPClient(client *http.Client) *GetCSPMScanScheduleParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get c s p m scan schedule params
func (o *GetCSPMScanScheduleParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCloudPlatform adds the cloudPlatform to the get c s p m scan schedule params
func (o *GetCSPMScanScheduleParams) WithCloudPlatform(cloudPlatform []string) *GetCSPMScanScheduleParams {
	o.SetCloudPlatform(cloudPlatform)
	return o
}

// SetCloudPlatform adds the cloudPlatform to the get c s p m scan schedule params
func (o *GetCSPMScanScheduleParams) SetCloudPlatform(cloudPlatform []string) {
	o.CloudPlatform = cloudPlatform
}

// WriteToRequest writes these params to a swagger request
func (o *GetCSPMScanScheduleParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.CloudPlatform != nil {

		// binding items for cloud-platform
		joinedCloudPlatform := o.bindParamCloudPlatform(reg)

		// query array param cloud-platform
		if err := r.SetQueryParam("cloud-platform", joinedCloudPlatform...); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamGetCSPMScanSchedule binds the parameter cloud-platform
func (o *GetCSPMScanScheduleParams) bindParamCloudPlatform(formats strfmt.Registry) []string {
	cloudPlatformIR := o.CloudPlatform

	var cloudPlatformIC []string
	for _, cloudPlatformIIR := range cloudPlatformIR { // explode []string

		cloudPlatformIIV := cloudPlatformIIR // string as string
		cloudPlatformIC = append(cloudPlatformIC, cloudPlatformIIV)
	}

	// items.CollectionFormat: "multi"
	cloudPlatformIS := swag.JoinByFormat(cloudPlatformIC, "multi")

	return cloudPlatformIS
}
