// Code generated by go-swagger; DO NOT EDIT.

package cspm_registration

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetIOAUsersParams creates a new GetIOAUsersParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetIOAUsersParams() *GetIOAUsersParams {
	return &GetIOAUsersParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetIOAUsersParamsWithTimeout creates a new GetIOAUsersParams object
// with the ability to set a timeout on a request.
func NewGetIOAUsersParamsWithTimeout(timeout time.Duration) *GetIOAUsersParams {
	return &GetIOAUsersParams{
		timeout: timeout,
	}
}

// NewGetIOAUsersParamsWithContext creates a new GetIOAUsersParams object
// with the ability to set a context for a request.
func NewGetIOAUsersParamsWithContext(ctx context.Context) *GetIOAUsersParams {
	return &GetIOAUsersParams{
		Context: ctx,
	}
}

// NewGetIOAUsersParamsWithHTTPClient creates a new GetIOAUsersParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetIOAUsersParamsWithHTTPClient(client *http.Client) *GetIOAUsersParams {
	return &GetIOAUsersParams{
		HTTPClient: client,
	}
}

/*
GetIOAUsersParams contains all the parameters to send to the API endpoint

	for the get i o a users operation.

	Typically these are written to a http.Request.
*/
type GetIOAUsersParams struct {

	/* AccountID.

	   Cloud account ID (e.g.: AWS accountID, Azure subscriptionID)
	*/
	AccountID *string

	/* AwsAccountID.

	   AWS accountID
	*/
	AwsAccountID *string

	/* AzureSubscriptionID.

	   Azure subscription ID
	*/
	AzureSubscriptionID *string

	/* AzureTenantID.

	   Azure tenant ID
	*/
	AzureTenantID *string

	/* CloudProvider.

	   Cloud Provider (e.g.: aws|azure|gcp)
	*/
	CloudProvider string

	/* PolicyID.

	   Policy ID
	*/
	PolicyID string

	/* State.

	   state
	*/
	State *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get i o a users params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetIOAUsersParams) WithDefaults() *GetIOAUsersParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get i o a users params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetIOAUsersParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get i o a users params
func (o *GetIOAUsersParams) WithTimeout(timeout time.Duration) *GetIOAUsersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get i o a users params
func (o *GetIOAUsersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get i o a users params
func (o *GetIOAUsersParams) WithContext(ctx context.Context) *GetIOAUsersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get i o a users params
func (o *GetIOAUsersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get i o a users params
func (o *GetIOAUsersParams) WithHTTPClient(client *http.Client) *GetIOAUsersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get i o a users params
func (o *GetIOAUsersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithAccountID adds the accountID to the get i o a users params
func (o *GetIOAUsersParams) WithAccountID(accountID *string) *GetIOAUsersParams {
	o.SetAccountID(accountID)
	return o
}

// SetAccountID adds the accountId to the get i o a users params
func (o *GetIOAUsersParams) SetAccountID(accountID *string) {
	o.AccountID = accountID
}

// WithAwsAccountID adds the awsAccountID to the get i o a users params
func (o *GetIOAUsersParams) WithAwsAccountID(awsAccountID *string) *GetIOAUsersParams {
	o.SetAwsAccountID(awsAccountID)
	return o
}

// SetAwsAccountID adds the awsAccountId to the get i o a users params
func (o *GetIOAUsersParams) SetAwsAccountID(awsAccountID *string) {
	o.AwsAccountID = awsAccountID
}

// WithAzureSubscriptionID adds the azureSubscriptionID to the get i o a users params
func (o *GetIOAUsersParams) WithAzureSubscriptionID(azureSubscriptionID *string) *GetIOAUsersParams {
	o.SetAzureSubscriptionID(azureSubscriptionID)
	return o
}

// SetAzureSubscriptionID adds the azureSubscriptionId to the get i o a users params
func (o *GetIOAUsersParams) SetAzureSubscriptionID(azureSubscriptionID *string) {
	o.AzureSubscriptionID = azureSubscriptionID
}

// WithAzureTenantID adds the azureTenantID to the get i o a users params
func (o *GetIOAUsersParams) WithAzureTenantID(azureTenantID *string) *GetIOAUsersParams {
	o.SetAzureTenantID(azureTenantID)
	return o
}

// SetAzureTenantID adds the azureTenantId to the get i o a users params
func (o *GetIOAUsersParams) SetAzureTenantID(azureTenantID *string) {
	o.AzureTenantID = azureTenantID
}

// WithCloudProvider adds the cloudProvider to the get i o a users params
func (o *GetIOAUsersParams) WithCloudProvider(cloudProvider string) *GetIOAUsersParams {
	o.SetCloudProvider(cloudProvider)
	return o
}

// SetCloudProvider adds the cloudProvider to the get i o a users params
func (o *GetIOAUsersParams) SetCloudProvider(cloudProvider string) {
	o.CloudProvider = cloudProvider
}

// WithPolicyID adds the policyID to the get i o a users params
func (o *GetIOAUsersParams) WithPolicyID(policyID string) *GetIOAUsersParams {
	o.SetPolicyID(policyID)
	return o
}

// SetPolicyID adds the policyId to the get i o a users params
func (o *GetIOAUsersParams) SetPolicyID(policyID string) {
	o.PolicyID = policyID
}

// WithState adds the state to the get i o a users params
func (o *GetIOAUsersParams) WithState(state *string) *GetIOAUsersParams {
	o.SetState(state)
	return o
}

// SetState adds the state to the get i o a users params
func (o *GetIOAUsersParams) SetState(state *string) {
	o.State = state
}

// WriteToRequest writes these params to a swagger request
func (o *GetIOAUsersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.AccountID != nil {

		// query param account_id
		var qrAccountID string

		if o.AccountID != nil {
			qrAccountID = *o.AccountID
		}
		qAccountID := qrAccountID
		if qAccountID != "" {

			if err := r.SetQueryParam("account_id", qAccountID); err != nil {
				return err
			}
		}
	}

	if o.AwsAccountID != nil {

		// query param aws_account_id
		var qrAwsAccountID string

		if o.AwsAccountID != nil {
			qrAwsAccountID = *o.AwsAccountID
		}
		qAwsAccountID := qrAwsAccountID
		if qAwsAccountID != "" {

			if err := r.SetQueryParam("aws_account_id", qAwsAccountID); err != nil {
				return err
			}
		}
	}

	if o.AzureSubscriptionID != nil {

		// query param azure_subscription_id
		var qrAzureSubscriptionID string

		if o.AzureSubscriptionID != nil {
			qrAzureSubscriptionID = *o.AzureSubscriptionID
		}
		qAzureSubscriptionID := qrAzureSubscriptionID
		if qAzureSubscriptionID != "" {

			if err := r.SetQueryParam("azure_subscription_id", qAzureSubscriptionID); err != nil {
				return err
			}
		}
	}

	if o.AzureTenantID != nil {

		// query param azure_tenant_id
		var qrAzureTenantID string

		if o.AzureTenantID != nil {
			qrAzureTenantID = *o.AzureTenantID
		}
		qAzureTenantID := qrAzureTenantID
		if qAzureTenantID != "" {

			if err := r.SetQueryParam("azure_tenant_id", qAzureTenantID); err != nil {
				return err
			}
		}
	}

	// query param cloud_provider
	qrCloudProvider := o.CloudProvider
	qCloudProvider := qrCloudProvider
	if qCloudProvider != "" {

		if err := r.SetQueryParam("cloud_provider", qCloudProvider); err != nil {
			return err
		}
	}

	// query param policy_id
	qrPolicyID := o.PolicyID
	qPolicyID := qrPolicyID
	if qPolicyID != "" {

		if err := r.SetQueryParam("policy_id", qPolicyID); err != nil {
			return err
		}
	}

	if o.State != nil {

		// query param state
		var qrState string

		if o.State != nil {
			qrState = *o.State
		}
		qState := qrState
		if qState != "" {

			if err := r.SetQueryParam("state", qState); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
