// Code generated by go-swagger; DO NOT EDIT.

package custom_ioa

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// CreateRuleGroupMixin0Reader is a Reader for the CreateRuleGroupMixin0 structure.
type CreateRuleGroupMixin0Reader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateRuleGroupMixin0Reader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 201:
		result := NewCreateRuleGroupMixin0Created()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 403:
		result := NewCreateRuleGroupMixin0Forbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewCreateRuleGroupMixin0NotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 429:
		result := NewCreateRuleGroupMixin0TooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewCreateRuleGroupMixin0Created creates a CreateRuleGroupMixin0Created with default headers values
func NewCreateRuleGroupMixin0Created() *CreateRuleGroupMixin0Created {
	return &CreateRuleGroupMixin0Created{}
}

/*
CreateRuleGroupMixin0Created describes a response with status code 201, with default header values.

Created
*/
type CreateRuleGroupMixin0Created struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.APIRuleGroupsResponse
}

// IsSuccess returns true when this create rule group mixin0 created response has a 2xx status code
func (o *CreateRuleGroupMixin0Created) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this create rule group mixin0 created response has a 3xx status code
func (o *CreateRuleGroupMixin0Created) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create rule group mixin0 created response has a 4xx status code
func (o *CreateRuleGroupMixin0Created) IsClientError() bool {
	return false
}

// IsServerError returns true when this create rule group mixin0 created response has a 5xx status code
func (o *CreateRuleGroupMixin0Created) IsServerError() bool {
	return false
}

// IsCode returns true when this create rule group mixin0 created response a status code equal to that given
func (o *CreateRuleGroupMixin0Created) IsCode(code int) bool {
	return code == 201
}

// Code gets the status code for the create rule group mixin0 created response
func (o *CreateRuleGroupMixin0Created) Code() int {
	return 201
}

func (o *CreateRuleGroupMixin0Created) Error() string {
	return fmt.Sprintf("[POST /ioarules/entities/rule-groups/v1][%d] createRuleGroupMixin0Created  %+v", 201, o.Payload)
}

func (o *CreateRuleGroupMixin0Created) String() string {
	return fmt.Sprintf("[POST /ioarules/entities/rule-groups/v1][%d] createRuleGroupMixin0Created  %+v", 201, o.Payload)
}

func (o *CreateRuleGroupMixin0Created) GetPayload() *models.APIRuleGroupsResponse {
	return o.Payload
}

func (o *CreateRuleGroupMixin0Created) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.APIRuleGroupsResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateRuleGroupMixin0Forbidden creates a CreateRuleGroupMixin0Forbidden with default headers values
func NewCreateRuleGroupMixin0Forbidden() *CreateRuleGroupMixin0Forbidden {
	return &CreateRuleGroupMixin0Forbidden{}
}

/*
CreateRuleGroupMixin0Forbidden describes a response with status code 403, with default header values.

Forbidden
*/
type CreateRuleGroupMixin0Forbidden struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this create rule group mixin0 forbidden response has a 2xx status code
func (o *CreateRuleGroupMixin0Forbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create rule group mixin0 forbidden response has a 3xx status code
func (o *CreateRuleGroupMixin0Forbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create rule group mixin0 forbidden response has a 4xx status code
func (o *CreateRuleGroupMixin0Forbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this create rule group mixin0 forbidden response has a 5xx status code
func (o *CreateRuleGroupMixin0Forbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this create rule group mixin0 forbidden response a status code equal to that given
func (o *CreateRuleGroupMixin0Forbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the create rule group mixin0 forbidden response
func (o *CreateRuleGroupMixin0Forbidden) Code() int {
	return 403
}

func (o *CreateRuleGroupMixin0Forbidden) Error() string {
	return fmt.Sprintf("[POST /ioarules/entities/rule-groups/v1][%d] createRuleGroupMixin0Forbidden  %+v", 403, o.Payload)
}

func (o *CreateRuleGroupMixin0Forbidden) String() string {
	return fmt.Sprintf("[POST /ioarules/entities/rule-groups/v1][%d] createRuleGroupMixin0Forbidden  %+v", 403, o.Payload)
}

func (o *CreateRuleGroupMixin0Forbidden) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *CreateRuleGroupMixin0Forbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateRuleGroupMixin0NotFound creates a CreateRuleGroupMixin0NotFound with default headers values
func NewCreateRuleGroupMixin0NotFound() *CreateRuleGroupMixin0NotFound {
	return &CreateRuleGroupMixin0NotFound{}
}

/*
CreateRuleGroupMixin0NotFound describes a response with status code 404, with default header values.

Not Found
*/
type CreateRuleGroupMixin0NotFound struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this create rule group mixin0 not found response has a 2xx status code
func (o *CreateRuleGroupMixin0NotFound) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create rule group mixin0 not found response has a 3xx status code
func (o *CreateRuleGroupMixin0NotFound) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create rule group mixin0 not found response has a 4xx status code
func (o *CreateRuleGroupMixin0NotFound) IsClientError() bool {
	return true
}

// IsServerError returns true when this create rule group mixin0 not found response has a 5xx status code
func (o *CreateRuleGroupMixin0NotFound) IsServerError() bool {
	return false
}

// IsCode returns true when this create rule group mixin0 not found response a status code equal to that given
func (o *CreateRuleGroupMixin0NotFound) IsCode(code int) bool {
	return code == 404
}

// Code gets the status code for the create rule group mixin0 not found response
func (o *CreateRuleGroupMixin0NotFound) Code() int {
	return 404
}

func (o *CreateRuleGroupMixin0NotFound) Error() string {
	return fmt.Sprintf("[POST /ioarules/entities/rule-groups/v1][%d] createRuleGroupMixin0NotFound  %+v", 404, o.Payload)
}

func (o *CreateRuleGroupMixin0NotFound) String() string {
	return fmt.Sprintf("[POST /ioarules/entities/rule-groups/v1][%d] createRuleGroupMixin0NotFound  %+v", 404, o.Payload)
}

func (o *CreateRuleGroupMixin0NotFound) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *CreateRuleGroupMixin0NotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateRuleGroupMixin0TooManyRequests creates a CreateRuleGroupMixin0TooManyRequests with default headers values
func NewCreateRuleGroupMixin0TooManyRequests() *CreateRuleGroupMixin0TooManyRequests {
	return &CreateRuleGroupMixin0TooManyRequests{}
}

/*
CreateRuleGroupMixin0TooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type CreateRuleGroupMixin0TooManyRequests struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	/* Too many requests, retry after this time (as milliseconds since epoch)
	 */
	XRateLimitRetryAfter int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this create rule group mixin0 too many requests response has a 2xx status code
func (o *CreateRuleGroupMixin0TooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create rule group mixin0 too many requests response has a 3xx status code
func (o *CreateRuleGroupMixin0TooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create rule group mixin0 too many requests response has a 4xx status code
func (o *CreateRuleGroupMixin0TooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this create rule group mixin0 too many requests response has a 5xx status code
func (o *CreateRuleGroupMixin0TooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this create rule group mixin0 too many requests response a status code equal to that given
func (o *CreateRuleGroupMixin0TooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the create rule group mixin0 too many requests response
func (o *CreateRuleGroupMixin0TooManyRequests) Code() int {
	return 429
}

func (o *CreateRuleGroupMixin0TooManyRequests) Error() string {
	return fmt.Sprintf("[POST /ioarules/entities/rule-groups/v1][%d] createRuleGroupMixin0TooManyRequests  %+v", 429, o.Payload)
}

func (o *CreateRuleGroupMixin0TooManyRequests) String() string {
	return fmt.Sprintf("[POST /ioarules/entities/rule-groups/v1][%d] createRuleGroupMixin0TooManyRequests  %+v", 429, o.Payload)
}

func (o *CreateRuleGroupMixin0TooManyRequests) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *CreateRuleGroupMixin0TooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header X-RateLimit-RetryAfter
	hdrXRateLimitRetryAfter := response.GetHeader("X-RateLimit-RetryAfter")

	if hdrXRateLimitRetryAfter != "" {
		valxRateLimitRetryAfter, err := swag.ConvertInt64(hdrXRateLimitRetryAfter)
		if err != nil {
			return errors.InvalidType("X-RateLimit-RetryAfter", "header", "int64", hdrXRateLimitRetryAfter)
		}
		o.XRateLimitRetryAfter = valxRateLimitRetryAfter
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
