// Code generated by go-swagger; DO NOT EDIT.

package custom_ioa

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewGetRulesGetParams creates a new GetRulesGetParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetRulesGetParams() *GetRulesGetParams {
	return &GetRulesGetParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetRulesGetParamsWithTimeout creates a new GetRulesGetParams object
// with the ability to set a timeout on a request.
func NewGetRulesGetParamsWithTimeout(timeout time.Duration) *GetRulesGetParams {
	return &GetRulesGetParams{
		timeout: timeout,
	}
}

// NewGetRulesGetParamsWithContext creates a new GetRulesGetParams object
// with the ability to set a context for a request.
func NewGetRulesGetParamsWithContext(ctx context.Context) *GetRulesGetParams {
	return &GetRulesGetParams{
		Context: ctx,
	}
}

// NewGetRulesGetParamsWithHTTPClient creates a new GetRulesGetParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetRulesGetParamsWithHTTPClient(client *http.Client) *GetRulesGetParams {
	return &GetRulesGetParams{
		HTTPClient: client,
	}
}

/*
GetRulesGetParams contains all the parameters to send to the API endpoint

	for the get rules get operation.

	Typically these are written to a http.Request.
*/
type GetRulesGetParams struct {

	/* Body.

	   The "ids" field contains a list of the rules to retrieve.
	*/
	Body *models.APIRulesGetRequestV1

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get rules get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetRulesGetParams) WithDefaults() *GetRulesGetParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get rules get params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetRulesGetParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get rules get params
func (o *GetRulesGetParams) WithTimeout(timeout time.Duration) *GetRulesGetParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get rules get params
func (o *GetRulesGetParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get rules get params
func (o *GetRulesGetParams) WithContext(ctx context.Context) *GetRulesGetParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get rules get params
func (o *GetRulesGetParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get rules get params
func (o *GetRulesGetParams) WithHTTPClient(client *http.Client) *GetRulesGetParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get rules get params
func (o *GetRulesGetParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the get rules get params
func (o *GetRulesGetParams) WithBody(body *models.APIRulesGetRequestV1) *GetRulesGetParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the get rules get params
func (o *GetRulesGetParams) SetBody(body *models.APIRulesGetRequestV1) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *GetRulesGetParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
