// Code generated by go-swagger; DO NOT EDIT.

package custom_ioa

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewQueryRuleGroupsFullParams creates a new QueryRuleGroupsFullParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewQueryRuleGroupsFullParams() *QueryRuleGroupsFullParams {
	return &QueryRuleGroupsFullParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewQueryRuleGroupsFullParamsWithTimeout creates a new QueryRuleGroupsFullParams object
// with the ability to set a timeout on a request.
func NewQueryRuleGroupsFullParamsWithTimeout(timeout time.Duration) *QueryRuleGroupsFullParams {
	return &QueryRuleGroupsFullParams{
		timeout: timeout,
	}
}

// NewQueryRuleGroupsFullParamsWithContext creates a new QueryRuleGroupsFullParams object
// with the ability to set a context for a request.
func NewQueryRuleGroupsFullParamsWithContext(ctx context.Context) *QueryRuleGroupsFullParams {
	return &QueryRuleGroupsFullParams{
		Context: ctx,
	}
}

// NewQueryRuleGroupsFullParamsWithHTTPClient creates a new QueryRuleGroupsFullParams object
// with the ability to set a custom HTTPClient for a request.
func NewQueryRuleGroupsFullParamsWithHTTPClient(client *http.Client) *QueryRuleGroupsFullParams {
	return &QueryRuleGroupsFullParams{
		HTTPClient: client,
	}
}

/*
QueryRuleGroupsFullParams contains all the parameters to send to the API endpoint

	for the query rule groups full operation.

	Typically these are written to a http.Request.
*/
type QueryRuleGroupsFullParams struct {

	/* Filter.

	   FQL query specifying the filter parameters. Filter term criteria: [enabled platform name description rules.action_label rules.name rules.description rules.pattern_severity rules.ruletype_name rules.enabled]. Filter range criteria: created_on, modified_on; use any common date format, such as '2010-05-15T14:55:21.892315096Z'.
	*/
	Filter *string

	/* Limit.

	   Number of IDs to return
	*/
	Limit *int64

	/* Offset.

	   Starting index of overall result set from which to return IDs
	*/
	Offset *string

	/* Q.

	   Match query criteria, which includes all the filter string fields
	*/
	Q *string

	/* Sort.

	   Possible order by fields: {modified_on, enabled, name, created_by, created_on, modified_by}
	*/
	Sort *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the query rule groups full params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *QueryRuleGroupsFullParams) WithDefaults() *QueryRuleGroupsFullParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the query rule groups full params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *QueryRuleGroupsFullParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the query rule groups full params
func (o *QueryRuleGroupsFullParams) WithTimeout(timeout time.Duration) *QueryRuleGroupsFullParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the query rule groups full params
func (o *QueryRuleGroupsFullParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the query rule groups full params
func (o *QueryRuleGroupsFullParams) WithContext(ctx context.Context) *QueryRuleGroupsFullParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the query rule groups full params
func (o *QueryRuleGroupsFullParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the query rule groups full params
func (o *QueryRuleGroupsFullParams) WithHTTPClient(client *http.Client) *QueryRuleGroupsFullParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the query rule groups full params
func (o *QueryRuleGroupsFullParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFilter adds the filter to the query rule groups full params
func (o *QueryRuleGroupsFullParams) WithFilter(filter *string) *QueryRuleGroupsFullParams {
	o.SetFilter(filter)
	return o
}

// SetFilter adds the filter to the query rule groups full params
func (o *QueryRuleGroupsFullParams) SetFilter(filter *string) {
	o.Filter = filter
}

// WithLimit adds the limit to the query rule groups full params
func (o *QueryRuleGroupsFullParams) WithLimit(limit *int64) *QueryRuleGroupsFullParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the query rule groups full params
func (o *QueryRuleGroupsFullParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithOffset adds the offset to the query rule groups full params
func (o *QueryRuleGroupsFullParams) WithOffset(offset *string) *QueryRuleGroupsFullParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the query rule groups full params
func (o *QueryRuleGroupsFullParams) SetOffset(offset *string) {
	o.Offset = offset
}

// WithQ adds the q to the query rule groups full params
func (o *QueryRuleGroupsFullParams) WithQ(q *string) *QueryRuleGroupsFullParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the query rule groups full params
func (o *QueryRuleGroupsFullParams) SetQ(q *string) {
	o.Q = q
}

// WithSort adds the sort to the query rule groups full params
func (o *QueryRuleGroupsFullParams) WithSort(sort *string) *QueryRuleGroupsFullParams {
	o.SetSort(sort)
	return o
}

// SetSort adds the sort to the query rule groups full params
func (o *QueryRuleGroupsFullParams) SetSort(sort *string) {
	o.Sort = sort
}

// WriteToRequest writes these params to a swagger request
func (o *QueryRuleGroupsFullParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Filter != nil {

		// query param filter
		var qrFilter string

		if o.Filter != nil {
			qrFilter = *o.Filter
		}
		qFilter := qrFilter
		if qFilter != "" {

			if err := r.SetQueryParam("filter", qFilter); err != nil {
				return err
			}
		}
	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64

		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {

			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}
	}

	if o.Offset != nil {

		// query param offset
		var qrOffset string

		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := qrOffset
		if qOffset != "" {

			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}
	}

	if o.Q != nil {

		// query param q
		var qrQ string

		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {

			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}
	}

	if o.Sort != nil {

		// query param sort
		var qrSort string

		if o.Sort != nil {
			qrSort = *o.Sort
		}
		qSort := qrSort
		if qSort != "" {

			if err := r.SetQueryParam("sort", qSort); err != nil {
				return err
			}
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
