// Code generated by go-swagger; DO NOT EDIT.

package custom_ioa

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// QueryRuleTypesReader is a Reader for the QueryRuleTypes structure.
type QueryRuleTypesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *QueryRuleTypesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewQueryRuleTypesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 403:
		result := NewQueryRuleTypesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 429:
		result := NewQueryRuleTypesTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewQueryRuleTypesDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewQueryRuleTypesOK creates a QueryRuleTypesOK with default headers values
func NewQueryRuleTypesOK() *QueryRuleTypesOK {
	return &QueryRuleTypesOK{}
}

/*
QueryRuleTypesOK describes a response with status code 200, with default header values.

OK
*/
type QueryRuleTypesOK struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaQueryResponse
}

// IsSuccess returns true when this query rule types o k response has a 2xx status code
func (o *QueryRuleTypesOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this query rule types o k response has a 3xx status code
func (o *QueryRuleTypesOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query rule types o k response has a 4xx status code
func (o *QueryRuleTypesOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this query rule types o k response has a 5xx status code
func (o *QueryRuleTypesOK) IsServerError() bool {
	return false
}

// IsCode returns true when this query rule types o k response a status code equal to that given
func (o *QueryRuleTypesOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the query rule types o k response
func (o *QueryRuleTypesOK) Code() int {
	return 200
}

func (o *QueryRuleTypesOK) Error() string {
	return fmt.Sprintf("[GET /ioarules/queries/rule-types/v1][%d] queryRuleTypesOK  %+v", 200, o.Payload)
}

func (o *QueryRuleTypesOK) String() string {
	return fmt.Sprintf("[GET /ioarules/queries/rule-types/v1][%d] queryRuleTypesOK  %+v", 200, o.Payload)
}

func (o *QueryRuleTypesOK) GetPayload() *models.MsaQueryResponse {
	return o.Payload
}

func (o *QueryRuleTypesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaQueryResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQueryRuleTypesForbidden creates a QueryRuleTypesForbidden with default headers values
func NewQueryRuleTypesForbidden() *QueryRuleTypesForbidden {
	return &QueryRuleTypesForbidden{}
}

/*
QueryRuleTypesForbidden describes a response with status code 403, with default header values.

Forbidden
*/
type QueryRuleTypesForbidden struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this query rule types forbidden response has a 2xx status code
func (o *QueryRuleTypesForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this query rule types forbidden response has a 3xx status code
func (o *QueryRuleTypesForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query rule types forbidden response has a 4xx status code
func (o *QueryRuleTypesForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this query rule types forbidden response has a 5xx status code
func (o *QueryRuleTypesForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this query rule types forbidden response a status code equal to that given
func (o *QueryRuleTypesForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the query rule types forbidden response
func (o *QueryRuleTypesForbidden) Code() int {
	return 403
}

func (o *QueryRuleTypesForbidden) Error() string {
	return fmt.Sprintf("[GET /ioarules/queries/rule-types/v1][%d] queryRuleTypesForbidden  %+v", 403, o.Payload)
}

func (o *QueryRuleTypesForbidden) String() string {
	return fmt.Sprintf("[GET /ioarules/queries/rule-types/v1][%d] queryRuleTypesForbidden  %+v", 403, o.Payload)
}

func (o *QueryRuleTypesForbidden) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *QueryRuleTypesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQueryRuleTypesTooManyRequests creates a QueryRuleTypesTooManyRequests with default headers values
func NewQueryRuleTypesTooManyRequests() *QueryRuleTypesTooManyRequests {
	return &QueryRuleTypesTooManyRequests{}
}

/*
QueryRuleTypesTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type QueryRuleTypesTooManyRequests struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	/* Too many requests, retry after this time (as milliseconds since epoch)
	 */
	XRateLimitRetryAfter int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this query rule types too many requests response has a 2xx status code
func (o *QueryRuleTypesTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this query rule types too many requests response has a 3xx status code
func (o *QueryRuleTypesTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query rule types too many requests response has a 4xx status code
func (o *QueryRuleTypesTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this query rule types too many requests response has a 5xx status code
func (o *QueryRuleTypesTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this query rule types too many requests response a status code equal to that given
func (o *QueryRuleTypesTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the query rule types too many requests response
func (o *QueryRuleTypesTooManyRequests) Code() int {
	return 429
}

func (o *QueryRuleTypesTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /ioarules/queries/rule-types/v1][%d] queryRuleTypesTooManyRequests  %+v", 429, o.Payload)
}

func (o *QueryRuleTypesTooManyRequests) String() string {
	return fmt.Sprintf("[GET /ioarules/queries/rule-types/v1][%d] queryRuleTypesTooManyRequests  %+v", 429, o.Payload)
}

func (o *QueryRuleTypesTooManyRequests) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *QueryRuleTypesTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header X-RateLimit-RetryAfter
	hdrXRateLimitRetryAfter := response.GetHeader("X-RateLimit-RetryAfter")

	if hdrXRateLimitRetryAfter != "" {
		valxRateLimitRetryAfter, err := swag.ConvertInt64(hdrXRateLimitRetryAfter)
		if err != nil {
			return errors.InvalidType("X-RateLimit-RetryAfter", "header", "int64", hdrXRateLimitRetryAfter)
		}
		o.XRateLimitRetryAfter = valxRateLimitRetryAfter
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQueryRuleTypesDefault creates a QueryRuleTypesDefault with default headers values
func NewQueryRuleTypesDefault(code int) *QueryRuleTypesDefault {
	return &QueryRuleTypesDefault{
		_statusCode: code,
	}
}

/*
QueryRuleTypesDefault describes a response with status code -1, with default header values.

OK
*/
type QueryRuleTypesDefault struct {
	_statusCode int

	Payload *models.MsaQueryResponse
}

// IsSuccess returns true when this query rule types default response has a 2xx status code
func (o *QueryRuleTypesDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this query rule types default response has a 3xx status code
func (o *QueryRuleTypesDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this query rule types default response has a 4xx status code
func (o *QueryRuleTypesDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this query rule types default response has a 5xx status code
func (o *QueryRuleTypesDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this query rule types default response a status code equal to that given
func (o *QueryRuleTypesDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the query rule types default response
func (o *QueryRuleTypesDefault) Code() int {
	return o._statusCode
}

func (o *QueryRuleTypesDefault) Error() string {
	return fmt.Sprintf("[GET /ioarules/queries/rule-types/v1][%d] query-rule-types default  %+v", o._statusCode, o.Payload)
}

func (o *QueryRuleTypesDefault) String() string {
	return fmt.Sprintf("[GET /ioarules/queries/rule-types/v1][%d] query-rule-types default  %+v", o._statusCode, o.Payload)
}

func (o *QueryRuleTypesDefault) GetPayload() *models.MsaQueryResponse {
	return o.Payload
}

func (o *QueryRuleTypesDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.MsaQueryResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
