// Code generated by go-swagger; DO NOT EDIT.

package device_control_policies

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewUpdateDeviceControlPoliciesParams creates a new UpdateDeviceControlPoliciesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateDeviceControlPoliciesParams() *UpdateDeviceControlPoliciesParams {
	return &UpdateDeviceControlPoliciesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateDeviceControlPoliciesParamsWithTimeout creates a new UpdateDeviceControlPoliciesParams object
// with the ability to set a timeout on a request.
func NewUpdateDeviceControlPoliciesParamsWithTimeout(timeout time.Duration) *UpdateDeviceControlPoliciesParams {
	return &UpdateDeviceControlPoliciesParams{
		timeout: timeout,
	}
}

// NewUpdateDeviceControlPoliciesParamsWithContext creates a new UpdateDeviceControlPoliciesParams object
// with the ability to set a context for a request.
func NewUpdateDeviceControlPoliciesParamsWithContext(ctx context.Context) *UpdateDeviceControlPoliciesParams {
	return &UpdateDeviceControlPoliciesParams{
		Context: ctx,
	}
}

// NewUpdateDeviceControlPoliciesParamsWithHTTPClient creates a new UpdateDeviceControlPoliciesParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateDeviceControlPoliciesParamsWithHTTPClient(client *http.Client) *UpdateDeviceControlPoliciesParams {
	return &UpdateDeviceControlPoliciesParams{
		HTTPClient: client,
	}
}

/*
UpdateDeviceControlPoliciesParams contains all the parameters to send to the API endpoint

	for the update device control policies operation.

	Typically these are written to a http.Request.
*/
type UpdateDeviceControlPoliciesParams struct {

	// Body.
	Body *models.RequestsUpdateDeviceControlPoliciesV1

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update device control policies params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateDeviceControlPoliciesParams) WithDefaults() *UpdateDeviceControlPoliciesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update device control policies params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateDeviceControlPoliciesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update device control policies params
func (o *UpdateDeviceControlPoliciesParams) WithTimeout(timeout time.Duration) *UpdateDeviceControlPoliciesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update device control policies params
func (o *UpdateDeviceControlPoliciesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update device control policies params
func (o *UpdateDeviceControlPoliciesParams) WithContext(ctx context.Context) *UpdateDeviceControlPoliciesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update device control policies params
func (o *UpdateDeviceControlPoliciesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update device control policies params
func (o *UpdateDeviceControlPoliciesParams) WithHTTPClient(client *http.Client) *UpdateDeviceControlPoliciesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update device control policies params
func (o *UpdateDeviceControlPoliciesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the update device control policies params
func (o *UpdateDeviceControlPoliciesParams) WithBody(body *models.RequestsUpdateDeviceControlPoliciesV1) *UpdateDeviceControlPoliciesParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update device control policies params
func (o *UpdateDeviceControlPoliciesParams) SetBody(body *models.RequestsUpdateDeviceControlPoliciesV1) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateDeviceControlPoliciesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
