// Code generated by go-swagger; DO NOT EDIT.

package falcon_complete_dashboard

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewAggregateEscalationsParams creates a new AggregateEscalationsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAggregateEscalationsParams() *AggregateEscalationsParams {
	return &AggregateEscalationsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAggregateEscalationsParamsWithTimeout creates a new AggregateEscalationsParams object
// with the ability to set a timeout on a request.
func NewAggregateEscalationsParamsWithTimeout(timeout time.Duration) *AggregateEscalationsParams {
	return &AggregateEscalationsParams{
		timeout: timeout,
	}
}

// NewAggregateEscalationsParamsWithContext creates a new AggregateEscalationsParams object
// with the ability to set a context for a request.
func NewAggregateEscalationsParamsWithContext(ctx context.Context) *AggregateEscalationsParams {
	return &AggregateEscalationsParams{
		Context: ctx,
	}
}

// NewAggregateEscalationsParamsWithHTTPClient creates a new AggregateEscalationsParams object
// with the ability to set a custom HTTPClient for a request.
func NewAggregateEscalationsParamsWithHTTPClient(client *http.Client) *AggregateEscalationsParams {
	return &AggregateEscalationsParams{
		HTTPClient: client,
	}
}

/*
AggregateEscalationsParams contains all the parameters to send to the API endpoint

	for the aggregate escalations operation.

	Typically these are written to a http.Request.
*/
type AggregateEscalationsParams struct {

	// Body.
	Body []*models.MsaAggregateQueryRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the aggregate escalations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AggregateEscalationsParams) WithDefaults() *AggregateEscalationsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the aggregate escalations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AggregateEscalationsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the aggregate escalations params
func (o *AggregateEscalationsParams) WithTimeout(timeout time.Duration) *AggregateEscalationsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the aggregate escalations params
func (o *AggregateEscalationsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the aggregate escalations params
func (o *AggregateEscalationsParams) WithContext(ctx context.Context) *AggregateEscalationsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the aggregate escalations params
func (o *AggregateEscalationsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the aggregate escalations params
func (o *AggregateEscalationsParams) WithHTTPClient(client *http.Client) *AggregateEscalationsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the aggregate escalations params
func (o *AggregateEscalationsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the aggregate escalations params
func (o *AggregateEscalationsParams) WithBody(body []*models.MsaAggregateQueryRequest) *AggregateEscalationsParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the aggregate escalations params
func (o *AggregateEscalationsParams) SetBody(body []*models.MsaAggregateQueryRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AggregateEscalationsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
