// Code generated by go-swagger; DO NOT EDIT.

package falcon_container_cli

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
)

// New creates a new falcon container cli API client.
func New(transport runtime.ClientTransport, formats strfmt.Registry) ClientService {
	return &Client{transport: transport, formats: formats}
}

/*
Client for falcon container cli API
*/
type Client struct {
	transport runtime.ClientTransport
	formats   strfmt.Registry
}

// ClientOption is the option for Client methods
type ClientOption func(*runtime.ClientOperation)

// ClientService is the interface for Client methods
type ClientService interface {
	ReadImageVulnerabilities(params *ReadImageVulnerabilitiesParams, opts ...ClientOption) (*ReadImageVulnerabilitiesOK, error)

	SetTransport(transport runtime.ClientTransport)
}

/*
ReadImageVulnerabilities retrieves known vulnerabilities for the provided image
*/
func (a *Client) ReadImageVulnerabilities(params *ReadImageVulnerabilitiesParams, opts ...ClientOption) (*ReadImageVulnerabilitiesOK, error) {
	// TODO: Validate the params before sending
	if params == nil {
		params = NewReadImageVulnerabilitiesParams()
	}
	op := &runtime.ClientOperation{
		ID:                 "ReadImageVulnerabilities",
		Method:             "POST",
		PathPattern:        "/image-assessment/combined/vulnerability-lookups/v1",
		ProducesMediaTypes: []string{"application/json"},
		ConsumesMediaTypes: []string{"application/json"},
		Schemes:            []string{"https"},
		Params:             params,
		Reader:             &ReadImageVulnerabilitiesReader{formats: a.formats},
		Context:            params.Context,
		Client:             params.HTTPClient,
	}
	for _, opt := range opts {
		opt(op)
	}

	result, err := a.transport.Submit(op)
	if err != nil {
		return nil, err
	}
	success, ok := result.(*ReadImageVulnerabilitiesOK)
	if ok {
		return success, nil
	}
	// unexpected success response
	// safeguard: normally, absent a default response, unknown success responses return an error above: so this is a codegen issue
	msg := fmt.Sprintf("unexpected success response for ReadImageVulnerabilities: API contract not enforced by server. Client expected to get an error, but got: %T", result)
	panic(msg)
}

// SetTransport changes the transport on the client
func (a *Client) SetTransport(transport runtime.ClientTransport) {
	a.transport = transport
}
