// Code generated by go-swagger; DO NOT EDIT.

package firewall_management

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewAggregateRuleGroupsParams creates a new AggregateRuleGroupsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAggregateRuleGroupsParams() *AggregateRuleGroupsParams {
	return &AggregateRuleGroupsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAggregateRuleGroupsParamsWithTimeout creates a new AggregateRuleGroupsParams object
// with the ability to set a timeout on a request.
func NewAggregateRuleGroupsParamsWithTimeout(timeout time.Duration) *AggregateRuleGroupsParams {
	return &AggregateRuleGroupsParams{
		timeout: timeout,
	}
}

// NewAggregateRuleGroupsParamsWithContext creates a new AggregateRuleGroupsParams object
// with the ability to set a context for a request.
func NewAggregateRuleGroupsParamsWithContext(ctx context.Context) *AggregateRuleGroupsParams {
	return &AggregateRuleGroupsParams{
		Context: ctx,
	}
}

// NewAggregateRuleGroupsParamsWithHTTPClient creates a new AggregateRuleGroupsParams object
// with the ability to set a custom HTTPClient for a request.
func NewAggregateRuleGroupsParamsWithHTTPClient(client *http.Client) *AggregateRuleGroupsParams {
	return &AggregateRuleGroupsParams{
		HTTPClient: client,
	}
}

/*
AggregateRuleGroupsParams contains all the parameters to send to the API endpoint

	for the aggregate rule groups operation.

	Typically these are written to a http.Request.
*/
type AggregateRuleGroupsParams struct {

	/* Body.

	   Query criteria and settings
	*/
	Body []*models.FwmgrMsaAggregateQueryRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the aggregate rule groups params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AggregateRuleGroupsParams) WithDefaults() *AggregateRuleGroupsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the aggregate rule groups params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AggregateRuleGroupsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the aggregate rule groups params
func (o *AggregateRuleGroupsParams) WithTimeout(timeout time.Duration) *AggregateRuleGroupsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the aggregate rule groups params
func (o *AggregateRuleGroupsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the aggregate rule groups params
func (o *AggregateRuleGroupsParams) WithContext(ctx context.Context) *AggregateRuleGroupsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the aggregate rule groups params
func (o *AggregateRuleGroupsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the aggregate rule groups params
func (o *AggregateRuleGroupsParams) WithHTTPClient(client *http.Client) *AggregateRuleGroupsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the aggregate rule groups params
func (o *AggregateRuleGroupsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the aggregate rule groups params
func (o *AggregateRuleGroupsParams) WithBody(body []*models.FwmgrMsaAggregateQueryRequest) *AggregateRuleGroupsParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the aggregate rule groups params
func (o *AggregateRuleGroupsParams) SetBody(body []*models.FwmgrMsaAggregateQueryRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AggregateRuleGroupsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
