// Code generated by go-swagger; DO NOT EDIT.

package firewall_management

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetFirewallFieldsParams creates a new GetFirewallFieldsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetFirewallFieldsParams() *GetFirewallFieldsParams {
	return &GetFirewallFieldsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetFirewallFieldsParamsWithTimeout creates a new GetFirewallFieldsParams object
// with the ability to set a timeout on a request.
func NewGetFirewallFieldsParamsWithTimeout(timeout time.Duration) *GetFirewallFieldsParams {
	return &GetFirewallFieldsParams{
		timeout: timeout,
	}
}

// NewGetFirewallFieldsParamsWithContext creates a new GetFirewallFieldsParams object
// with the ability to set a context for a request.
func NewGetFirewallFieldsParamsWithContext(ctx context.Context) *GetFirewallFieldsParams {
	return &GetFirewallFieldsParams{
		Context: ctx,
	}
}

// NewGetFirewallFieldsParamsWithHTTPClient creates a new GetFirewallFieldsParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetFirewallFieldsParamsWithHTTPClient(client *http.Client) *GetFirewallFieldsParams {
	return &GetFirewallFieldsParams{
		HTTPClient: client,
	}
}

/*
GetFirewallFieldsParams contains all the parameters to send to the API endpoint

	for the get firewall fields operation.

	Typically these are written to a http.Request.
*/
type GetFirewallFieldsParams struct {

	/* Ids.

	   The IDs of the rule types to retrieve
	*/
	Ids []string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get firewall fields params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetFirewallFieldsParams) WithDefaults() *GetFirewallFieldsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get firewall fields params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetFirewallFieldsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get firewall fields params
func (o *GetFirewallFieldsParams) WithTimeout(timeout time.Duration) *GetFirewallFieldsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get firewall fields params
func (o *GetFirewallFieldsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get firewall fields params
func (o *GetFirewallFieldsParams) WithContext(ctx context.Context) *GetFirewallFieldsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get firewall fields params
func (o *GetFirewallFieldsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get firewall fields params
func (o *GetFirewallFieldsParams) WithHTTPClient(client *http.Client) *GetFirewallFieldsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get firewall fields params
func (o *GetFirewallFieldsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIds adds the ids to the get firewall fields params
func (o *GetFirewallFieldsParams) WithIds(ids []string) *GetFirewallFieldsParams {
	o.SetIds(ids)
	return o
}

// SetIds adds the ids to the get firewall fields params
func (o *GetFirewallFieldsParams) SetIds(ids []string) {
	o.Ids = ids
}

// WriteToRequest writes these params to a swagger request
func (o *GetFirewallFieldsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Ids != nil {

		// binding items for ids
		joinedIds := o.bindParamIds(reg)

		// query array param ids
		if err := r.SetQueryParam("ids", joinedIds...); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamGetFirewallFields binds the parameter ids
func (o *GetFirewallFieldsParams) bindParamIds(formats strfmt.Registry) []string {
	idsIR := o.Ids

	var idsIC []string
	for _, idsIIR := range idsIR { // explode []string

		idsIIV := idsIIR // string as string
		idsIC = append(idsIC, idsIIV)
	}

	// items.CollectionFormat: "multi"
	idsIS := swag.JoinByFormat(idsIC, "multi")

	return idsIS
}
