// Code generated by go-swagger; DO NOT EDIT.

package firewall_management

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetNetworkLocationsParams creates a new GetNetworkLocationsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetNetworkLocationsParams() *GetNetworkLocationsParams {
	return &GetNetworkLocationsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetNetworkLocationsParamsWithTimeout creates a new GetNetworkLocationsParams object
// with the ability to set a timeout on a request.
func NewGetNetworkLocationsParamsWithTimeout(timeout time.Duration) *GetNetworkLocationsParams {
	return &GetNetworkLocationsParams{
		timeout: timeout,
	}
}

// NewGetNetworkLocationsParamsWithContext creates a new GetNetworkLocationsParams object
// with the ability to set a context for a request.
func NewGetNetworkLocationsParamsWithContext(ctx context.Context) *GetNetworkLocationsParams {
	return &GetNetworkLocationsParams{
		Context: ctx,
	}
}

// NewGetNetworkLocationsParamsWithHTTPClient creates a new GetNetworkLocationsParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetNetworkLocationsParamsWithHTTPClient(client *http.Client) *GetNetworkLocationsParams {
	return &GetNetworkLocationsParams{
		HTTPClient: client,
	}
}

/*
GetNetworkLocationsParams contains all the parameters to send to the API endpoint

	for the get network locations operation.

	Typically these are written to a http.Request.
*/
type GetNetworkLocationsParams struct {

	/* Ids.

	   The events to retrieve, identified by ID
	*/
	Ids []string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get network locations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetNetworkLocationsParams) WithDefaults() *GetNetworkLocationsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get network locations params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetNetworkLocationsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get network locations params
func (o *GetNetworkLocationsParams) WithTimeout(timeout time.Duration) *GetNetworkLocationsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get network locations params
func (o *GetNetworkLocationsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get network locations params
func (o *GetNetworkLocationsParams) WithContext(ctx context.Context) *GetNetworkLocationsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get network locations params
func (o *GetNetworkLocationsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get network locations params
func (o *GetNetworkLocationsParams) WithHTTPClient(client *http.Client) *GetNetworkLocationsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get network locations params
func (o *GetNetworkLocationsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIds adds the ids to the get network locations params
func (o *GetNetworkLocationsParams) WithIds(ids []string) *GetNetworkLocationsParams {
	o.SetIds(ids)
	return o
}

// SetIds adds the ids to the get network locations params
func (o *GetNetworkLocationsParams) SetIds(ids []string) {
	o.Ids = ids
}

// WriteToRequest writes these params to a swagger request
func (o *GetNetworkLocationsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Ids != nil {

		// binding items for ids
		joinedIds := o.bindParamIds(reg)

		// query array param ids
		if err := r.SetQueryParam("ids", joinedIds...); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamGetNetworkLocations binds the parameter ids
func (o *GetNetworkLocationsParams) bindParamIds(formats strfmt.Registry) []string {
	idsIR := o.Ids

	var idsIC []string
	for _, idsIIR := range idsIR { // explode []string

		idsIIV := idsIIR // string as string
		idsIC = append(idsIC, idsIIV)
	}

	// items.CollectionFormat: "multi"
	idsIS := swag.JoinByFormat(idsIC, "multi")

	return idsIS
}
