// Code generated by go-swagger; DO NOT EDIT.

package firewall_management

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewValidateFilepathPatternParams creates a new ValidateFilepathPatternParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewValidateFilepathPatternParams() *ValidateFilepathPatternParams {
	return &ValidateFilepathPatternParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewValidateFilepathPatternParamsWithTimeout creates a new ValidateFilepathPatternParams object
// with the ability to set a timeout on a request.
func NewValidateFilepathPatternParamsWithTimeout(timeout time.Duration) *ValidateFilepathPatternParams {
	return &ValidateFilepathPatternParams{
		timeout: timeout,
	}
}

// NewValidateFilepathPatternParamsWithContext creates a new ValidateFilepathPatternParams object
// with the ability to set a context for a request.
func NewValidateFilepathPatternParamsWithContext(ctx context.Context) *ValidateFilepathPatternParams {
	return &ValidateFilepathPatternParams{
		Context: ctx,
	}
}

// NewValidateFilepathPatternParamsWithHTTPClient creates a new ValidateFilepathPatternParams object
// with the ability to set a custom HTTPClient for a request.
func NewValidateFilepathPatternParamsWithHTTPClient(client *http.Client) *ValidateFilepathPatternParams {
	return &ValidateFilepathPatternParams{
		HTTPClient: client,
	}
}

/*
ValidateFilepathPatternParams contains all the parameters to send to the API endpoint

	for the validate filepath pattern operation.

	Typically these are written to a http.Request.
*/
type ValidateFilepathPatternParams struct {

	// Body.
	Body *models.FwmgrAPIFilepathTestRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the validate filepath pattern params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ValidateFilepathPatternParams) WithDefaults() *ValidateFilepathPatternParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the validate filepath pattern params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ValidateFilepathPatternParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the validate filepath pattern params
func (o *ValidateFilepathPatternParams) WithTimeout(timeout time.Duration) *ValidateFilepathPatternParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the validate filepath pattern params
func (o *ValidateFilepathPatternParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the validate filepath pattern params
func (o *ValidateFilepathPatternParams) WithContext(ctx context.Context) *ValidateFilepathPatternParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the validate filepath pattern params
func (o *ValidateFilepathPatternParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the validate filepath pattern params
func (o *ValidateFilepathPatternParams) WithHTTPClient(client *http.Client) *ValidateFilepathPatternParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the validate filepath pattern params
func (o *ValidateFilepathPatternParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the validate filepath pattern params
func (o *ValidateFilepathPatternParams) WithBody(body *models.FwmgrAPIFilepathTestRequest) *ValidateFilepathPatternParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the validate filepath pattern params
func (o *ValidateFilepathPatternParams) SetBody(body *models.FwmgrAPIFilepathTestRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *ValidateFilepathPatternParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
