// Code generated by go-swagger; DO NOT EDIT.

package firewall_policies

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewUpdateFirewallPoliciesParams creates a new UpdateFirewallPoliciesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateFirewallPoliciesParams() *UpdateFirewallPoliciesParams {
	return &UpdateFirewallPoliciesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateFirewallPoliciesParamsWithTimeout creates a new UpdateFirewallPoliciesParams object
// with the ability to set a timeout on a request.
func NewUpdateFirewallPoliciesParamsWithTimeout(timeout time.Duration) *UpdateFirewallPoliciesParams {
	return &UpdateFirewallPoliciesParams{
		timeout: timeout,
	}
}

// NewUpdateFirewallPoliciesParamsWithContext creates a new UpdateFirewallPoliciesParams object
// with the ability to set a context for a request.
func NewUpdateFirewallPoliciesParamsWithContext(ctx context.Context) *UpdateFirewallPoliciesParams {
	return &UpdateFirewallPoliciesParams{
		Context: ctx,
	}
}

// NewUpdateFirewallPoliciesParamsWithHTTPClient creates a new UpdateFirewallPoliciesParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateFirewallPoliciesParamsWithHTTPClient(client *http.Client) *UpdateFirewallPoliciesParams {
	return &UpdateFirewallPoliciesParams{
		HTTPClient: client,
	}
}

/*
UpdateFirewallPoliciesParams contains all the parameters to send to the API endpoint

	for the update firewall policies operation.

	Typically these are written to a http.Request.
*/
type UpdateFirewallPoliciesParams struct {

	// Body.
	Body *models.RequestsUpdateFirewallPoliciesV1

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update firewall policies params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateFirewallPoliciesParams) WithDefaults() *UpdateFirewallPoliciesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update firewall policies params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateFirewallPoliciesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update firewall policies params
func (o *UpdateFirewallPoliciesParams) WithTimeout(timeout time.Duration) *UpdateFirewallPoliciesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update firewall policies params
func (o *UpdateFirewallPoliciesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update firewall policies params
func (o *UpdateFirewallPoliciesParams) WithContext(ctx context.Context) *UpdateFirewallPoliciesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update firewall policies params
func (o *UpdateFirewallPoliciesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update firewall policies params
func (o *UpdateFirewallPoliciesParams) WithHTTPClient(client *http.Client) *UpdateFirewallPoliciesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update firewall policies params
func (o *UpdateFirewallPoliciesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the update firewall policies params
func (o *UpdateFirewallPoliciesParams) WithBody(body *models.RequestsUpdateFirewallPoliciesV1) *UpdateFirewallPoliciesParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update firewall policies params
func (o *UpdateFirewallPoliciesParams) SetBody(body *models.RequestsUpdateFirewallPoliciesV1) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateFirewallPoliciesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
