// Code generated by go-swagger; DO NOT EDIT.

package host_group

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewCreateHostGroupsParams creates a new CreateHostGroupsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateHostGroupsParams() *CreateHostGroupsParams {
	return &CreateHostGroupsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateHostGroupsParamsWithTimeout creates a new CreateHostGroupsParams object
// with the ability to set a timeout on a request.
func NewCreateHostGroupsParamsWithTimeout(timeout time.Duration) *CreateHostGroupsParams {
	return &CreateHostGroupsParams{
		timeout: timeout,
	}
}

// NewCreateHostGroupsParamsWithContext creates a new CreateHostGroupsParams object
// with the ability to set a context for a request.
func NewCreateHostGroupsParamsWithContext(ctx context.Context) *CreateHostGroupsParams {
	return &CreateHostGroupsParams{
		Context: ctx,
	}
}

// NewCreateHostGroupsParamsWithHTTPClient creates a new CreateHostGroupsParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateHostGroupsParamsWithHTTPClient(client *http.Client) *CreateHostGroupsParams {
	return &CreateHostGroupsParams{
		HTTPClient: client,
	}
}

/*
CreateHostGroupsParams contains all the parameters to send to the API endpoint

	for the create host groups operation.

	Typically these are written to a http.Request.
*/
type CreateHostGroupsParams struct {

	// Body.
	Body *models.RequestsCreateGroupsV1

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create host groups params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateHostGroupsParams) WithDefaults() *CreateHostGroupsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create host groups params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateHostGroupsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create host groups params
func (o *CreateHostGroupsParams) WithTimeout(timeout time.Duration) *CreateHostGroupsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create host groups params
func (o *CreateHostGroupsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create host groups params
func (o *CreateHostGroupsParams) WithContext(ctx context.Context) *CreateHostGroupsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create host groups params
func (o *CreateHostGroupsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create host groups params
func (o *CreateHostGroupsParams) WithHTTPClient(client *http.Client) *CreateHostGroupsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create host groups params
func (o *CreateHostGroupsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create host groups params
func (o *CreateHostGroupsParams) WithBody(body *models.RequestsCreateGroupsV1) *CreateHostGroupsParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create host groups params
func (o *CreateHostGroupsParams) SetBody(body *models.RequestsCreateGroupsV1) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *CreateHostGroupsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
