// Code generated by go-swagger; DO NOT EDIT.

package hosts

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// GetDeviceDetailsReader is a Reader for the GetDeviceDetails structure.
type GetDeviceDetailsReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *GetDeviceDetailsReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewGetDeviceDetailsOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 403:
		result := NewGetDeviceDetailsForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 429:
		result := NewGetDeviceDetailsTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewGetDeviceDetailsDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewGetDeviceDetailsOK creates a GetDeviceDetailsOK with default headers values
func NewGetDeviceDetailsOK() *GetDeviceDetailsOK {
	return &GetDeviceDetailsOK{}
}

/*
GetDeviceDetailsOK describes a response with status code 200, with default header values.

OK
*/
type GetDeviceDetailsOK struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.DomainDeviceDetailsResponseSwagger
}

// IsSuccess returns true when this get device details o k response has a 2xx status code
func (o *GetDeviceDetailsOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this get device details o k response has a 3xx status code
func (o *GetDeviceDetailsOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device details o k response has a 4xx status code
func (o *GetDeviceDetailsOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this get device details o k response has a 5xx status code
func (o *GetDeviceDetailsOK) IsServerError() bool {
	return false
}

// IsCode returns true when this get device details o k response a status code equal to that given
func (o *GetDeviceDetailsOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the get device details o k response
func (o *GetDeviceDetailsOK) Code() int {
	return 200
}

func (o *GetDeviceDetailsOK) Error() string {
	return fmt.Sprintf("[GET /devices/entities/devices//v2][%d] getDeviceDetailsOK  %+v", 200, o.Payload)
}

func (o *GetDeviceDetailsOK) String() string {
	return fmt.Sprintf("[GET /devices/entities/devices//v2][%d] getDeviceDetailsOK  %+v", 200, o.Payload)
}

func (o *GetDeviceDetailsOK) GetPayload() *models.DomainDeviceDetailsResponseSwagger {
	return o.Payload
}

func (o *GetDeviceDetailsOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.DomainDeviceDetailsResponseSwagger)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceDetailsForbidden creates a GetDeviceDetailsForbidden with default headers values
func NewGetDeviceDetailsForbidden() *GetDeviceDetailsForbidden {
	return &GetDeviceDetailsForbidden{}
}

/*
GetDeviceDetailsForbidden describes a response with status code 403, with default header values.

Forbidden
*/
type GetDeviceDetailsForbidden struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this get device details forbidden response has a 2xx status code
func (o *GetDeviceDetailsForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get device details forbidden response has a 3xx status code
func (o *GetDeviceDetailsForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device details forbidden response has a 4xx status code
func (o *GetDeviceDetailsForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this get device details forbidden response has a 5xx status code
func (o *GetDeviceDetailsForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this get device details forbidden response a status code equal to that given
func (o *GetDeviceDetailsForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the get device details forbidden response
func (o *GetDeviceDetailsForbidden) Code() int {
	return 403
}

func (o *GetDeviceDetailsForbidden) Error() string {
	return fmt.Sprintf("[GET /devices/entities/devices//v2][%d] getDeviceDetailsForbidden  %+v", 403, o.Payload)
}

func (o *GetDeviceDetailsForbidden) String() string {
	return fmt.Sprintf("[GET /devices/entities/devices//v2][%d] getDeviceDetailsForbidden  %+v", 403, o.Payload)
}

func (o *GetDeviceDetailsForbidden) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *GetDeviceDetailsForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceDetailsTooManyRequests creates a GetDeviceDetailsTooManyRequests with default headers values
func NewGetDeviceDetailsTooManyRequests() *GetDeviceDetailsTooManyRequests {
	return &GetDeviceDetailsTooManyRequests{}
}

/*
GetDeviceDetailsTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type GetDeviceDetailsTooManyRequests struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	/* Too many requests, retry after this time (as milliseconds since epoch)
	 */
	XRateLimitRetryAfter int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this get device details too many requests response has a 2xx status code
func (o *GetDeviceDetailsTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this get device details too many requests response has a 3xx status code
func (o *GetDeviceDetailsTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this get device details too many requests response has a 4xx status code
func (o *GetDeviceDetailsTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this get device details too many requests response has a 5xx status code
func (o *GetDeviceDetailsTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this get device details too many requests response a status code equal to that given
func (o *GetDeviceDetailsTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the get device details too many requests response
func (o *GetDeviceDetailsTooManyRequests) Code() int {
	return 429
}

func (o *GetDeviceDetailsTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /devices/entities/devices//v2][%d] getDeviceDetailsTooManyRequests  %+v", 429, o.Payload)
}

func (o *GetDeviceDetailsTooManyRequests) String() string {
	return fmt.Sprintf("[GET /devices/entities/devices//v2][%d] getDeviceDetailsTooManyRequests  %+v", 429, o.Payload)
}

func (o *GetDeviceDetailsTooManyRequests) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *GetDeviceDetailsTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header X-RateLimit-RetryAfter
	hdrXRateLimitRetryAfter := response.GetHeader("X-RateLimit-RetryAfter")

	if hdrXRateLimitRetryAfter != "" {
		valxRateLimitRetryAfter, err := swag.ConvertInt64(hdrXRateLimitRetryAfter)
		if err != nil {
			return errors.InvalidType("X-RateLimit-RetryAfter", "header", "int64", hdrXRateLimitRetryAfter)
		}
		o.XRateLimitRetryAfter = valxRateLimitRetryAfter
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewGetDeviceDetailsDefault creates a GetDeviceDetailsDefault with default headers values
func NewGetDeviceDetailsDefault(code int) *GetDeviceDetailsDefault {
	return &GetDeviceDetailsDefault{
		_statusCode: code,
	}
}

/*
GetDeviceDetailsDefault describes a response with status code -1, with default header values.

OK
*/
type GetDeviceDetailsDefault struct {
	_statusCode int

	Payload *models.DomainDeviceDetailsResponseSwagger
}

// IsSuccess returns true when this get device details default response has a 2xx status code
func (o *GetDeviceDetailsDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this get device details default response has a 3xx status code
func (o *GetDeviceDetailsDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this get device details default response has a 4xx status code
func (o *GetDeviceDetailsDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this get device details default response has a 5xx status code
func (o *GetDeviceDetailsDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this get device details default response a status code equal to that given
func (o *GetDeviceDetailsDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the get device details default response
func (o *GetDeviceDetailsDefault) Code() int {
	return o._statusCode
}

func (o *GetDeviceDetailsDefault) Error() string {
	return fmt.Sprintf("[GET /devices/entities/devices//v2][%d] GetDeviceDetails default  %+v", o._statusCode, o.Payload)
}

func (o *GetDeviceDetailsDefault) String() string {
	return fmt.Sprintf("[GET /devices/entities/devices//v2][%d] GetDeviceDetails default  %+v", o._statusCode, o.Payload)
}

func (o *GetDeviceDetailsDefault) GetPayload() *models.DomainDeviceDetailsResponseSwagger {
	return o.Payload
}

func (o *GetDeviceDetailsDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DomainDeviceDetailsResponseSwagger)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
