// Code generated by go-swagger; DO NOT EDIT.

package incidents

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewGetBehaviorsParams creates a new GetBehaviorsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetBehaviorsParams() *GetBehaviorsParams {
	return &GetBehaviorsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetBehaviorsParamsWithTimeout creates a new GetBehaviorsParams object
// with the ability to set a timeout on a request.
func NewGetBehaviorsParamsWithTimeout(timeout time.Duration) *GetBehaviorsParams {
	return &GetBehaviorsParams{
		timeout: timeout,
	}
}

// NewGetBehaviorsParamsWithContext creates a new GetBehaviorsParams object
// with the ability to set a context for a request.
func NewGetBehaviorsParamsWithContext(ctx context.Context) *GetBehaviorsParams {
	return &GetBehaviorsParams{
		Context: ctx,
	}
}

// NewGetBehaviorsParamsWithHTTPClient creates a new GetBehaviorsParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetBehaviorsParamsWithHTTPClient(client *http.Client) *GetBehaviorsParams {
	return &GetBehaviorsParams{
		HTTPClient: client,
	}
}

/*
GetBehaviorsParams contains all the parameters to send to the API endpoint

	for the get behaviors operation.

	Typically these are written to a http.Request.
*/
type GetBehaviorsParams struct {

	// Body.
	Body *models.MsaIdsRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get behaviors params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetBehaviorsParams) WithDefaults() *GetBehaviorsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get behaviors params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetBehaviorsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get behaviors params
func (o *GetBehaviorsParams) WithTimeout(timeout time.Duration) *GetBehaviorsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get behaviors params
func (o *GetBehaviorsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get behaviors params
func (o *GetBehaviorsParams) WithContext(ctx context.Context) *GetBehaviorsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get behaviors params
func (o *GetBehaviorsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get behaviors params
func (o *GetBehaviorsParams) WithHTTPClient(client *http.Client) *GetBehaviorsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get behaviors params
func (o *GetBehaviorsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the get behaviors params
func (o *GetBehaviorsParams) WithBody(body *models.MsaIdsRequest) *GetBehaviorsParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the get behaviors params
func (o *GetBehaviorsParams) SetBody(body *models.MsaIdsRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *GetBehaviorsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
