// Code generated by go-swagger; DO NOT EDIT.

package intel

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
)

// NewGetIntelReportEntitiesParams creates a new GetIntelReportEntitiesParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetIntelReportEntitiesParams() *GetIntelReportEntitiesParams {
	return &GetIntelReportEntitiesParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetIntelReportEntitiesParamsWithTimeout creates a new GetIntelReportEntitiesParams object
// with the ability to set a timeout on a request.
func NewGetIntelReportEntitiesParamsWithTimeout(timeout time.Duration) *GetIntelReportEntitiesParams {
	return &GetIntelReportEntitiesParams{
		timeout: timeout,
	}
}

// NewGetIntelReportEntitiesParamsWithContext creates a new GetIntelReportEntitiesParams object
// with the ability to set a context for a request.
func NewGetIntelReportEntitiesParamsWithContext(ctx context.Context) *GetIntelReportEntitiesParams {
	return &GetIntelReportEntitiesParams{
		Context: ctx,
	}
}

// NewGetIntelReportEntitiesParamsWithHTTPClient creates a new GetIntelReportEntitiesParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetIntelReportEntitiesParamsWithHTTPClient(client *http.Client) *GetIntelReportEntitiesParams {
	return &GetIntelReportEntitiesParams{
		HTTPClient: client,
	}
}

/*
GetIntelReportEntitiesParams contains all the parameters to send to the API endpoint

	for the get intel report entities operation.

	Typically these are written to a http.Request.
*/
type GetIntelReportEntitiesParams struct {

	/* Fields.

	     The fields to return, or a predefined set of fields in the form of the collection name surrounded by two underscores like:

	\_\_\<collection\>\_\_.

	Ex: slug \_\_full\_\_.

	Defaults to \_\_basic\_\_.
	*/
	Fields []string

	/* Ids.

	   The IDs of the reports you want to retrieve.
	*/
	Ids []string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get intel report entities params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetIntelReportEntitiesParams) WithDefaults() *GetIntelReportEntitiesParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get intel report entities params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetIntelReportEntitiesParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get intel report entities params
func (o *GetIntelReportEntitiesParams) WithTimeout(timeout time.Duration) *GetIntelReportEntitiesParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get intel report entities params
func (o *GetIntelReportEntitiesParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get intel report entities params
func (o *GetIntelReportEntitiesParams) WithContext(ctx context.Context) *GetIntelReportEntitiesParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get intel report entities params
func (o *GetIntelReportEntitiesParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get intel report entities params
func (o *GetIntelReportEntitiesParams) WithHTTPClient(client *http.Client) *GetIntelReportEntitiesParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get intel report entities params
func (o *GetIntelReportEntitiesParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithFields adds the fields to the get intel report entities params
func (o *GetIntelReportEntitiesParams) WithFields(fields []string) *GetIntelReportEntitiesParams {
	o.SetFields(fields)
	return o
}

// SetFields adds the fields to the get intel report entities params
func (o *GetIntelReportEntitiesParams) SetFields(fields []string) {
	o.Fields = fields
}

// WithIds adds the ids to the get intel report entities params
func (o *GetIntelReportEntitiesParams) WithIds(ids []string) *GetIntelReportEntitiesParams {
	o.SetIds(ids)
	return o
}

// SetIds adds the ids to the get intel report entities params
func (o *GetIntelReportEntitiesParams) SetIds(ids []string) {
	o.Ids = ids
}

// WriteToRequest writes these params to a swagger request
func (o *GetIntelReportEntitiesParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Fields != nil {

		// binding items for fields
		joinedFields := o.bindParamFields(reg)

		// query array param fields
		if err := r.SetQueryParam("fields", joinedFields...); err != nil {
			return err
		}
	}

	if o.Ids != nil {

		// binding items for ids
		joinedIds := o.bindParamIds(reg)

		// query array param ids
		if err := r.SetQueryParam("ids", joinedIds...); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

// bindParamGetIntelReportEntities binds the parameter fields
func (o *GetIntelReportEntitiesParams) bindParamFields(formats strfmt.Registry) []string {
	fieldsIR := o.Fields

	var fieldsIC []string
	for _, fieldsIIR := range fieldsIR { // explode []string

		fieldsIIV := fieldsIIR // string as string
		fieldsIC = append(fieldsIC, fieldsIIV)
	}

	// items.CollectionFormat: "multi"
	fieldsIS := swag.JoinByFormat(fieldsIC, "multi")

	return fieldsIS
}

// bindParamGetIntelReportEntities binds the parameter ids
func (o *GetIntelReportEntitiesParams) bindParamIds(formats strfmt.Registry) []string {
	idsIR := o.Ids

	var idsIC []string
	for _, idsIIR := range idsIR { // explode []string

		idsIIV := idsIIR // string as string
		idsIC = append(idsIC, idsIIV)
	}

	// items.CollectionFormat: "multi"
	idsIS := swag.JoinByFormat(idsIC, "multi")

	return idsIS
}
