// Code generated by go-swagger; DO NOT EDIT.

package ioa_exclusions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// CreateIOAExclusionsV1Reader is a Reader for the CreateIOAExclusionsV1 structure.
type CreateIOAExclusionsV1Reader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateIOAExclusionsV1Reader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewCreateIOAExclusionsV1OK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewCreateIOAExclusionsV1BadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewCreateIOAExclusionsV1Forbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 429:
		result := NewCreateIOAExclusionsV1TooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewCreateIOAExclusionsV1InternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewCreateIOAExclusionsV1Default(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewCreateIOAExclusionsV1OK creates a CreateIOAExclusionsV1OK with default headers values
func NewCreateIOAExclusionsV1OK() *CreateIOAExclusionsV1OK {
	return &CreateIOAExclusionsV1OK{}
}

/*
CreateIOAExclusionsV1OK describes a response with status code 200, with default header values.

OK
*/
type CreateIOAExclusionsV1OK struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.ResponsesIoaExclusionRespV1
}

// IsSuccess returns true when this create i o a exclusions v1 o k response has a 2xx status code
func (o *CreateIOAExclusionsV1OK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this create i o a exclusions v1 o k response has a 3xx status code
func (o *CreateIOAExclusionsV1OK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create i o a exclusions v1 o k response has a 4xx status code
func (o *CreateIOAExclusionsV1OK) IsClientError() bool {
	return false
}

// IsServerError returns true when this create i o a exclusions v1 o k response has a 5xx status code
func (o *CreateIOAExclusionsV1OK) IsServerError() bool {
	return false
}

// IsCode returns true when this create i o a exclusions v1 o k response a status code equal to that given
func (o *CreateIOAExclusionsV1OK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the create i o a exclusions v1 o k response
func (o *CreateIOAExclusionsV1OK) Code() int {
	return 200
}

func (o *CreateIOAExclusionsV1OK) Error() string {
	return fmt.Sprintf("[POST /policy/entities/ioa-exclusions/v1][%d] createIOAExclusionsV1OK  %+v", 200, o.Payload)
}

func (o *CreateIOAExclusionsV1OK) String() string {
	return fmt.Sprintf("[POST /policy/entities/ioa-exclusions/v1][%d] createIOAExclusionsV1OK  %+v", 200, o.Payload)
}

func (o *CreateIOAExclusionsV1OK) GetPayload() *models.ResponsesIoaExclusionRespV1 {
	return o.Payload
}

func (o *CreateIOAExclusionsV1OK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.ResponsesIoaExclusionRespV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateIOAExclusionsV1BadRequest creates a CreateIOAExclusionsV1BadRequest with default headers values
func NewCreateIOAExclusionsV1BadRequest() *CreateIOAExclusionsV1BadRequest {
	return &CreateIOAExclusionsV1BadRequest{}
}

/*
CreateIOAExclusionsV1BadRequest describes a response with status code 400, with default header values.

Bad Request
*/
type CreateIOAExclusionsV1BadRequest struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.ResponsesIoaExclusionRespV1
}

// IsSuccess returns true when this create i o a exclusions v1 bad request response has a 2xx status code
func (o *CreateIOAExclusionsV1BadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create i o a exclusions v1 bad request response has a 3xx status code
func (o *CreateIOAExclusionsV1BadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create i o a exclusions v1 bad request response has a 4xx status code
func (o *CreateIOAExclusionsV1BadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this create i o a exclusions v1 bad request response has a 5xx status code
func (o *CreateIOAExclusionsV1BadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this create i o a exclusions v1 bad request response a status code equal to that given
func (o *CreateIOAExclusionsV1BadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the create i o a exclusions v1 bad request response
func (o *CreateIOAExclusionsV1BadRequest) Code() int {
	return 400
}

func (o *CreateIOAExclusionsV1BadRequest) Error() string {
	return fmt.Sprintf("[POST /policy/entities/ioa-exclusions/v1][%d] createIOAExclusionsV1BadRequest  %+v", 400, o.Payload)
}

func (o *CreateIOAExclusionsV1BadRequest) String() string {
	return fmt.Sprintf("[POST /policy/entities/ioa-exclusions/v1][%d] createIOAExclusionsV1BadRequest  %+v", 400, o.Payload)
}

func (o *CreateIOAExclusionsV1BadRequest) GetPayload() *models.ResponsesIoaExclusionRespV1 {
	return o.Payload
}

func (o *CreateIOAExclusionsV1BadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.ResponsesIoaExclusionRespV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateIOAExclusionsV1Forbidden creates a CreateIOAExclusionsV1Forbidden with default headers values
func NewCreateIOAExclusionsV1Forbidden() *CreateIOAExclusionsV1Forbidden {
	return &CreateIOAExclusionsV1Forbidden{}
}

/*
CreateIOAExclusionsV1Forbidden describes a response with status code 403, with default header values.

Forbidden
*/
type CreateIOAExclusionsV1Forbidden struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaErrorsOnly
}

// IsSuccess returns true when this create i o a exclusions v1 forbidden response has a 2xx status code
func (o *CreateIOAExclusionsV1Forbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create i o a exclusions v1 forbidden response has a 3xx status code
func (o *CreateIOAExclusionsV1Forbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create i o a exclusions v1 forbidden response has a 4xx status code
func (o *CreateIOAExclusionsV1Forbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this create i o a exclusions v1 forbidden response has a 5xx status code
func (o *CreateIOAExclusionsV1Forbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this create i o a exclusions v1 forbidden response a status code equal to that given
func (o *CreateIOAExclusionsV1Forbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the create i o a exclusions v1 forbidden response
func (o *CreateIOAExclusionsV1Forbidden) Code() int {
	return 403
}

func (o *CreateIOAExclusionsV1Forbidden) Error() string {
	return fmt.Sprintf("[POST /policy/entities/ioa-exclusions/v1][%d] createIOAExclusionsV1Forbidden  %+v", 403, o.Payload)
}

func (o *CreateIOAExclusionsV1Forbidden) String() string {
	return fmt.Sprintf("[POST /policy/entities/ioa-exclusions/v1][%d] createIOAExclusionsV1Forbidden  %+v", 403, o.Payload)
}

func (o *CreateIOAExclusionsV1Forbidden) GetPayload() *models.MsaErrorsOnly {
	return o.Payload
}

func (o *CreateIOAExclusionsV1Forbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaErrorsOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateIOAExclusionsV1TooManyRequests creates a CreateIOAExclusionsV1TooManyRequests with default headers values
func NewCreateIOAExclusionsV1TooManyRequests() *CreateIOAExclusionsV1TooManyRequests {
	return &CreateIOAExclusionsV1TooManyRequests{}
}

/*
CreateIOAExclusionsV1TooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type CreateIOAExclusionsV1TooManyRequests struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	/* Too many requests, retry after this time (as milliseconds since epoch)
	 */
	XRateLimitRetryAfter int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this create i o a exclusions v1 too many requests response has a 2xx status code
func (o *CreateIOAExclusionsV1TooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create i o a exclusions v1 too many requests response has a 3xx status code
func (o *CreateIOAExclusionsV1TooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create i o a exclusions v1 too many requests response has a 4xx status code
func (o *CreateIOAExclusionsV1TooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this create i o a exclusions v1 too many requests response has a 5xx status code
func (o *CreateIOAExclusionsV1TooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this create i o a exclusions v1 too many requests response a status code equal to that given
func (o *CreateIOAExclusionsV1TooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the create i o a exclusions v1 too many requests response
func (o *CreateIOAExclusionsV1TooManyRequests) Code() int {
	return 429
}

func (o *CreateIOAExclusionsV1TooManyRequests) Error() string {
	return fmt.Sprintf("[POST /policy/entities/ioa-exclusions/v1][%d] createIOAExclusionsV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *CreateIOAExclusionsV1TooManyRequests) String() string {
	return fmt.Sprintf("[POST /policy/entities/ioa-exclusions/v1][%d] createIOAExclusionsV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *CreateIOAExclusionsV1TooManyRequests) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *CreateIOAExclusionsV1TooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header X-RateLimit-RetryAfter
	hdrXRateLimitRetryAfter := response.GetHeader("X-RateLimit-RetryAfter")

	if hdrXRateLimitRetryAfter != "" {
		valxRateLimitRetryAfter, err := swag.ConvertInt64(hdrXRateLimitRetryAfter)
		if err != nil {
			return errors.InvalidType("X-RateLimit-RetryAfter", "header", "int64", hdrXRateLimitRetryAfter)
		}
		o.XRateLimitRetryAfter = valxRateLimitRetryAfter
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateIOAExclusionsV1InternalServerError creates a CreateIOAExclusionsV1InternalServerError with default headers values
func NewCreateIOAExclusionsV1InternalServerError() *CreateIOAExclusionsV1InternalServerError {
	return &CreateIOAExclusionsV1InternalServerError{}
}

/*
CreateIOAExclusionsV1InternalServerError describes a response with status code 500, with default header values.

Internal Server Error
*/
type CreateIOAExclusionsV1InternalServerError struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.ResponsesIoaExclusionRespV1
}

// IsSuccess returns true when this create i o a exclusions v1 internal server error response has a 2xx status code
func (o *CreateIOAExclusionsV1InternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create i o a exclusions v1 internal server error response has a 3xx status code
func (o *CreateIOAExclusionsV1InternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create i o a exclusions v1 internal server error response has a 4xx status code
func (o *CreateIOAExclusionsV1InternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this create i o a exclusions v1 internal server error response has a 5xx status code
func (o *CreateIOAExclusionsV1InternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this create i o a exclusions v1 internal server error response a status code equal to that given
func (o *CreateIOAExclusionsV1InternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the create i o a exclusions v1 internal server error response
func (o *CreateIOAExclusionsV1InternalServerError) Code() int {
	return 500
}

func (o *CreateIOAExclusionsV1InternalServerError) Error() string {
	return fmt.Sprintf("[POST /policy/entities/ioa-exclusions/v1][%d] createIOAExclusionsV1InternalServerError  %+v", 500, o.Payload)
}

func (o *CreateIOAExclusionsV1InternalServerError) String() string {
	return fmt.Sprintf("[POST /policy/entities/ioa-exclusions/v1][%d] createIOAExclusionsV1InternalServerError  %+v", 500, o.Payload)
}

func (o *CreateIOAExclusionsV1InternalServerError) GetPayload() *models.ResponsesIoaExclusionRespV1 {
	return o.Payload
}

func (o *CreateIOAExclusionsV1InternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.ResponsesIoaExclusionRespV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateIOAExclusionsV1Default creates a CreateIOAExclusionsV1Default with default headers values
func NewCreateIOAExclusionsV1Default(code int) *CreateIOAExclusionsV1Default {
	return &CreateIOAExclusionsV1Default{
		_statusCode: code,
	}
}

/*
CreateIOAExclusionsV1Default describes a response with status code -1, with default header values.

OK
*/
type CreateIOAExclusionsV1Default struct {
	_statusCode int

	Payload *models.ResponsesIoaExclusionRespV1
}

// IsSuccess returns true when this create i o a exclusions v1 default response has a 2xx status code
func (o *CreateIOAExclusionsV1Default) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this create i o a exclusions v1 default response has a 3xx status code
func (o *CreateIOAExclusionsV1Default) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this create i o a exclusions v1 default response has a 4xx status code
func (o *CreateIOAExclusionsV1Default) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this create i o a exclusions v1 default response has a 5xx status code
func (o *CreateIOAExclusionsV1Default) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this create i o a exclusions v1 default response a status code equal to that given
func (o *CreateIOAExclusionsV1Default) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the create i o a exclusions v1 default response
func (o *CreateIOAExclusionsV1Default) Code() int {
	return o._statusCode
}

func (o *CreateIOAExclusionsV1Default) Error() string {
	return fmt.Sprintf("[POST /policy/entities/ioa-exclusions/v1][%d] createIOAExclusionsV1 default  %+v", o._statusCode, o.Payload)
}

func (o *CreateIOAExclusionsV1Default) String() string {
	return fmt.Sprintf("[POST /policy/entities/ioa-exclusions/v1][%d] createIOAExclusionsV1 default  %+v", o._statusCode, o.Payload)
}

func (o *CreateIOAExclusionsV1Default) GetPayload() *models.ResponsesIoaExclusionRespV1 {
	return o.Payload
}

func (o *CreateIOAExclusionsV1Default) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ResponsesIoaExclusionRespV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
