// Code generated by go-swagger; DO NOT EDIT.

package ioa_exclusions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// QueryIOAExclusionsV1Reader is a Reader for the QueryIOAExclusionsV1 structure.
type QueryIOAExclusionsV1Reader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *QueryIOAExclusionsV1Reader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewQueryIOAExclusionsV1OK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewQueryIOAExclusionsV1BadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewQueryIOAExclusionsV1Forbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 429:
		result := NewQueryIOAExclusionsV1TooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewQueryIOAExclusionsV1InternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewQueryIOAExclusionsV1Default(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewQueryIOAExclusionsV1OK creates a QueryIOAExclusionsV1OK with default headers values
func NewQueryIOAExclusionsV1OK() *QueryIOAExclusionsV1OK {
	return &QueryIOAExclusionsV1OK{}
}

/*
QueryIOAExclusionsV1OK describes a response with status code 200, with default header values.

OK
*/
type QueryIOAExclusionsV1OK struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaQueryResponse
}

// IsSuccess returns true when this query i o a exclusions v1 o k response has a 2xx status code
func (o *QueryIOAExclusionsV1OK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this query i o a exclusions v1 o k response has a 3xx status code
func (o *QueryIOAExclusionsV1OK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query i o a exclusions v1 o k response has a 4xx status code
func (o *QueryIOAExclusionsV1OK) IsClientError() bool {
	return false
}

// IsServerError returns true when this query i o a exclusions v1 o k response has a 5xx status code
func (o *QueryIOAExclusionsV1OK) IsServerError() bool {
	return false
}

// IsCode returns true when this query i o a exclusions v1 o k response a status code equal to that given
func (o *QueryIOAExclusionsV1OK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the query i o a exclusions v1 o k response
func (o *QueryIOAExclusionsV1OK) Code() int {
	return 200
}

func (o *QueryIOAExclusionsV1OK) Error() string {
	return fmt.Sprintf("[GET /policy/queries/ioa-exclusions/v1][%d] queryIOAExclusionsV1OK  %+v", 200, o.Payload)
}

func (o *QueryIOAExclusionsV1OK) String() string {
	return fmt.Sprintf("[GET /policy/queries/ioa-exclusions/v1][%d] queryIOAExclusionsV1OK  %+v", 200, o.Payload)
}

func (o *QueryIOAExclusionsV1OK) GetPayload() *models.MsaQueryResponse {
	return o.Payload
}

func (o *QueryIOAExclusionsV1OK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaQueryResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQueryIOAExclusionsV1BadRequest creates a QueryIOAExclusionsV1BadRequest with default headers values
func NewQueryIOAExclusionsV1BadRequest() *QueryIOAExclusionsV1BadRequest {
	return &QueryIOAExclusionsV1BadRequest{}
}

/*
QueryIOAExclusionsV1BadRequest describes a response with status code 400, with default header values.

Bad Request
*/
type QueryIOAExclusionsV1BadRequest struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaQueryResponse
}

// IsSuccess returns true when this query i o a exclusions v1 bad request response has a 2xx status code
func (o *QueryIOAExclusionsV1BadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this query i o a exclusions v1 bad request response has a 3xx status code
func (o *QueryIOAExclusionsV1BadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query i o a exclusions v1 bad request response has a 4xx status code
func (o *QueryIOAExclusionsV1BadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this query i o a exclusions v1 bad request response has a 5xx status code
func (o *QueryIOAExclusionsV1BadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this query i o a exclusions v1 bad request response a status code equal to that given
func (o *QueryIOAExclusionsV1BadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the query i o a exclusions v1 bad request response
func (o *QueryIOAExclusionsV1BadRequest) Code() int {
	return 400
}

func (o *QueryIOAExclusionsV1BadRequest) Error() string {
	return fmt.Sprintf("[GET /policy/queries/ioa-exclusions/v1][%d] queryIOAExclusionsV1BadRequest  %+v", 400, o.Payload)
}

func (o *QueryIOAExclusionsV1BadRequest) String() string {
	return fmt.Sprintf("[GET /policy/queries/ioa-exclusions/v1][%d] queryIOAExclusionsV1BadRequest  %+v", 400, o.Payload)
}

func (o *QueryIOAExclusionsV1BadRequest) GetPayload() *models.MsaQueryResponse {
	return o.Payload
}

func (o *QueryIOAExclusionsV1BadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaQueryResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQueryIOAExclusionsV1Forbidden creates a QueryIOAExclusionsV1Forbidden with default headers values
func NewQueryIOAExclusionsV1Forbidden() *QueryIOAExclusionsV1Forbidden {
	return &QueryIOAExclusionsV1Forbidden{}
}

/*
QueryIOAExclusionsV1Forbidden describes a response with status code 403, with default header values.

Forbidden
*/
type QueryIOAExclusionsV1Forbidden struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaErrorsOnly
}

// IsSuccess returns true when this query i o a exclusions v1 forbidden response has a 2xx status code
func (o *QueryIOAExclusionsV1Forbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this query i o a exclusions v1 forbidden response has a 3xx status code
func (o *QueryIOAExclusionsV1Forbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query i o a exclusions v1 forbidden response has a 4xx status code
func (o *QueryIOAExclusionsV1Forbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this query i o a exclusions v1 forbidden response has a 5xx status code
func (o *QueryIOAExclusionsV1Forbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this query i o a exclusions v1 forbidden response a status code equal to that given
func (o *QueryIOAExclusionsV1Forbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the query i o a exclusions v1 forbidden response
func (o *QueryIOAExclusionsV1Forbidden) Code() int {
	return 403
}

func (o *QueryIOAExclusionsV1Forbidden) Error() string {
	return fmt.Sprintf("[GET /policy/queries/ioa-exclusions/v1][%d] queryIOAExclusionsV1Forbidden  %+v", 403, o.Payload)
}

func (o *QueryIOAExclusionsV1Forbidden) String() string {
	return fmt.Sprintf("[GET /policy/queries/ioa-exclusions/v1][%d] queryIOAExclusionsV1Forbidden  %+v", 403, o.Payload)
}

func (o *QueryIOAExclusionsV1Forbidden) GetPayload() *models.MsaErrorsOnly {
	return o.Payload
}

func (o *QueryIOAExclusionsV1Forbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaErrorsOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQueryIOAExclusionsV1TooManyRequests creates a QueryIOAExclusionsV1TooManyRequests with default headers values
func NewQueryIOAExclusionsV1TooManyRequests() *QueryIOAExclusionsV1TooManyRequests {
	return &QueryIOAExclusionsV1TooManyRequests{}
}

/*
QueryIOAExclusionsV1TooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type QueryIOAExclusionsV1TooManyRequests struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	/* Too many requests, retry after this time (as milliseconds since epoch)
	 */
	XRateLimitRetryAfter int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this query i o a exclusions v1 too many requests response has a 2xx status code
func (o *QueryIOAExclusionsV1TooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this query i o a exclusions v1 too many requests response has a 3xx status code
func (o *QueryIOAExclusionsV1TooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query i o a exclusions v1 too many requests response has a 4xx status code
func (o *QueryIOAExclusionsV1TooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this query i o a exclusions v1 too many requests response has a 5xx status code
func (o *QueryIOAExclusionsV1TooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this query i o a exclusions v1 too many requests response a status code equal to that given
func (o *QueryIOAExclusionsV1TooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the query i o a exclusions v1 too many requests response
func (o *QueryIOAExclusionsV1TooManyRequests) Code() int {
	return 429
}

func (o *QueryIOAExclusionsV1TooManyRequests) Error() string {
	return fmt.Sprintf("[GET /policy/queries/ioa-exclusions/v1][%d] queryIOAExclusionsV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *QueryIOAExclusionsV1TooManyRequests) String() string {
	return fmt.Sprintf("[GET /policy/queries/ioa-exclusions/v1][%d] queryIOAExclusionsV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *QueryIOAExclusionsV1TooManyRequests) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *QueryIOAExclusionsV1TooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header X-RateLimit-RetryAfter
	hdrXRateLimitRetryAfter := response.GetHeader("X-RateLimit-RetryAfter")

	if hdrXRateLimitRetryAfter != "" {
		valxRateLimitRetryAfter, err := swag.ConvertInt64(hdrXRateLimitRetryAfter)
		if err != nil {
			return errors.InvalidType("X-RateLimit-RetryAfter", "header", "int64", hdrXRateLimitRetryAfter)
		}
		o.XRateLimitRetryAfter = valxRateLimitRetryAfter
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQueryIOAExclusionsV1InternalServerError creates a QueryIOAExclusionsV1InternalServerError with default headers values
func NewQueryIOAExclusionsV1InternalServerError() *QueryIOAExclusionsV1InternalServerError {
	return &QueryIOAExclusionsV1InternalServerError{}
}

/*
QueryIOAExclusionsV1InternalServerError describes a response with status code 500, with default header values.

Internal Server Error
*/
type QueryIOAExclusionsV1InternalServerError struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaQueryResponse
}

// IsSuccess returns true when this query i o a exclusions v1 internal server error response has a 2xx status code
func (o *QueryIOAExclusionsV1InternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this query i o a exclusions v1 internal server error response has a 3xx status code
func (o *QueryIOAExclusionsV1InternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query i o a exclusions v1 internal server error response has a 4xx status code
func (o *QueryIOAExclusionsV1InternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this query i o a exclusions v1 internal server error response has a 5xx status code
func (o *QueryIOAExclusionsV1InternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this query i o a exclusions v1 internal server error response a status code equal to that given
func (o *QueryIOAExclusionsV1InternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the query i o a exclusions v1 internal server error response
func (o *QueryIOAExclusionsV1InternalServerError) Code() int {
	return 500
}

func (o *QueryIOAExclusionsV1InternalServerError) Error() string {
	return fmt.Sprintf("[GET /policy/queries/ioa-exclusions/v1][%d] queryIOAExclusionsV1InternalServerError  %+v", 500, o.Payload)
}

func (o *QueryIOAExclusionsV1InternalServerError) String() string {
	return fmt.Sprintf("[GET /policy/queries/ioa-exclusions/v1][%d] queryIOAExclusionsV1InternalServerError  %+v", 500, o.Payload)
}

func (o *QueryIOAExclusionsV1InternalServerError) GetPayload() *models.MsaQueryResponse {
	return o.Payload
}

func (o *QueryIOAExclusionsV1InternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaQueryResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQueryIOAExclusionsV1Default creates a QueryIOAExclusionsV1Default with default headers values
func NewQueryIOAExclusionsV1Default(code int) *QueryIOAExclusionsV1Default {
	return &QueryIOAExclusionsV1Default{
		_statusCode: code,
	}
}

/*
QueryIOAExclusionsV1Default describes a response with status code -1, with default header values.

OK
*/
type QueryIOAExclusionsV1Default struct {
	_statusCode int

	Payload *models.MsaQueryResponse
}

// IsSuccess returns true when this query i o a exclusions v1 default response has a 2xx status code
func (o *QueryIOAExclusionsV1Default) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this query i o a exclusions v1 default response has a 3xx status code
func (o *QueryIOAExclusionsV1Default) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this query i o a exclusions v1 default response has a 4xx status code
func (o *QueryIOAExclusionsV1Default) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this query i o a exclusions v1 default response has a 5xx status code
func (o *QueryIOAExclusionsV1Default) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this query i o a exclusions v1 default response a status code equal to that given
func (o *QueryIOAExclusionsV1Default) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the query i o a exclusions v1 default response
func (o *QueryIOAExclusionsV1Default) Code() int {
	return o._statusCode
}

func (o *QueryIOAExclusionsV1Default) Error() string {
	return fmt.Sprintf("[GET /policy/queries/ioa-exclusions/v1][%d] queryIOAExclusionsV1 default  %+v", o._statusCode, o.Payload)
}

func (o *QueryIOAExclusionsV1Default) String() string {
	return fmt.Sprintf("[GET /policy/queries/ioa-exclusions/v1][%d] queryIOAExclusionsV1 default  %+v", o._statusCode, o.Payload)
}

func (o *QueryIOAExclusionsV1Default) GetPayload() *models.MsaQueryResponse {
	return o.Payload
}

func (o *QueryIOAExclusionsV1Default) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.MsaQueryResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
