// Code generated by go-swagger; DO NOT EDIT.

package kubernetes_protection

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewCreateAWSAccountParams creates a new CreateAWSAccountParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateAWSAccountParams() *CreateAWSAccountParams {
	return &CreateAWSAccountParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateAWSAccountParamsWithTimeout creates a new CreateAWSAccountParams object
// with the ability to set a timeout on a request.
func NewCreateAWSAccountParamsWithTimeout(timeout time.Duration) *CreateAWSAccountParams {
	return &CreateAWSAccountParams{
		timeout: timeout,
	}
}

// NewCreateAWSAccountParamsWithContext creates a new CreateAWSAccountParams object
// with the ability to set a context for a request.
func NewCreateAWSAccountParamsWithContext(ctx context.Context) *CreateAWSAccountParams {
	return &CreateAWSAccountParams{
		Context: ctx,
	}
}

// NewCreateAWSAccountParamsWithHTTPClient creates a new CreateAWSAccountParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateAWSAccountParamsWithHTTPClient(client *http.Client) *CreateAWSAccountParams {
	return &CreateAWSAccountParams{
		HTTPClient: client,
	}
}

/*
CreateAWSAccountParams contains all the parameters to send to the API endpoint

	for the create a w s account operation.

	Typically these are written to a http.Request.
*/
type CreateAWSAccountParams struct {

	// Body.
	Body *models.K8sregCreateAWSAccReq

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create a w s account params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateAWSAccountParams) WithDefaults() *CreateAWSAccountParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create a w s account params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateAWSAccountParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create a w s account params
func (o *CreateAWSAccountParams) WithTimeout(timeout time.Duration) *CreateAWSAccountParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create a w s account params
func (o *CreateAWSAccountParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create a w s account params
func (o *CreateAWSAccountParams) WithContext(ctx context.Context) *CreateAWSAccountParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create a w s account params
func (o *CreateAWSAccountParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create a w s account params
func (o *CreateAWSAccountParams) WithHTTPClient(client *http.Client) *CreateAWSAccountParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create a w s account params
func (o *CreateAWSAccountParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create a w s account params
func (o *CreateAWSAccountParams) WithBody(body *models.K8sregCreateAWSAccReq) *CreateAWSAccountParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create a w s account params
func (o *CreateAWSAccountParams) SetBody(body *models.K8sregCreateAWSAccReq) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *CreateAWSAccountParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
