// Code generated by go-swagger; DO NOT EDIT.

package kubernetes_protection

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewPatchAzureServicePrincipalParams creates a new PatchAzureServicePrincipalParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPatchAzureServicePrincipalParams() *PatchAzureServicePrincipalParams {
	return &PatchAzureServicePrincipalParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewPatchAzureServicePrincipalParamsWithTimeout creates a new PatchAzureServicePrincipalParams object
// with the ability to set a timeout on a request.
func NewPatchAzureServicePrincipalParamsWithTimeout(timeout time.Duration) *PatchAzureServicePrincipalParams {
	return &PatchAzureServicePrincipalParams{
		timeout: timeout,
	}
}

// NewPatchAzureServicePrincipalParamsWithContext creates a new PatchAzureServicePrincipalParams object
// with the ability to set a context for a request.
func NewPatchAzureServicePrincipalParamsWithContext(ctx context.Context) *PatchAzureServicePrincipalParams {
	return &PatchAzureServicePrincipalParams{
		Context: ctx,
	}
}

// NewPatchAzureServicePrincipalParamsWithHTTPClient creates a new PatchAzureServicePrincipalParams object
// with the ability to set a custom HTTPClient for a request.
func NewPatchAzureServicePrincipalParamsWithHTTPClient(client *http.Client) *PatchAzureServicePrincipalParams {
	return &PatchAzureServicePrincipalParams{
		HTTPClient: client,
	}
}

/*
PatchAzureServicePrincipalParams contains all the parameters to send to the API endpoint

	for the patch azure service principal operation.

	Typically these are written to a http.Request.
*/
type PatchAzureServicePrincipalParams struct {

	/* ClientID.

	   Azure Client ID
	*/
	ClientID string

	/* ID.

	   Azure Tenant ID
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the patch azure service principal params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PatchAzureServicePrincipalParams) WithDefaults() *PatchAzureServicePrincipalParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the patch azure service principal params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PatchAzureServicePrincipalParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the patch azure service principal params
func (o *PatchAzureServicePrincipalParams) WithTimeout(timeout time.Duration) *PatchAzureServicePrincipalParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the patch azure service principal params
func (o *PatchAzureServicePrincipalParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the patch azure service principal params
func (o *PatchAzureServicePrincipalParams) WithContext(ctx context.Context) *PatchAzureServicePrincipalParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the patch azure service principal params
func (o *PatchAzureServicePrincipalParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the patch azure service principal params
func (o *PatchAzureServicePrincipalParams) WithHTTPClient(client *http.Client) *PatchAzureServicePrincipalParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the patch azure service principal params
func (o *PatchAzureServicePrincipalParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithClientID adds the clientID to the patch azure service principal params
func (o *PatchAzureServicePrincipalParams) WithClientID(clientID string) *PatchAzureServicePrincipalParams {
	o.SetClientID(clientID)
	return o
}

// SetClientID adds the clientId to the patch azure service principal params
func (o *PatchAzureServicePrincipalParams) SetClientID(clientID string) {
	o.ClientID = clientID
}

// WithID adds the id to the patch azure service principal params
func (o *PatchAzureServicePrincipalParams) WithID(id string) *PatchAzureServicePrincipalParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the patch azure service principal params
func (o *PatchAzureServicePrincipalParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *PatchAzureServicePrincipalParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// query param client_id
	qrClientID := o.ClientID
	qClientID := qrClientID
	if qClientID != "" {

		if err := r.SetQueryParam("client_id", qClientID); err != nil {
			return err
		}
	}

	// query param id
	qrID := o.ID
	qID := qrID
	if qID != "" {

		if err := r.SetQueryParam("id", qID); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
