// Code generated by go-swagger; DO NOT EDIT.

package malquery

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewPostMalQueryExactSearchV1Params creates a new PostMalQueryExactSearchV1Params object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewPostMalQueryExactSearchV1Params() *PostMalQueryExactSearchV1Params {
	return &PostMalQueryExactSearchV1Params{
		timeout: cr.DefaultTimeout,
	}
}

// NewPostMalQueryExactSearchV1ParamsWithTimeout creates a new PostMalQueryExactSearchV1Params object
// with the ability to set a timeout on a request.
func NewPostMalQueryExactSearchV1ParamsWithTimeout(timeout time.Duration) *PostMalQueryExactSearchV1Params {
	return &PostMalQueryExactSearchV1Params{
		timeout: timeout,
	}
}

// NewPostMalQueryExactSearchV1ParamsWithContext creates a new PostMalQueryExactSearchV1Params object
// with the ability to set a context for a request.
func NewPostMalQueryExactSearchV1ParamsWithContext(ctx context.Context) *PostMalQueryExactSearchV1Params {
	return &PostMalQueryExactSearchV1Params{
		Context: ctx,
	}
}

// NewPostMalQueryExactSearchV1ParamsWithHTTPClient creates a new PostMalQueryExactSearchV1Params object
// with the ability to set a custom HTTPClient for a request.
func NewPostMalQueryExactSearchV1ParamsWithHTTPClient(client *http.Client) *PostMalQueryExactSearchV1Params {
	return &PostMalQueryExactSearchV1Params{
		HTTPClient: client,
	}
}

/*
PostMalQueryExactSearchV1Params contains all the parameters to send to the API endpoint

	for the post mal query exact search v1 operation.

	Typically these are written to a http.Request.
*/
type PostMalQueryExactSearchV1Params struct {

	/* Body.

	   Exact search parameters. See model for more details.
	*/
	Body *models.MalqueryExternalExactSearchParametersV1

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the post mal query exact search v1 params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostMalQueryExactSearchV1Params) WithDefaults() *PostMalQueryExactSearchV1Params {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the post mal query exact search v1 params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *PostMalQueryExactSearchV1Params) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the post mal query exact search v1 params
func (o *PostMalQueryExactSearchV1Params) WithTimeout(timeout time.Duration) *PostMalQueryExactSearchV1Params {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the post mal query exact search v1 params
func (o *PostMalQueryExactSearchV1Params) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the post mal query exact search v1 params
func (o *PostMalQueryExactSearchV1Params) WithContext(ctx context.Context) *PostMalQueryExactSearchV1Params {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the post mal query exact search v1 params
func (o *PostMalQueryExactSearchV1Params) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the post mal query exact search v1 params
func (o *PostMalQueryExactSearchV1Params) WithHTTPClient(client *http.Client) *PostMalQueryExactSearchV1Params {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the post mal query exact search v1 params
func (o *PostMalQueryExactSearchV1Params) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the post mal query exact search v1 params
func (o *PostMalQueryExactSearchV1Params) WithBody(body *models.MalqueryExternalExactSearchParametersV1) *PostMalQueryExactSearchV1Params {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the post mal query exact search v1 params
func (o *PostMalQueryExactSearchV1Params) SetBody(body *models.MalqueryExternalExactSearchParametersV1) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *PostMalQueryExactSearchV1Params) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
