// Code generated by go-swagger; DO NOT EDIT.

package message_center

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewCaseAddActivityParams creates a new CaseAddActivityParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCaseAddActivityParams() *CaseAddActivityParams {
	return &CaseAddActivityParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCaseAddActivityParamsWithTimeout creates a new CaseAddActivityParams object
// with the ability to set a timeout on a request.
func NewCaseAddActivityParamsWithTimeout(timeout time.Duration) *CaseAddActivityParams {
	return &CaseAddActivityParams{
		timeout: timeout,
	}
}

// NewCaseAddActivityParamsWithContext creates a new CaseAddActivityParams object
// with the ability to set a context for a request.
func NewCaseAddActivityParamsWithContext(ctx context.Context) *CaseAddActivityParams {
	return &CaseAddActivityParams{
		Context: ctx,
	}
}

// NewCaseAddActivityParamsWithHTTPClient creates a new CaseAddActivityParams object
// with the ability to set a custom HTTPClient for a request.
func NewCaseAddActivityParamsWithHTTPClient(client *http.Client) *CaseAddActivityParams {
	return &CaseAddActivityParams{
		HTTPClient: client,
	}
}

/*
CaseAddActivityParams contains all the parameters to send to the API endpoint

	for the case add activity operation.

	Typically these are written to a http.Request.
*/
type CaseAddActivityParams struct {

	// Body.
	Body *models.APIActivityCreationRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the case add activity params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CaseAddActivityParams) WithDefaults() *CaseAddActivityParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the case add activity params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CaseAddActivityParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the case add activity params
func (o *CaseAddActivityParams) WithTimeout(timeout time.Duration) *CaseAddActivityParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the case add activity params
func (o *CaseAddActivityParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the case add activity params
func (o *CaseAddActivityParams) WithContext(ctx context.Context) *CaseAddActivityParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the case add activity params
func (o *CaseAddActivityParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the case add activity params
func (o *CaseAddActivityParams) WithHTTPClient(client *http.Client) *CaseAddActivityParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the case add activity params
func (o *CaseAddActivityParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the case add activity params
func (o *CaseAddActivityParams) WithBody(body *models.APIActivityCreationRequest) *CaseAddActivityParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the case add activity params
func (o *CaseAddActivityParams) SetBody(body *models.APIActivityCreationRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *CaseAddActivityParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
