// Code generated by go-swagger; DO NOT EDIT.

package message_center

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewCaseDownloadAttachmentParams creates a new CaseDownloadAttachmentParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCaseDownloadAttachmentParams() *CaseDownloadAttachmentParams {
	return &CaseDownloadAttachmentParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCaseDownloadAttachmentParamsWithTimeout creates a new CaseDownloadAttachmentParams object
// with the ability to set a timeout on a request.
func NewCaseDownloadAttachmentParamsWithTimeout(timeout time.Duration) *CaseDownloadAttachmentParams {
	return &CaseDownloadAttachmentParams{
		timeout: timeout,
	}
}

// NewCaseDownloadAttachmentParamsWithContext creates a new CaseDownloadAttachmentParams object
// with the ability to set a context for a request.
func NewCaseDownloadAttachmentParamsWithContext(ctx context.Context) *CaseDownloadAttachmentParams {
	return &CaseDownloadAttachmentParams{
		Context: ctx,
	}
}

// NewCaseDownloadAttachmentParamsWithHTTPClient creates a new CaseDownloadAttachmentParams object
// with the ability to set a custom HTTPClient for a request.
func NewCaseDownloadAttachmentParamsWithHTTPClient(client *http.Client) *CaseDownloadAttachmentParams {
	return &CaseDownloadAttachmentParams{
		HTTPClient: client,
	}
}

/*
CaseDownloadAttachmentParams contains all the parameters to send to the API endpoint

	for the case download attachment operation.

	Typically these are written to a http.Request.
*/
type CaseDownloadAttachmentParams struct {

	/* ID.

	   attachment ID
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the case download attachment params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CaseDownloadAttachmentParams) WithDefaults() *CaseDownloadAttachmentParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the case download attachment params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CaseDownloadAttachmentParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the case download attachment params
func (o *CaseDownloadAttachmentParams) WithTimeout(timeout time.Duration) *CaseDownloadAttachmentParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the case download attachment params
func (o *CaseDownloadAttachmentParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the case download attachment params
func (o *CaseDownloadAttachmentParams) WithContext(ctx context.Context) *CaseDownloadAttachmentParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the case download attachment params
func (o *CaseDownloadAttachmentParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the case download attachment params
func (o *CaseDownloadAttachmentParams) WithHTTPClient(client *http.Client) *CaseDownloadAttachmentParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the case download attachment params
func (o *CaseDownloadAttachmentParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the case download attachment params
func (o *CaseDownloadAttachmentParams) WithID(id string) *CaseDownloadAttachmentParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the case download attachment params
func (o *CaseDownloadAttachmentParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *CaseDownloadAttachmentParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// query param id
	qrID := o.ID
	qID := qrID
	if qID != "" {

		if err := r.SetQueryParam("id", qID); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
