// Code generated by go-swagger; DO NOT EDIT.

package message_center

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewUpdateCaseParams creates a new UpdateCaseParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewUpdateCaseParams() *UpdateCaseParams {
	return &UpdateCaseParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewUpdateCaseParamsWithTimeout creates a new UpdateCaseParams object
// with the ability to set a timeout on a request.
func NewUpdateCaseParamsWithTimeout(timeout time.Duration) *UpdateCaseParams {
	return &UpdateCaseParams{
		timeout: timeout,
	}
}

// NewUpdateCaseParamsWithContext creates a new UpdateCaseParams object
// with the ability to set a context for a request.
func NewUpdateCaseParamsWithContext(ctx context.Context) *UpdateCaseParams {
	return &UpdateCaseParams{
		Context: ctx,
	}
}

// NewUpdateCaseParamsWithHTTPClient creates a new UpdateCaseParams object
// with the ability to set a custom HTTPClient for a request.
func NewUpdateCaseParamsWithHTTPClient(client *http.Client) *UpdateCaseParams {
	return &UpdateCaseParams{
		HTTPClient: client,
	}
}

/*
UpdateCaseParams contains all the parameters to send to the API endpoint

	for the update case operation.

	Typically these are written to a http.Request.
*/
type UpdateCaseParams struct {

	// Body.
	Body *models.APICaseUpdateRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the update case params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateCaseParams) WithDefaults() *UpdateCaseParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the update case params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *UpdateCaseParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the update case params
func (o *UpdateCaseParams) WithTimeout(timeout time.Duration) *UpdateCaseParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the update case params
func (o *UpdateCaseParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the update case params
func (o *UpdateCaseParams) WithContext(ctx context.Context) *UpdateCaseParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the update case params
func (o *UpdateCaseParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the update case params
func (o *UpdateCaseParams) WithHTTPClient(client *http.Client) *UpdateCaseParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the update case params
func (o *UpdateCaseParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the update case params
func (o *UpdateCaseParams) WithBody(body *models.APICaseUpdateRequest) *UpdateCaseParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the update case params
func (o *UpdateCaseParams) SetBody(body *models.APICaseUpdateRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *UpdateCaseParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
