// Code generated by go-swagger; DO NOT EDIT.

package ml_exclusions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// UpdateMLExclusionsV1Reader is a Reader for the UpdateMLExclusionsV1 structure.
type UpdateMLExclusionsV1Reader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UpdateMLExclusionsV1Reader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUpdateMLExclusionsV1OK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewUpdateMLExclusionsV1BadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewUpdateMLExclusionsV1Forbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 429:
		result := NewUpdateMLExclusionsV1TooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewUpdateMLExclusionsV1InternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUpdateMLExclusionsV1Default(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUpdateMLExclusionsV1OK creates a UpdateMLExclusionsV1OK with default headers values
func NewUpdateMLExclusionsV1OK() *UpdateMLExclusionsV1OK {
	return &UpdateMLExclusionsV1OK{}
}

/*
UpdateMLExclusionsV1OK describes a response with status code 200, with default header values.

OK
*/
type UpdateMLExclusionsV1OK struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.ResponsesMlExclusionRespV1
}

// IsSuccess returns true when this update m l exclusions v1 o k response has a 2xx status code
func (o *UpdateMLExclusionsV1OK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this update m l exclusions v1 o k response has a 3xx status code
func (o *UpdateMLExclusionsV1OK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update m l exclusions v1 o k response has a 4xx status code
func (o *UpdateMLExclusionsV1OK) IsClientError() bool {
	return false
}

// IsServerError returns true when this update m l exclusions v1 o k response has a 5xx status code
func (o *UpdateMLExclusionsV1OK) IsServerError() bool {
	return false
}

// IsCode returns true when this update m l exclusions v1 o k response a status code equal to that given
func (o *UpdateMLExclusionsV1OK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the update m l exclusions v1 o k response
func (o *UpdateMLExclusionsV1OK) Code() int {
	return 200
}

func (o *UpdateMLExclusionsV1OK) Error() string {
	return fmt.Sprintf("[PATCH /policy/entities/ml-exclusions/v1][%d] updateMLExclusionsV1OK  %+v", 200, o.Payload)
}

func (o *UpdateMLExclusionsV1OK) String() string {
	return fmt.Sprintf("[PATCH /policy/entities/ml-exclusions/v1][%d] updateMLExclusionsV1OK  %+v", 200, o.Payload)
}

func (o *UpdateMLExclusionsV1OK) GetPayload() *models.ResponsesMlExclusionRespV1 {
	return o.Payload
}

func (o *UpdateMLExclusionsV1OK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.ResponsesMlExclusionRespV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateMLExclusionsV1BadRequest creates a UpdateMLExclusionsV1BadRequest with default headers values
func NewUpdateMLExclusionsV1BadRequest() *UpdateMLExclusionsV1BadRequest {
	return &UpdateMLExclusionsV1BadRequest{}
}

/*
UpdateMLExclusionsV1BadRequest describes a response with status code 400, with default header values.

Bad Request
*/
type UpdateMLExclusionsV1BadRequest struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.ResponsesMlExclusionRespV1
}

// IsSuccess returns true when this update m l exclusions v1 bad request response has a 2xx status code
func (o *UpdateMLExclusionsV1BadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update m l exclusions v1 bad request response has a 3xx status code
func (o *UpdateMLExclusionsV1BadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update m l exclusions v1 bad request response has a 4xx status code
func (o *UpdateMLExclusionsV1BadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this update m l exclusions v1 bad request response has a 5xx status code
func (o *UpdateMLExclusionsV1BadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this update m l exclusions v1 bad request response a status code equal to that given
func (o *UpdateMLExclusionsV1BadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the update m l exclusions v1 bad request response
func (o *UpdateMLExclusionsV1BadRequest) Code() int {
	return 400
}

func (o *UpdateMLExclusionsV1BadRequest) Error() string {
	return fmt.Sprintf("[PATCH /policy/entities/ml-exclusions/v1][%d] updateMLExclusionsV1BadRequest  %+v", 400, o.Payload)
}

func (o *UpdateMLExclusionsV1BadRequest) String() string {
	return fmt.Sprintf("[PATCH /policy/entities/ml-exclusions/v1][%d] updateMLExclusionsV1BadRequest  %+v", 400, o.Payload)
}

func (o *UpdateMLExclusionsV1BadRequest) GetPayload() *models.ResponsesMlExclusionRespV1 {
	return o.Payload
}

func (o *UpdateMLExclusionsV1BadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.ResponsesMlExclusionRespV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateMLExclusionsV1Forbidden creates a UpdateMLExclusionsV1Forbidden with default headers values
func NewUpdateMLExclusionsV1Forbidden() *UpdateMLExclusionsV1Forbidden {
	return &UpdateMLExclusionsV1Forbidden{}
}

/*
UpdateMLExclusionsV1Forbidden describes a response with status code 403, with default header values.

Forbidden
*/
type UpdateMLExclusionsV1Forbidden struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaErrorsOnly
}

// IsSuccess returns true when this update m l exclusions v1 forbidden response has a 2xx status code
func (o *UpdateMLExclusionsV1Forbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update m l exclusions v1 forbidden response has a 3xx status code
func (o *UpdateMLExclusionsV1Forbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update m l exclusions v1 forbidden response has a 4xx status code
func (o *UpdateMLExclusionsV1Forbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this update m l exclusions v1 forbidden response has a 5xx status code
func (o *UpdateMLExclusionsV1Forbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this update m l exclusions v1 forbidden response a status code equal to that given
func (o *UpdateMLExclusionsV1Forbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the update m l exclusions v1 forbidden response
func (o *UpdateMLExclusionsV1Forbidden) Code() int {
	return 403
}

func (o *UpdateMLExclusionsV1Forbidden) Error() string {
	return fmt.Sprintf("[PATCH /policy/entities/ml-exclusions/v1][%d] updateMLExclusionsV1Forbidden  %+v", 403, o.Payload)
}

func (o *UpdateMLExclusionsV1Forbidden) String() string {
	return fmt.Sprintf("[PATCH /policy/entities/ml-exclusions/v1][%d] updateMLExclusionsV1Forbidden  %+v", 403, o.Payload)
}

func (o *UpdateMLExclusionsV1Forbidden) GetPayload() *models.MsaErrorsOnly {
	return o.Payload
}

func (o *UpdateMLExclusionsV1Forbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaErrorsOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateMLExclusionsV1TooManyRequests creates a UpdateMLExclusionsV1TooManyRequests with default headers values
func NewUpdateMLExclusionsV1TooManyRequests() *UpdateMLExclusionsV1TooManyRequests {
	return &UpdateMLExclusionsV1TooManyRequests{}
}

/*
UpdateMLExclusionsV1TooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UpdateMLExclusionsV1TooManyRequests struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	/* Too many requests, retry after this time (as milliseconds since epoch)
	 */
	XRateLimitRetryAfter int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this update m l exclusions v1 too many requests response has a 2xx status code
func (o *UpdateMLExclusionsV1TooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update m l exclusions v1 too many requests response has a 3xx status code
func (o *UpdateMLExclusionsV1TooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update m l exclusions v1 too many requests response has a 4xx status code
func (o *UpdateMLExclusionsV1TooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this update m l exclusions v1 too many requests response has a 5xx status code
func (o *UpdateMLExclusionsV1TooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this update m l exclusions v1 too many requests response a status code equal to that given
func (o *UpdateMLExclusionsV1TooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the update m l exclusions v1 too many requests response
func (o *UpdateMLExclusionsV1TooManyRequests) Code() int {
	return 429
}

func (o *UpdateMLExclusionsV1TooManyRequests) Error() string {
	return fmt.Sprintf("[PATCH /policy/entities/ml-exclusions/v1][%d] updateMLExclusionsV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *UpdateMLExclusionsV1TooManyRequests) String() string {
	return fmt.Sprintf("[PATCH /policy/entities/ml-exclusions/v1][%d] updateMLExclusionsV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *UpdateMLExclusionsV1TooManyRequests) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *UpdateMLExclusionsV1TooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header X-RateLimit-RetryAfter
	hdrXRateLimitRetryAfter := response.GetHeader("X-RateLimit-RetryAfter")

	if hdrXRateLimitRetryAfter != "" {
		valxRateLimitRetryAfter, err := swag.ConvertInt64(hdrXRateLimitRetryAfter)
		if err != nil {
			return errors.InvalidType("X-RateLimit-RetryAfter", "header", "int64", hdrXRateLimitRetryAfter)
		}
		o.XRateLimitRetryAfter = valxRateLimitRetryAfter
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateMLExclusionsV1InternalServerError creates a UpdateMLExclusionsV1InternalServerError with default headers values
func NewUpdateMLExclusionsV1InternalServerError() *UpdateMLExclusionsV1InternalServerError {
	return &UpdateMLExclusionsV1InternalServerError{}
}

/*
UpdateMLExclusionsV1InternalServerError describes a response with status code 500, with default header values.

Internal Server Error
*/
type UpdateMLExclusionsV1InternalServerError struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.ResponsesMlExclusionRespV1
}

// IsSuccess returns true when this update m l exclusions v1 internal server error response has a 2xx status code
func (o *UpdateMLExclusionsV1InternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this update m l exclusions v1 internal server error response has a 3xx status code
func (o *UpdateMLExclusionsV1InternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this update m l exclusions v1 internal server error response has a 4xx status code
func (o *UpdateMLExclusionsV1InternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this update m l exclusions v1 internal server error response has a 5xx status code
func (o *UpdateMLExclusionsV1InternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this update m l exclusions v1 internal server error response a status code equal to that given
func (o *UpdateMLExclusionsV1InternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the update m l exclusions v1 internal server error response
func (o *UpdateMLExclusionsV1InternalServerError) Code() int {
	return 500
}

func (o *UpdateMLExclusionsV1InternalServerError) Error() string {
	return fmt.Sprintf("[PATCH /policy/entities/ml-exclusions/v1][%d] updateMLExclusionsV1InternalServerError  %+v", 500, o.Payload)
}

func (o *UpdateMLExclusionsV1InternalServerError) String() string {
	return fmt.Sprintf("[PATCH /policy/entities/ml-exclusions/v1][%d] updateMLExclusionsV1InternalServerError  %+v", 500, o.Payload)
}

func (o *UpdateMLExclusionsV1InternalServerError) GetPayload() *models.ResponsesMlExclusionRespV1 {
	return o.Payload
}

func (o *UpdateMLExclusionsV1InternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.ResponsesMlExclusionRespV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUpdateMLExclusionsV1Default creates a UpdateMLExclusionsV1Default with default headers values
func NewUpdateMLExclusionsV1Default(code int) *UpdateMLExclusionsV1Default {
	return &UpdateMLExclusionsV1Default{
		_statusCode: code,
	}
}

/*
UpdateMLExclusionsV1Default describes a response with status code -1, with default header values.

OK
*/
type UpdateMLExclusionsV1Default struct {
	_statusCode int

	Payload *models.ResponsesMlExclusionRespV1
}

// IsSuccess returns true when this update m l exclusions v1 default response has a 2xx status code
func (o *UpdateMLExclusionsV1Default) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this update m l exclusions v1 default response has a 3xx status code
func (o *UpdateMLExclusionsV1Default) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this update m l exclusions v1 default response has a 4xx status code
func (o *UpdateMLExclusionsV1Default) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this update m l exclusions v1 default response has a 5xx status code
func (o *UpdateMLExclusionsV1Default) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this update m l exclusions v1 default response a status code equal to that given
func (o *UpdateMLExclusionsV1Default) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the update m l exclusions v1 default response
func (o *UpdateMLExclusionsV1Default) Code() int {
	return o._statusCode
}

func (o *UpdateMLExclusionsV1Default) Error() string {
	return fmt.Sprintf("[PATCH /policy/entities/ml-exclusions/v1][%d] updateMLExclusionsV1 default  %+v", o._statusCode, o.Payload)
}

func (o *UpdateMLExclusionsV1Default) String() string {
	return fmt.Sprintf("[PATCH /policy/entities/ml-exclusions/v1][%d] updateMLExclusionsV1 default  %+v", o._statusCode, o.Payload)
}

func (o *UpdateMLExclusionsV1Default) GetPayload() *models.ResponsesMlExclusionRespV1 {
	return o.Payload
}

func (o *UpdateMLExclusionsV1Default) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ResponsesMlExclusionRespV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
