// Code generated by go-swagger; DO NOT EDIT.

package mssp

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewAddCIDGroupMembersParams creates a new AddCIDGroupMembersParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAddCIDGroupMembersParams() *AddCIDGroupMembersParams {
	return &AddCIDGroupMembersParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAddCIDGroupMembersParamsWithTimeout creates a new AddCIDGroupMembersParams object
// with the ability to set a timeout on a request.
func NewAddCIDGroupMembersParamsWithTimeout(timeout time.Duration) *AddCIDGroupMembersParams {
	return &AddCIDGroupMembersParams{
		timeout: timeout,
	}
}

// NewAddCIDGroupMembersParamsWithContext creates a new AddCIDGroupMembersParams object
// with the ability to set a context for a request.
func NewAddCIDGroupMembersParamsWithContext(ctx context.Context) *AddCIDGroupMembersParams {
	return &AddCIDGroupMembersParams{
		Context: ctx,
	}
}

// NewAddCIDGroupMembersParamsWithHTTPClient creates a new AddCIDGroupMembersParams object
// with the ability to set a custom HTTPClient for a request.
func NewAddCIDGroupMembersParamsWithHTTPClient(client *http.Client) *AddCIDGroupMembersParams {
	return &AddCIDGroupMembersParams{
		HTTPClient: client,
	}
}

/*
AddCIDGroupMembersParams contains all the parameters to send to the API endpoint

	for the add c ID group members operation.

	Typically these are written to a http.Request.
*/
type AddCIDGroupMembersParams struct {

	// Body.
	Body *models.DomainCIDGroupMembersRequestV1

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the add c ID group members params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddCIDGroupMembersParams) WithDefaults() *AddCIDGroupMembersParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the add c ID group members params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AddCIDGroupMembersParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the add c ID group members params
func (o *AddCIDGroupMembersParams) WithTimeout(timeout time.Duration) *AddCIDGroupMembersParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the add c ID group members params
func (o *AddCIDGroupMembersParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the add c ID group members params
func (o *AddCIDGroupMembersParams) WithContext(ctx context.Context) *AddCIDGroupMembersParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the add c ID group members params
func (o *AddCIDGroupMembersParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the add c ID group members params
func (o *AddCIDGroupMembersParams) WithHTTPClient(client *http.Client) *AddCIDGroupMembersParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the add c ID group members params
func (o *AddCIDGroupMembersParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the add c ID group members params
func (o *AddCIDGroupMembersParams) WithBody(body *models.DomainCIDGroupMembersRequestV1) *AddCIDGroupMembersParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the add c ID group members params
func (o *AddCIDGroupMembersParams) SetBody(body *models.DomainCIDGroupMembersRequestV1) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AddCIDGroupMembersParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
