// Code generated by go-swagger; DO NOT EDIT.

package mssp

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewCreateCIDGroupsParams creates a new CreateCIDGroupsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateCIDGroupsParams() *CreateCIDGroupsParams {
	return &CreateCIDGroupsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateCIDGroupsParamsWithTimeout creates a new CreateCIDGroupsParams object
// with the ability to set a timeout on a request.
func NewCreateCIDGroupsParamsWithTimeout(timeout time.Duration) *CreateCIDGroupsParams {
	return &CreateCIDGroupsParams{
		timeout: timeout,
	}
}

// NewCreateCIDGroupsParamsWithContext creates a new CreateCIDGroupsParams object
// with the ability to set a context for a request.
func NewCreateCIDGroupsParamsWithContext(ctx context.Context) *CreateCIDGroupsParams {
	return &CreateCIDGroupsParams{
		Context: ctx,
	}
}

// NewCreateCIDGroupsParamsWithHTTPClient creates a new CreateCIDGroupsParams object
// with the ability to set a custom HTTPClient for a request.
func NewCreateCIDGroupsParamsWithHTTPClient(client *http.Client) *CreateCIDGroupsParams {
	return &CreateCIDGroupsParams{
		HTTPClient: client,
	}
}

/*
CreateCIDGroupsParams contains all the parameters to send to the API endpoint

	for the create c ID groups operation.

	Typically these are written to a http.Request.
*/
type CreateCIDGroupsParams struct {

	// Body.
	Body *models.DomainCIDGroupsRequestV1

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create c ID groups params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateCIDGroupsParams) WithDefaults() *CreateCIDGroupsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create c ID groups params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateCIDGroupsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create c ID groups params
func (o *CreateCIDGroupsParams) WithTimeout(timeout time.Duration) *CreateCIDGroupsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create c ID groups params
func (o *CreateCIDGroupsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create c ID groups params
func (o *CreateCIDGroupsParams) WithContext(ctx context.Context) *CreateCIDGroupsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create c ID groups params
func (o *CreateCIDGroupsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create c ID groups params
func (o *CreateCIDGroupsParams) WithHTTPClient(client *http.Client) *CreateCIDGroupsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create c ID groups params
func (o *CreateCIDGroupsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create c ID groups params
func (o *CreateCIDGroupsParams) WithBody(body *models.DomainCIDGroupsRequestV1) *CreateCIDGroupsParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create c ID groups params
func (o *CreateCIDGroupsParams) SetBody(body *models.DomainCIDGroupsRequestV1) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *CreateCIDGroupsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
