// Code generated by go-swagger; DO NOT EDIT.

package mssp

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewGetChildrenV2Params creates a new GetChildrenV2Params object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetChildrenV2Params() *GetChildrenV2Params {
	return &GetChildrenV2Params{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetChildrenV2ParamsWithTimeout creates a new GetChildrenV2Params object
// with the ability to set a timeout on a request.
func NewGetChildrenV2ParamsWithTimeout(timeout time.Duration) *GetChildrenV2Params {
	return &GetChildrenV2Params{
		timeout: timeout,
	}
}

// NewGetChildrenV2ParamsWithContext creates a new GetChildrenV2Params object
// with the ability to set a context for a request.
func NewGetChildrenV2ParamsWithContext(ctx context.Context) *GetChildrenV2Params {
	return &GetChildrenV2Params{
		Context: ctx,
	}
}

// NewGetChildrenV2ParamsWithHTTPClient creates a new GetChildrenV2Params object
// with the ability to set a custom HTTPClient for a request.
func NewGetChildrenV2ParamsWithHTTPClient(client *http.Client) *GetChildrenV2Params {
	return &GetChildrenV2Params{
		HTTPClient: client,
	}
}

/*
GetChildrenV2Params contains all the parameters to send to the API endpoint

	for the get children v2 operation.

	Typically these are written to a http.Request.
*/
type GetChildrenV2Params struct {

	// Body.
	Body *models.MsaspecIdsRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get children v2 params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetChildrenV2Params) WithDefaults() *GetChildrenV2Params {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get children v2 params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetChildrenV2Params) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get children v2 params
func (o *GetChildrenV2Params) WithTimeout(timeout time.Duration) *GetChildrenV2Params {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get children v2 params
func (o *GetChildrenV2Params) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get children v2 params
func (o *GetChildrenV2Params) WithContext(ctx context.Context) *GetChildrenV2Params {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get children v2 params
func (o *GetChildrenV2Params) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get children v2 params
func (o *GetChildrenV2Params) WithHTTPClient(client *http.Client) *GetChildrenV2Params {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get children v2 params
func (o *GetChildrenV2Params) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the get children v2 params
func (o *GetChildrenV2Params) WithBody(body *models.MsaspecIdsRequest) *GetChildrenV2Params {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the get children v2 params
func (o *GetChildrenV2Params) SetBody(body *models.MsaspecIdsRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *GetChildrenV2Params) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
