// Code generated by go-swagger; DO NOT EDIT.

package ods

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewAggregateScansParams creates a new AggregateScansParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAggregateScansParams() *AggregateScansParams {
	return &AggregateScansParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAggregateScansParamsWithTimeout creates a new AggregateScansParams object
// with the ability to set a timeout on a request.
func NewAggregateScansParamsWithTimeout(timeout time.Duration) *AggregateScansParams {
	return &AggregateScansParams{
		timeout: timeout,
	}
}

// NewAggregateScansParamsWithContext creates a new AggregateScansParams object
// with the ability to set a context for a request.
func NewAggregateScansParamsWithContext(ctx context.Context) *AggregateScansParams {
	return &AggregateScansParams{
		Context: ctx,
	}
}

// NewAggregateScansParamsWithHTTPClient creates a new AggregateScansParams object
// with the ability to set a custom HTTPClient for a request.
func NewAggregateScansParamsWithHTTPClient(client *http.Client) *AggregateScansParams {
	return &AggregateScansParams{
		HTTPClient: client,
	}
}

/*
AggregateScansParams contains all the parameters to send to the API endpoint

	for the aggregate scans operation.

	Typically these are written to a http.Request.
*/
type AggregateScansParams struct {

	// Body.
	Body []*models.MsaAggregateQueryRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the aggregate scans params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AggregateScansParams) WithDefaults() *AggregateScansParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the aggregate scans params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AggregateScansParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the aggregate scans params
func (o *AggregateScansParams) WithTimeout(timeout time.Duration) *AggregateScansParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the aggregate scans params
func (o *AggregateScansParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the aggregate scans params
func (o *AggregateScansParams) WithContext(ctx context.Context) *AggregateScansParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the aggregate scans params
func (o *AggregateScansParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the aggregate scans params
func (o *AggregateScansParams) WithHTTPClient(client *http.Client) *AggregateScansParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the aggregate scans params
func (o *AggregateScansParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the aggregate scans params
func (o *AggregateScansParams) WithBody(body []*models.MsaAggregateQueryRequest) *AggregateScansParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the aggregate scans params
func (o *AggregateScansParams) SetBody(body []*models.MsaAggregateQueryRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AggregateScansParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
