// Code generated by go-swagger; DO NOT EDIT.

package ods

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewAggregateScheduledScansParams creates a new AggregateScheduledScansParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewAggregateScheduledScansParams() *AggregateScheduledScansParams {
	return &AggregateScheduledScansParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewAggregateScheduledScansParamsWithTimeout creates a new AggregateScheduledScansParams object
// with the ability to set a timeout on a request.
func NewAggregateScheduledScansParamsWithTimeout(timeout time.Duration) *AggregateScheduledScansParams {
	return &AggregateScheduledScansParams{
		timeout: timeout,
	}
}

// NewAggregateScheduledScansParamsWithContext creates a new AggregateScheduledScansParams object
// with the ability to set a context for a request.
func NewAggregateScheduledScansParamsWithContext(ctx context.Context) *AggregateScheduledScansParams {
	return &AggregateScheduledScansParams{
		Context: ctx,
	}
}

// NewAggregateScheduledScansParamsWithHTTPClient creates a new AggregateScheduledScansParams object
// with the ability to set a custom HTTPClient for a request.
func NewAggregateScheduledScansParamsWithHTTPClient(client *http.Client) *AggregateScheduledScansParams {
	return &AggregateScheduledScansParams{
		HTTPClient: client,
	}
}

/*
AggregateScheduledScansParams contains all the parameters to send to the API endpoint

	for the aggregate scheduled scans operation.

	Typically these are written to a http.Request.
*/
type AggregateScheduledScansParams struct {

	// Body.
	Body []*models.MsaAggregateQueryRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the aggregate scheduled scans params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AggregateScheduledScansParams) WithDefaults() *AggregateScheduledScansParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the aggregate scheduled scans params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *AggregateScheduledScansParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the aggregate scheduled scans params
func (o *AggregateScheduledScansParams) WithTimeout(timeout time.Duration) *AggregateScheduledScansParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the aggregate scheduled scans params
func (o *AggregateScheduledScansParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the aggregate scheduled scans params
func (o *AggregateScheduledScansParams) WithContext(ctx context.Context) *AggregateScheduledScansParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the aggregate scheduled scans params
func (o *AggregateScheduledScansParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the aggregate scheduled scans params
func (o *AggregateScheduledScansParams) WithHTTPClient(client *http.Client) *AggregateScheduledScansParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the aggregate scheduled scans params
func (o *AggregateScheduledScansParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the aggregate scheduled scans params
func (o *AggregateScheduledScansParams) WithBody(body []*models.MsaAggregateQueryRequest) *AggregateScheduledScansParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the aggregate scheduled scans params
func (o *AggregateScheduledScansParams) SetBody(body []*models.MsaAggregateQueryRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *AggregateScheduledScansParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
