// Code generated by go-swagger; DO NOT EDIT.

package quarantine

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// QueryQuarantineFilesReader is a Reader for the QueryQuarantineFiles structure.
type QueryQuarantineFilesReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *QueryQuarantineFilesReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewQueryQuarantineFilesOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 403:
		result := NewQueryQuarantineFilesForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 429:
		result := NewQueryQuarantineFilesTooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewQueryQuarantineFilesDefault(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewQueryQuarantineFilesOK creates a QueryQuarantineFilesOK with default headers values
func NewQueryQuarantineFilesOK() *QueryQuarantineFilesOK {
	return &QueryQuarantineFilesOK{}
}

/*
QueryQuarantineFilesOK describes a response with status code 200, with default header values.

OK
*/
type QueryQuarantineFilesOK struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaQueryResponse
}

// IsSuccess returns true when this query quarantine files o k response has a 2xx status code
func (o *QueryQuarantineFilesOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this query quarantine files o k response has a 3xx status code
func (o *QueryQuarantineFilesOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query quarantine files o k response has a 4xx status code
func (o *QueryQuarantineFilesOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this query quarantine files o k response has a 5xx status code
func (o *QueryQuarantineFilesOK) IsServerError() bool {
	return false
}

// IsCode returns true when this query quarantine files o k response a status code equal to that given
func (o *QueryQuarantineFilesOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the query quarantine files o k response
func (o *QueryQuarantineFilesOK) Code() int {
	return 200
}

func (o *QueryQuarantineFilesOK) Error() string {
	return fmt.Sprintf("[GET /quarantine/queries/quarantined-files/v1][%d] queryQuarantineFilesOK  %+v", 200, o.Payload)
}

func (o *QueryQuarantineFilesOK) String() string {
	return fmt.Sprintf("[GET /quarantine/queries/quarantined-files/v1][%d] queryQuarantineFilesOK  %+v", 200, o.Payload)
}

func (o *QueryQuarantineFilesOK) GetPayload() *models.MsaQueryResponse {
	return o.Payload
}

func (o *QueryQuarantineFilesOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaQueryResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQueryQuarantineFilesForbidden creates a QueryQuarantineFilesForbidden with default headers values
func NewQueryQuarantineFilesForbidden() *QueryQuarantineFilesForbidden {
	return &QueryQuarantineFilesForbidden{}
}

/*
QueryQuarantineFilesForbidden describes a response with status code 403, with default header values.

Forbidden
*/
type QueryQuarantineFilesForbidden struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this query quarantine files forbidden response has a 2xx status code
func (o *QueryQuarantineFilesForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this query quarantine files forbidden response has a 3xx status code
func (o *QueryQuarantineFilesForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query quarantine files forbidden response has a 4xx status code
func (o *QueryQuarantineFilesForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this query quarantine files forbidden response has a 5xx status code
func (o *QueryQuarantineFilesForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this query quarantine files forbidden response a status code equal to that given
func (o *QueryQuarantineFilesForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the query quarantine files forbidden response
func (o *QueryQuarantineFilesForbidden) Code() int {
	return 403
}

func (o *QueryQuarantineFilesForbidden) Error() string {
	return fmt.Sprintf("[GET /quarantine/queries/quarantined-files/v1][%d] queryQuarantineFilesForbidden  %+v", 403, o.Payload)
}

func (o *QueryQuarantineFilesForbidden) String() string {
	return fmt.Sprintf("[GET /quarantine/queries/quarantined-files/v1][%d] queryQuarantineFilesForbidden  %+v", 403, o.Payload)
}

func (o *QueryQuarantineFilesForbidden) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *QueryQuarantineFilesForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQueryQuarantineFilesTooManyRequests creates a QueryQuarantineFilesTooManyRequests with default headers values
func NewQueryQuarantineFilesTooManyRequests() *QueryQuarantineFilesTooManyRequests {
	return &QueryQuarantineFilesTooManyRequests{}
}

/*
QueryQuarantineFilesTooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type QueryQuarantineFilesTooManyRequests struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	/* Too many requests, retry after this time (as milliseconds since epoch)
	 */
	XRateLimitRetryAfter int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this query quarantine files too many requests response has a 2xx status code
func (o *QueryQuarantineFilesTooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this query quarantine files too many requests response has a 3xx status code
func (o *QueryQuarantineFilesTooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query quarantine files too many requests response has a 4xx status code
func (o *QueryQuarantineFilesTooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this query quarantine files too many requests response has a 5xx status code
func (o *QueryQuarantineFilesTooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this query quarantine files too many requests response a status code equal to that given
func (o *QueryQuarantineFilesTooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the query quarantine files too many requests response
func (o *QueryQuarantineFilesTooManyRequests) Code() int {
	return 429
}

func (o *QueryQuarantineFilesTooManyRequests) Error() string {
	return fmt.Sprintf("[GET /quarantine/queries/quarantined-files/v1][%d] queryQuarantineFilesTooManyRequests  %+v", 429, o.Payload)
}

func (o *QueryQuarantineFilesTooManyRequests) String() string {
	return fmt.Sprintf("[GET /quarantine/queries/quarantined-files/v1][%d] queryQuarantineFilesTooManyRequests  %+v", 429, o.Payload)
}

func (o *QueryQuarantineFilesTooManyRequests) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *QueryQuarantineFilesTooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header X-RateLimit-RetryAfter
	hdrXRateLimitRetryAfter := response.GetHeader("X-RateLimit-RetryAfter")

	if hdrXRateLimitRetryAfter != "" {
		valxRateLimitRetryAfter, err := swag.ConvertInt64(hdrXRateLimitRetryAfter)
		if err != nil {
			return errors.InvalidType("X-RateLimit-RetryAfter", "header", "int64", hdrXRateLimitRetryAfter)
		}
		o.XRateLimitRetryAfter = valxRateLimitRetryAfter
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQueryQuarantineFilesDefault creates a QueryQuarantineFilesDefault with default headers values
func NewQueryQuarantineFilesDefault(code int) *QueryQuarantineFilesDefault {
	return &QueryQuarantineFilesDefault{
		_statusCode: code,
	}
}

/*
QueryQuarantineFilesDefault describes a response with status code -1, with default header values.

OK
*/
type QueryQuarantineFilesDefault struct {
	_statusCode int

	Payload *models.MsaQueryResponse
}

// IsSuccess returns true when this query quarantine files default response has a 2xx status code
func (o *QueryQuarantineFilesDefault) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this query quarantine files default response has a 3xx status code
func (o *QueryQuarantineFilesDefault) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this query quarantine files default response has a 4xx status code
func (o *QueryQuarantineFilesDefault) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this query quarantine files default response has a 5xx status code
func (o *QueryQuarantineFilesDefault) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this query quarantine files default response a status code equal to that given
func (o *QueryQuarantineFilesDefault) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the query quarantine files default response
func (o *QueryQuarantineFilesDefault) Code() int {
	return o._statusCode
}

func (o *QueryQuarantineFilesDefault) Error() string {
	return fmt.Sprintf("[GET /quarantine/queries/quarantined-files/v1][%d] QueryQuarantineFiles default  %+v", o._statusCode, o.Payload)
}

func (o *QueryQuarantineFilesDefault) String() string {
	return fmt.Sprintf("[GET /quarantine/queries/quarantined-files/v1][%d] QueryQuarantineFiles default  %+v", o._statusCode, o.Payload)
}

func (o *QueryQuarantineFilesDefault) GetPayload() *models.MsaQueryResponse {
	return o.Payload
}

func (o *QueryQuarantineFilesDefault) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.MsaQueryResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
