// Code generated by go-swagger; DO NOT EDIT.

package real_time_response

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewRTRListQueuedSessionsParams creates a new RTRListQueuedSessionsParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewRTRListQueuedSessionsParams() *RTRListQueuedSessionsParams {
	return &RTRListQueuedSessionsParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewRTRListQueuedSessionsParamsWithTimeout creates a new RTRListQueuedSessionsParams object
// with the ability to set a timeout on a request.
func NewRTRListQueuedSessionsParamsWithTimeout(timeout time.Duration) *RTRListQueuedSessionsParams {
	return &RTRListQueuedSessionsParams{
		timeout: timeout,
	}
}

// NewRTRListQueuedSessionsParamsWithContext creates a new RTRListQueuedSessionsParams object
// with the ability to set a context for a request.
func NewRTRListQueuedSessionsParamsWithContext(ctx context.Context) *RTRListQueuedSessionsParams {
	return &RTRListQueuedSessionsParams{
		Context: ctx,
	}
}

// NewRTRListQueuedSessionsParamsWithHTTPClient creates a new RTRListQueuedSessionsParams object
// with the ability to set a custom HTTPClient for a request.
func NewRTRListQueuedSessionsParamsWithHTTPClient(client *http.Client) *RTRListQueuedSessionsParams {
	return &RTRListQueuedSessionsParams{
		HTTPClient: client,
	}
}

/*
RTRListQueuedSessionsParams contains all the parameters to send to the API endpoint

	for the r t r list queued sessions operation.

	Typically these are written to a http.Request.
*/
type RTRListQueuedSessionsParams struct {

	/* Body.

	 **`ids`** List of RTR sessions to retrieve.  RTR will only return the sessions that were created by the calling user
	 */
	Body *models.MsaIdsRequest

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the r t r list queued sessions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RTRListQueuedSessionsParams) WithDefaults() *RTRListQueuedSessionsParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the r t r list queued sessions params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *RTRListQueuedSessionsParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the r t r list queued sessions params
func (o *RTRListQueuedSessionsParams) WithTimeout(timeout time.Duration) *RTRListQueuedSessionsParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the r t r list queued sessions params
func (o *RTRListQueuedSessionsParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the r t r list queued sessions params
func (o *RTRListQueuedSessionsParams) WithContext(ctx context.Context) *RTRListQueuedSessionsParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the r t r list queued sessions params
func (o *RTRListQueuedSessionsParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the r t r list queued sessions params
func (o *RTRListQueuedSessionsParams) WithHTTPClient(client *http.Client) *RTRListQueuedSessionsParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the r t r list queued sessions params
func (o *RTRListQueuedSessionsParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the r t r list queued sessions params
func (o *RTRListQueuedSessionsParams) WithBody(body *models.MsaIdsRequest) *RTRListQueuedSessionsParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the r t r list queued sessions params
func (o *RTRListQueuedSessionsParams) SetBody(body *models.MsaIdsRequest) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *RTRListQueuedSessionsParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
