// Code generated by go-swagger; DO NOT EDIT.

package recon

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewCreateRulesV1Params creates a new CreateRulesV1Params object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewCreateRulesV1Params() *CreateRulesV1Params {
	return &CreateRulesV1Params{
		timeout: cr.DefaultTimeout,
	}
}

// NewCreateRulesV1ParamsWithTimeout creates a new CreateRulesV1Params object
// with the ability to set a timeout on a request.
func NewCreateRulesV1ParamsWithTimeout(timeout time.Duration) *CreateRulesV1Params {
	return &CreateRulesV1Params{
		timeout: timeout,
	}
}

// NewCreateRulesV1ParamsWithContext creates a new CreateRulesV1Params object
// with the ability to set a context for a request.
func NewCreateRulesV1ParamsWithContext(ctx context.Context) *CreateRulesV1Params {
	return &CreateRulesV1Params{
		Context: ctx,
	}
}

// NewCreateRulesV1ParamsWithHTTPClient creates a new CreateRulesV1Params object
// with the ability to set a custom HTTPClient for a request.
func NewCreateRulesV1ParamsWithHTTPClient(client *http.Client) *CreateRulesV1Params {
	return &CreateRulesV1Params{
		HTTPClient: client,
	}
}

/*
CreateRulesV1Params contains all the parameters to send to the API endpoint

	for the create rules v1 operation.

	Typically these are written to a http.Request.
*/
type CreateRulesV1Params struct {

	// Body.
	Body []*models.SadomainCreateRuleRequestV1

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the create rules v1 params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateRulesV1Params) WithDefaults() *CreateRulesV1Params {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the create rules v1 params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *CreateRulesV1Params) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the create rules v1 params
func (o *CreateRulesV1Params) WithTimeout(timeout time.Duration) *CreateRulesV1Params {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the create rules v1 params
func (o *CreateRulesV1Params) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the create rules v1 params
func (o *CreateRulesV1Params) WithContext(ctx context.Context) *CreateRulesV1Params {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the create rules v1 params
func (o *CreateRulesV1Params) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the create rules v1 params
func (o *CreateRulesV1Params) WithHTTPClient(client *http.Client) *CreateRulesV1Params {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the create rules v1 params
func (o *CreateRulesV1Params) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the create rules v1 params
func (o *CreateRulesV1Params) WithBody(body []*models.SadomainCreateRuleRequestV1) *CreateRulesV1Params {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the create rules v1 params
func (o *CreateRulesV1Params) SetBody(body []*models.SadomainCreateRuleRequestV1) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *CreateRulesV1Params) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
