// Code generated by go-swagger; DO NOT EDIT.

package sample_uploads

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// ExtractionGetV1Reader is a Reader for the ExtractionGetV1 structure.
type ExtractionGetV1Reader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ExtractionGetV1Reader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewExtractionGetV1OK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewExtractionGetV1BadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewExtractionGetV1Forbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 429:
		result := NewExtractionGetV1TooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewExtractionGetV1InternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewExtractionGetV1Default(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewExtractionGetV1OK creates a ExtractionGetV1OK with default headers values
func NewExtractionGetV1OK() *ExtractionGetV1OK {
	return &ExtractionGetV1OK{}
}

/*
ExtractionGetV1OK describes a response with status code 200, with default header values.

OK
*/
type ExtractionGetV1OK struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.ClientExtractionCreateResponseV1
}

// IsSuccess returns true when this extraction get v1 o k response has a 2xx status code
func (o *ExtractionGetV1OK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this extraction get v1 o k response has a 3xx status code
func (o *ExtractionGetV1OK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this extraction get v1 o k response has a 4xx status code
func (o *ExtractionGetV1OK) IsClientError() bool {
	return false
}

// IsServerError returns true when this extraction get v1 o k response has a 5xx status code
func (o *ExtractionGetV1OK) IsServerError() bool {
	return false
}

// IsCode returns true when this extraction get v1 o k response a status code equal to that given
func (o *ExtractionGetV1OK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the extraction get v1 o k response
func (o *ExtractionGetV1OK) Code() int {
	return 200
}

func (o *ExtractionGetV1OK) Error() string {
	return fmt.Sprintf("[GET /archives/entities/extractions/v1][%d] extractionGetV1OK  %+v", 200, o.Payload)
}

func (o *ExtractionGetV1OK) String() string {
	return fmt.Sprintf("[GET /archives/entities/extractions/v1][%d] extractionGetV1OK  %+v", 200, o.Payload)
}

func (o *ExtractionGetV1OK) GetPayload() *models.ClientExtractionCreateResponseV1 {
	return o.Payload
}

func (o *ExtractionGetV1OK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.ClientExtractionCreateResponseV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewExtractionGetV1BadRequest creates a ExtractionGetV1BadRequest with default headers values
func NewExtractionGetV1BadRequest() *ExtractionGetV1BadRequest {
	return &ExtractionGetV1BadRequest{}
}

/*
ExtractionGetV1BadRequest describes a response with status code 400, with default header values.

Bad Request
*/
type ExtractionGetV1BadRequest struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.ClientExtractionCreateResponseV1
}

// IsSuccess returns true when this extraction get v1 bad request response has a 2xx status code
func (o *ExtractionGetV1BadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this extraction get v1 bad request response has a 3xx status code
func (o *ExtractionGetV1BadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this extraction get v1 bad request response has a 4xx status code
func (o *ExtractionGetV1BadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this extraction get v1 bad request response has a 5xx status code
func (o *ExtractionGetV1BadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this extraction get v1 bad request response a status code equal to that given
func (o *ExtractionGetV1BadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the extraction get v1 bad request response
func (o *ExtractionGetV1BadRequest) Code() int {
	return 400
}

func (o *ExtractionGetV1BadRequest) Error() string {
	return fmt.Sprintf("[GET /archives/entities/extractions/v1][%d] extractionGetV1BadRequest  %+v", 400, o.Payload)
}

func (o *ExtractionGetV1BadRequest) String() string {
	return fmt.Sprintf("[GET /archives/entities/extractions/v1][%d] extractionGetV1BadRequest  %+v", 400, o.Payload)
}

func (o *ExtractionGetV1BadRequest) GetPayload() *models.ClientExtractionCreateResponseV1 {
	return o.Payload
}

func (o *ExtractionGetV1BadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.ClientExtractionCreateResponseV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewExtractionGetV1Forbidden creates a ExtractionGetV1Forbidden with default headers values
func NewExtractionGetV1Forbidden() *ExtractionGetV1Forbidden {
	return &ExtractionGetV1Forbidden{}
}

/*
ExtractionGetV1Forbidden describes a response with status code 403, with default header values.

Forbidden
*/
type ExtractionGetV1Forbidden struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this extraction get v1 forbidden response has a 2xx status code
func (o *ExtractionGetV1Forbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this extraction get v1 forbidden response has a 3xx status code
func (o *ExtractionGetV1Forbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this extraction get v1 forbidden response has a 4xx status code
func (o *ExtractionGetV1Forbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this extraction get v1 forbidden response has a 5xx status code
func (o *ExtractionGetV1Forbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this extraction get v1 forbidden response a status code equal to that given
func (o *ExtractionGetV1Forbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the extraction get v1 forbidden response
func (o *ExtractionGetV1Forbidden) Code() int {
	return 403
}

func (o *ExtractionGetV1Forbidden) Error() string {
	return fmt.Sprintf("[GET /archives/entities/extractions/v1][%d] extractionGetV1Forbidden  %+v", 403, o.Payload)
}

func (o *ExtractionGetV1Forbidden) String() string {
	return fmt.Sprintf("[GET /archives/entities/extractions/v1][%d] extractionGetV1Forbidden  %+v", 403, o.Payload)
}

func (o *ExtractionGetV1Forbidden) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *ExtractionGetV1Forbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewExtractionGetV1TooManyRequests creates a ExtractionGetV1TooManyRequests with default headers values
func NewExtractionGetV1TooManyRequests() *ExtractionGetV1TooManyRequests {
	return &ExtractionGetV1TooManyRequests{}
}

/*
ExtractionGetV1TooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type ExtractionGetV1TooManyRequests struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	/* Too many requests, retry after this time (as milliseconds since epoch)
	 */
	XRateLimitRetryAfter int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this extraction get v1 too many requests response has a 2xx status code
func (o *ExtractionGetV1TooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this extraction get v1 too many requests response has a 3xx status code
func (o *ExtractionGetV1TooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this extraction get v1 too many requests response has a 4xx status code
func (o *ExtractionGetV1TooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this extraction get v1 too many requests response has a 5xx status code
func (o *ExtractionGetV1TooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this extraction get v1 too many requests response a status code equal to that given
func (o *ExtractionGetV1TooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the extraction get v1 too many requests response
func (o *ExtractionGetV1TooManyRequests) Code() int {
	return 429
}

func (o *ExtractionGetV1TooManyRequests) Error() string {
	return fmt.Sprintf("[GET /archives/entities/extractions/v1][%d] extractionGetV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *ExtractionGetV1TooManyRequests) String() string {
	return fmt.Sprintf("[GET /archives/entities/extractions/v1][%d] extractionGetV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *ExtractionGetV1TooManyRequests) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *ExtractionGetV1TooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header X-RateLimit-RetryAfter
	hdrXRateLimitRetryAfter := response.GetHeader("X-RateLimit-RetryAfter")

	if hdrXRateLimitRetryAfter != "" {
		valxRateLimitRetryAfter, err := swag.ConvertInt64(hdrXRateLimitRetryAfter)
		if err != nil {
			return errors.InvalidType("X-RateLimit-RetryAfter", "header", "int64", hdrXRateLimitRetryAfter)
		}
		o.XRateLimitRetryAfter = valxRateLimitRetryAfter
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewExtractionGetV1InternalServerError creates a ExtractionGetV1InternalServerError with default headers values
func NewExtractionGetV1InternalServerError() *ExtractionGetV1InternalServerError {
	return &ExtractionGetV1InternalServerError{}
}

/*
ExtractionGetV1InternalServerError describes a response with status code 500, with default header values.

Internal Server Error
*/
type ExtractionGetV1InternalServerError struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.ClientExtractionCreateResponseV1
}

// IsSuccess returns true when this extraction get v1 internal server error response has a 2xx status code
func (o *ExtractionGetV1InternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this extraction get v1 internal server error response has a 3xx status code
func (o *ExtractionGetV1InternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this extraction get v1 internal server error response has a 4xx status code
func (o *ExtractionGetV1InternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this extraction get v1 internal server error response has a 5xx status code
func (o *ExtractionGetV1InternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this extraction get v1 internal server error response a status code equal to that given
func (o *ExtractionGetV1InternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the extraction get v1 internal server error response
func (o *ExtractionGetV1InternalServerError) Code() int {
	return 500
}

func (o *ExtractionGetV1InternalServerError) Error() string {
	return fmt.Sprintf("[GET /archives/entities/extractions/v1][%d] extractionGetV1InternalServerError  %+v", 500, o.Payload)
}

func (o *ExtractionGetV1InternalServerError) String() string {
	return fmt.Sprintf("[GET /archives/entities/extractions/v1][%d] extractionGetV1InternalServerError  %+v", 500, o.Payload)
}

func (o *ExtractionGetV1InternalServerError) GetPayload() *models.ClientExtractionCreateResponseV1 {
	return o.Payload
}

func (o *ExtractionGetV1InternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.ClientExtractionCreateResponseV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewExtractionGetV1Default creates a ExtractionGetV1Default with default headers values
func NewExtractionGetV1Default(code int) *ExtractionGetV1Default {
	return &ExtractionGetV1Default{
		_statusCode: code,
	}
}

/*
ExtractionGetV1Default describes a response with status code -1, with default header values.

OK
*/
type ExtractionGetV1Default struct {
	_statusCode int

	Payload *models.ClientExtractionCreateResponseV1
}

// IsSuccess returns true when this extraction get v1 default response has a 2xx status code
func (o *ExtractionGetV1Default) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this extraction get v1 default response has a 3xx status code
func (o *ExtractionGetV1Default) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this extraction get v1 default response has a 4xx status code
func (o *ExtractionGetV1Default) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this extraction get v1 default response has a 5xx status code
func (o *ExtractionGetV1Default) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this extraction get v1 default response a status code equal to that given
func (o *ExtractionGetV1Default) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the extraction get v1 default response
func (o *ExtractionGetV1Default) Code() int {
	return o._statusCode
}

func (o *ExtractionGetV1Default) Error() string {
	return fmt.Sprintf("[GET /archives/entities/extractions/v1][%d] ExtractionGetV1 default  %+v", o._statusCode, o.Payload)
}

func (o *ExtractionGetV1Default) String() string {
	return fmt.Sprintf("[GET /archives/entities/extractions/v1][%d] ExtractionGetV1 default  %+v", o._statusCode, o.Payload)
}

func (o *ExtractionGetV1Default) GetPayload() *models.ClientExtractionCreateResponseV1 {
	return o.Payload
}

func (o *ExtractionGetV1Default) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ClientExtractionCreateResponseV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
