// Code generated by go-swagger; DO NOT EDIT.

package scheduled_reports

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// NewScheduledReportsLaunchParams creates a new ScheduledReportsLaunchParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewScheduledReportsLaunchParams() *ScheduledReportsLaunchParams {
	return &ScheduledReportsLaunchParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewScheduledReportsLaunchParamsWithTimeout creates a new ScheduledReportsLaunchParams object
// with the ability to set a timeout on a request.
func NewScheduledReportsLaunchParamsWithTimeout(timeout time.Duration) *ScheduledReportsLaunchParams {
	return &ScheduledReportsLaunchParams{
		timeout: timeout,
	}
}

// NewScheduledReportsLaunchParamsWithContext creates a new ScheduledReportsLaunchParams object
// with the ability to set a context for a request.
func NewScheduledReportsLaunchParamsWithContext(ctx context.Context) *ScheduledReportsLaunchParams {
	return &ScheduledReportsLaunchParams{
		Context: ctx,
	}
}

// NewScheduledReportsLaunchParamsWithHTTPClient creates a new ScheduledReportsLaunchParams object
// with the ability to set a custom HTTPClient for a request.
func NewScheduledReportsLaunchParamsWithHTTPClient(client *http.Client) *ScheduledReportsLaunchParams {
	return &ScheduledReportsLaunchParams{
		HTTPClient: client,
	}
}

/*
ScheduledReportsLaunchParams contains all the parameters to send to the API endpoint

	for the scheduled reports launch operation.

	Typically these are written to a http.Request.
*/
type ScheduledReportsLaunchParams struct {

	// Body.
	Body []*models.APIReportExecutionLaunchRequestV1

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the scheduled reports launch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ScheduledReportsLaunchParams) WithDefaults() *ScheduledReportsLaunchParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the scheduled reports launch params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *ScheduledReportsLaunchParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the scheduled reports launch params
func (o *ScheduledReportsLaunchParams) WithTimeout(timeout time.Duration) *ScheduledReportsLaunchParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the scheduled reports launch params
func (o *ScheduledReportsLaunchParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the scheduled reports launch params
func (o *ScheduledReportsLaunchParams) WithContext(ctx context.Context) *ScheduledReportsLaunchParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the scheduled reports launch params
func (o *ScheduledReportsLaunchParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the scheduled reports launch params
func (o *ScheduledReportsLaunchParams) WithHTTPClient(client *http.Client) *ScheduledReportsLaunchParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the scheduled reports launch params
func (o *ScheduledReportsLaunchParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithBody adds the body to the scheduled reports launch params
func (o *ScheduledReportsLaunchParams) WithBody(body []*models.APIReportExecutionLaunchRequestV1) *ScheduledReportsLaunchParams {
	o.SetBody(body)
	return o
}

// SetBody adds the body to the scheduled reports launch params
func (o *ScheduledReportsLaunchParams) SetBody(body []*models.APIReportExecutionLaunchRequestV1) {
	o.Body = body
}

// WriteToRequest writes these params to a swagger request
func (o *ScheduledReportsLaunchParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error
	if o.Body != nil {
		if err := r.SetBodyParam(o.Body); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
