// Code generated by go-swagger; DO NOT EDIT.

package sensor_visibility_exclusions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// CreateSVExclusionsV1Reader is a Reader for the CreateSVExclusionsV1 structure.
type CreateSVExclusionsV1Reader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateSVExclusionsV1Reader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewCreateSVExclusionsV1OK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewCreateSVExclusionsV1BadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewCreateSVExclusionsV1Forbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 429:
		result := NewCreateSVExclusionsV1TooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewCreateSVExclusionsV1InternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewCreateSVExclusionsV1Default(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewCreateSVExclusionsV1OK creates a CreateSVExclusionsV1OK with default headers values
func NewCreateSVExclusionsV1OK() *CreateSVExclusionsV1OK {
	return &CreateSVExclusionsV1OK{}
}

/*
CreateSVExclusionsV1OK describes a response with status code 200, with default header values.

OK
*/
type CreateSVExclusionsV1OK struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.ResponsesMlExclusionRespV1
}

// IsSuccess returns true when this create s v exclusions v1 o k response has a 2xx status code
func (o *CreateSVExclusionsV1OK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this create s v exclusions v1 o k response has a 3xx status code
func (o *CreateSVExclusionsV1OK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create s v exclusions v1 o k response has a 4xx status code
func (o *CreateSVExclusionsV1OK) IsClientError() bool {
	return false
}

// IsServerError returns true when this create s v exclusions v1 o k response has a 5xx status code
func (o *CreateSVExclusionsV1OK) IsServerError() bool {
	return false
}

// IsCode returns true when this create s v exclusions v1 o k response a status code equal to that given
func (o *CreateSVExclusionsV1OK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the create s v exclusions v1 o k response
func (o *CreateSVExclusionsV1OK) Code() int {
	return 200
}

func (o *CreateSVExclusionsV1OK) Error() string {
	return fmt.Sprintf("[POST /policy/entities/sv-exclusions/v1][%d] createSVExclusionsV1OK  %+v", 200, o.Payload)
}

func (o *CreateSVExclusionsV1OK) String() string {
	return fmt.Sprintf("[POST /policy/entities/sv-exclusions/v1][%d] createSVExclusionsV1OK  %+v", 200, o.Payload)
}

func (o *CreateSVExclusionsV1OK) GetPayload() *models.ResponsesMlExclusionRespV1 {
	return o.Payload
}

func (o *CreateSVExclusionsV1OK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.ResponsesMlExclusionRespV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateSVExclusionsV1BadRequest creates a CreateSVExclusionsV1BadRequest with default headers values
func NewCreateSVExclusionsV1BadRequest() *CreateSVExclusionsV1BadRequest {
	return &CreateSVExclusionsV1BadRequest{}
}

/*
CreateSVExclusionsV1BadRequest describes a response with status code 400, with default header values.

Bad Request
*/
type CreateSVExclusionsV1BadRequest struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.ResponsesMlExclusionRespV1
}

// IsSuccess returns true when this create s v exclusions v1 bad request response has a 2xx status code
func (o *CreateSVExclusionsV1BadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create s v exclusions v1 bad request response has a 3xx status code
func (o *CreateSVExclusionsV1BadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create s v exclusions v1 bad request response has a 4xx status code
func (o *CreateSVExclusionsV1BadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this create s v exclusions v1 bad request response has a 5xx status code
func (o *CreateSVExclusionsV1BadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this create s v exclusions v1 bad request response a status code equal to that given
func (o *CreateSVExclusionsV1BadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the create s v exclusions v1 bad request response
func (o *CreateSVExclusionsV1BadRequest) Code() int {
	return 400
}

func (o *CreateSVExclusionsV1BadRequest) Error() string {
	return fmt.Sprintf("[POST /policy/entities/sv-exclusions/v1][%d] createSVExclusionsV1BadRequest  %+v", 400, o.Payload)
}

func (o *CreateSVExclusionsV1BadRequest) String() string {
	return fmt.Sprintf("[POST /policy/entities/sv-exclusions/v1][%d] createSVExclusionsV1BadRequest  %+v", 400, o.Payload)
}

func (o *CreateSVExclusionsV1BadRequest) GetPayload() *models.ResponsesMlExclusionRespV1 {
	return o.Payload
}

func (o *CreateSVExclusionsV1BadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.ResponsesMlExclusionRespV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateSVExclusionsV1Forbidden creates a CreateSVExclusionsV1Forbidden with default headers values
func NewCreateSVExclusionsV1Forbidden() *CreateSVExclusionsV1Forbidden {
	return &CreateSVExclusionsV1Forbidden{}
}

/*
CreateSVExclusionsV1Forbidden describes a response with status code 403, with default header values.

Forbidden
*/
type CreateSVExclusionsV1Forbidden struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaErrorsOnly
}

// IsSuccess returns true when this create s v exclusions v1 forbidden response has a 2xx status code
func (o *CreateSVExclusionsV1Forbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create s v exclusions v1 forbidden response has a 3xx status code
func (o *CreateSVExclusionsV1Forbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create s v exclusions v1 forbidden response has a 4xx status code
func (o *CreateSVExclusionsV1Forbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this create s v exclusions v1 forbidden response has a 5xx status code
func (o *CreateSVExclusionsV1Forbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this create s v exclusions v1 forbidden response a status code equal to that given
func (o *CreateSVExclusionsV1Forbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the create s v exclusions v1 forbidden response
func (o *CreateSVExclusionsV1Forbidden) Code() int {
	return 403
}

func (o *CreateSVExclusionsV1Forbidden) Error() string {
	return fmt.Sprintf("[POST /policy/entities/sv-exclusions/v1][%d] createSVExclusionsV1Forbidden  %+v", 403, o.Payload)
}

func (o *CreateSVExclusionsV1Forbidden) String() string {
	return fmt.Sprintf("[POST /policy/entities/sv-exclusions/v1][%d] createSVExclusionsV1Forbidden  %+v", 403, o.Payload)
}

func (o *CreateSVExclusionsV1Forbidden) GetPayload() *models.MsaErrorsOnly {
	return o.Payload
}

func (o *CreateSVExclusionsV1Forbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaErrorsOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateSVExclusionsV1TooManyRequests creates a CreateSVExclusionsV1TooManyRequests with default headers values
func NewCreateSVExclusionsV1TooManyRequests() *CreateSVExclusionsV1TooManyRequests {
	return &CreateSVExclusionsV1TooManyRequests{}
}

/*
CreateSVExclusionsV1TooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type CreateSVExclusionsV1TooManyRequests struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	/* Too many requests, retry after this time (as milliseconds since epoch)
	 */
	XRateLimitRetryAfter int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this create s v exclusions v1 too many requests response has a 2xx status code
func (o *CreateSVExclusionsV1TooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create s v exclusions v1 too many requests response has a 3xx status code
func (o *CreateSVExclusionsV1TooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create s v exclusions v1 too many requests response has a 4xx status code
func (o *CreateSVExclusionsV1TooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this create s v exclusions v1 too many requests response has a 5xx status code
func (o *CreateSVExclusionsV1TooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this create s v exclusions v1 too many requests response a status code equal to that given
func (o *CreateSVExclusionsV1TooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the create s v exclusions v1 too many requests response
func (o *CreateSVExclusionsV1TooManyRequests) Code() int {
	return 429
}

func (o *CreateSVExclusionsV1TooManyRequests) Error() string {
	return fmt.Sprintf("[POST /policy/entities/sv-exclusions/v1][%d] createSVExclusionsV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *CreateSVExclusionsV1TooManyRequests) String() string {
	return fmt.Sprintf("[POST /policy/entities/sv-exclusions/v1][%d] createSVExclusionsV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *CreateSVExclusionsV1TooManyRequests) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *CreateSVExclusionsV1TooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header X-RateLimit-RetryAfter
	hdrXRateLimitRetryAfter := response.GetHeader("X-RateLimit-RetryAfter")

	if hdrXRateLimitRetryAfter != "" {
		valxRateLimitRetryAfter, err := swag.ConvertInt64(hdrXRateLimitRetryAfter)
		if err != nil {
			return errors.InvalidType("X-RateLimit-RetryAfter", "header", "int64", hdrXRateLimitRetryAfter)
		}
		o.XRateLimitRetryAfter = valxRateLimitRetryAfter
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateSVExclusionsV1InternalServerError creates a CreateSVExclusionsV1InternalServerError with default headers values
func NewCreateSVExclusionsV1InternalServerError() *CreateSVExclusionsV1InternalServerError {
	return &CreateSVExclusionsV1InternalServerError{}
}

/*
CreateSVExclusionsV1InternalServerError describes a response with status code 500, with default header values.

Internal Server Error
*/
type CreateSVExclusionsV1InternalServerError struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.ResponsesMlExclusionRespV1
}

// IsSuccess returns true when this create s v exclusions v1 internal server error response has a 2xx status code
func (o *CreateSVExclusionsV1InternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create s v exclusions v1 internal server error response has a 3xx status code
func (o *CreateSVExclusionsV1InternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create s v exclusions v1 internal server error response has a 4xx status code
func (o *CreateSVExclusionsV1InternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this create s v exclusions v1 internal server error response has a 5xx status code
func (o *CreateSVExclusionsV1InternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this create s v exclusions v1 internal server error response a status code equal to that given
func (o *CreateSVExclusionsV1InternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the create s v exclusions v1 internal server error response
func (o *CreateSVExclusionsV1InternalServerError) Code() int {
	return 500
}

func (o *CreateSVExclusionsV1InternalServerError) Error() string {
	return fmt.Sprintf("[POST /policy/entities/sv-exclusions/v1][%d] createSVExclusionsV1InternalServerError  %+v", 500, o.Payload)
}

func (o *CreateSVExclusionsV1InternalServerError) String() string {
	return fmt.Sprintf("[POST /policy/entities/sv-exclusions/v1][%d] createSVExclusionsV1InternalServerError  %+v", 500, o.Payload)
}

func (o *CreateSVExclusionsV1InternalServerError) GetPayload() *models.ResponsesMlExclusionRespV1 {
	return o.Payload
}

func (o *CreateSVExclusionsV1InternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.ResponsesMlExclusionRespV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateSVExclusionsV1Default creates a CreateSVExclusionsV1Default with default headers values
func NewCreateSVExclusionsV1Default(code int) *CreateSVExclusionsV1Default {
	return &CreateSVExclusionsV1Default{
		_statusCode: code,
	}
}

/*
CreateSVExclusionsV1Default describes a response with status code -1, with default header values.

OK
*/
type CreateSVExclusionsV1Default struct {
	_statusCode int

	Payload *models.ResponsesMlExclusionRespV1
}

// IsSuccess returns true when this create s v exclusions v1 default response has a 2xx status code
func (o *CreateSVExclusionsV1Default) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this create s v exclusions v1 default response has a 3xx status code
func (o *CreateSVExclusionsV1Default) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this create s v exclusions v1 default response has a 4xx status code
func (o *CreateSVExclusionsV1Default) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this create s v exclusions v1 default response has a 5xx status code
func (o *CreateSVExclusionsV1Default) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this create s v exclusions v1 default response a status code equal to that given
func (o *CreateSVExclusionsV1Default) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the create s v exclusions v1 default response
func (o *CreateSVExclusionsV1Default) Code() int {
	return o._statusCode
}

func (o *CreateSVExclusionsV1Default) Error() string {
	return fmt.Sprintf("[POST /policy/entities/sv-exclusions/v1][%d] createSVExclusionsV1 default  %+v", o._statusCode, o.Payload)
}

func (o *CreateSVExclusionsV1Default) String() string {
	return fmt.Sprintf("[POST /policy/entities/sv-exclusions/v1][%d] createSVExclusionsV1 default  %+v", o._statusCode, o.Payload)
}

func (o *CreateSVExclusionsV1Default) GetPayload() *models.ResponsesMlExclusionRespV1 {
	return o.Payload
}

func (o *CreateSVExclusionsV1Default) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ResponsesMlExclusionRespV1)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
