// Code generated by go-swagger; DO NOT EDIT.

package sensor_visibility_exclusions

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// QuerySensorVisibilityExclusionsV1Reader is a Reader for the QuerySensorVisibilityExclusionsV1 structure.
type QuerySensorVisibilityExclusionsV1Reader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *QuerySensorVisibilityExclusionsV1Reader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewQuerySensorVisibilityExclusionsV1OK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewQuerySensorVisibilityExclusionsV1BadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewQuerySensorVisibilityExclusionsV1Forbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 429:
		result := NewQuerySensorVisibilityExclusionsV1TooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewQuerySensorVisibilityExclusionsV1InternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewQuerySensorVisibilityExclusionsV1Default(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewQuerySensorVisibilityExclusionsV1OK creates a QuerySensorVisibilityExclusionsV1OK with default headers values
func NewQuerySensorVisibilityExclusionsV1OK() *QuerySensorVisibilityExclusionsV1OK {
	return &QuerySensorVisibilityExclusionsV1OK{}
}

/*
QuerySensorVisibilityExclusionsV1OK describes a response with status code 200, with default header values.

OK
*/
type QuerySensorVisibilityExclusionsV1OK struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaQueryResponse
}

// IsSuccess returns true when this query sensor visibility exclusions v1 o k response has a 2xx status code
func (o *QuerySensorVisibilityExclusionsV1OK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this query sensor visibility exclusions v1 o k response has a 3xx status code
func (o *QuerySensorVisibilityExclusionsV1OK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query sensor visibility exclusions v1 o k response has a 4xx status code
func (o *QuerySensorVisibilityExclusionsV1OK) IsClientError() bool {
	return false
}

// IsServerError returns true when this query sensor visibility exclusions v1 o k response has a 5xx status code
func (o *QuerySensorVisibilityExclusionsV1OK) IsServerError() bool {
	return false
}

// IsCode returns true when this query sensor visibility exclusions v1 o k response a status code equal to that given
func (o *QuerySensorVisibilityExclusionsV1OK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the query sensor visibility exclusions v1 o k response
func (o *QuerySensorVisibilityExclusionsV1OK) Code() int {
	return 200
}

func (o *QuerySensorVisibilityExclusionsV1OK) Error() string {
	return fmt.Sprintf("[GET /policy/queries/sv-exclusions/v1][%d] querySensorVisibilityExclusionsV1OK  %+v", 200, o.Payload)
}

func (o *QuerySensorVisibilityExclusionsV1OK) String() string {
	return fmt.Sprintf("[GET /policy/queries/sv-exclusions/v1][%d] querySensorVisibilityExclusionsV1OK  %+v", 200, o.Payload)
}

func (o *QuerySensorVisibilityExclusionsV1OK) GetPayload() *models.MsaQueryResponse {
	return o.Payload
}

func (o *QuerySensorVisibilityExclusionsV1OK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaQueryResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQuerySensorVisibilityExclusionsV1BadRequest creates a QuerySensorVisibilityExclusionsV1BadRequest with default headers values
func NewQuerySensorVisibilityExclusionsV1BadRequest() *QuerySensorVisibilityExclusionsV1BadRequest {
	return &QuerySensorVisibilityExclusionsV1BadRequest{}
}

/*
QuerySensorVisibilityExclusionsV1BadRequest describes a response with status code 400, with default header values.

Bad Request
*/
type QuerySensorVisibilityExclusionsV1BadRequest struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaQueryResponse
}

// IsSuccess returns true when this query sensor visibility exclusions v1 bad request response has a 2xx status code
func (o *QuerySensorVisibilityExclusionsV1BadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this query sensor visibility exclusions v1 bad request response has a 3xx status code
func (o *QuerySensorVisibilityExclusionsV1BadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query sensor visibility exclusions v1 bad request response has a 4xx status code
func (o *QuerySensorVisibilityExclusionsV1BadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this query sensor visibility exclusions v1 bad request response has a 5xx status code
func (o *QuerySensorVisibilityExclusionsV1BadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this query sensor visibility exclusions v1 bad request response a status code equal to that given
func (o *QuerySensorVisibilityExclusionsV1BadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the query sensor visibility exclusions v1 bad request response
func (o *QuerySensorVisibilityExclusionsV1BadRequest) Code() int {
	return 400
}

func (o *QuerySensorVisibilityExclusionsV1BadRequest) Error() string {
	return fmt.Sprintf("[GET /policy/queries/sv-exclusions/v1][%d] querySensorVisibilityExclusionsV1BadRequest  %+v", 400, o.Payload)
}

func (o *QuerySensorVisibilityExclusionsV1BadRequest) String() string {
	return fmt.Sprintf("[GET /policy/queries/sv-exclusions/v1][%d] querySensorVisibilityExclusionsV1BadRequest  %+v", 400, o.Payload)
}

func (o *QuerySensorVisibilityExclusionsV1BadRequest) GetPayload() *models.MsaQueryResponse {
	return o.Payload
}

func (o *QuerySensorVisibilityExclusionsV1BadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaQueryResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQuerySensorVisibilityExclusionsV1Forbidden creates a QuerySensorVisibilityExclusionsV1Forbidden with default headers values
func NewQuerySensorVisibilityExclusionsV1Forbidden() *QuerySensorVisibilityExclusionsV1Forbidden {
	return &QuerySensorVisibilityExclusionsV1Forbidden{}
}

/*
QuerySensorVisibilityExclusionsV1Forbidden describes a response with status code 403, with default header values.

Forbidden
*/
type QuerySensorVisibilityExclusionsV1Forbidden struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaErrorsOnly
}

// IsSuccess returns true when this query sensor visibility exclusions v1 forbidden response has a 2xx status code
func (o *QuerySensorVisibilityExclusionsV1Forbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this query sensor visibility exclusions v1 forbidden response has a 3xx status code
func (o *QuerySensorVisibilityExclusionsV1Forbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query sensor visibility exclusions v1 forbidden response has a 4xx status code
func (o *QuerySensorVisibilityExclusionsV1Forbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this query sensor visibility exclusions v1 forbidden response has a 5xx status code
func (o *QuerySensorVisibilityExclusionsV1Forbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this query sensor visibility exclusions v1 forbidden response a status code equal to that given
func (o *QuerySensorVisibilityExclusionsV1Forbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the query sensor visibility exclusions v1 forbidden response
func (o *QuerySensorVisibilityExclusionsV1Forbidden) Code() int {
	return 403
}

func (o *QuerySensorVisibilityExclusionsV1Forbidden) Error() string {
	return fmt.Sprintf("[GET /policy/queries/sv-exclusions/v1][%d] querySensorVisibilityExclusionsV1Forbidden  %+v", 403, o.Payload)
}

func (o *QuerySensorVisibilityExclusionsV1Forbidden) String() string {
	return fmt.Sprintf("[GET /policy/queries/sv-exclusions/v1][%d] querySensorVisibilityExclusionsV1Forbidden  %+v", 403, o.Payload)
}

func (o *QuerySensorVisibilityExclusionsV1Forbidden) GetPayload() *models.MsaErrorsOnly {
	return o.Payload
}

func (o *QuerySensorVisibilityExclusionsV1Forbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaErrorsOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQuerySensorVisibilityExclusionsV1TooManyRequests creates a QuerySensorVisibilityExclusionsV1TooManyRequests with default headers values
func NewQuerySensorVisibilityExclusionsV1TooManyRequests() *QuerySensorVisibilityExclusionsV1TooManyRequests {
	return &QuerySensorVisibilityExclusionsV1TooManyRequests{}
}

/*
QuerySensorVisibilityExclusionsV1TooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type QuerySensorVisibilityExclusionsV1TooManyRequests struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	/* Too many requests, retry after this time (as milliseconds since epoch)
	 */
	XRateLimitRetryAfter int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this query sensor visibility exclusions v1 too many requests response has a 2xx status code
func (o *QuerySensorVisibilityExclusionsV1TooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this query sensor visibility exclusions v1 too many requests response has a 3xx status code
func (o *QuerySensorVisibilityExclusionsV1TooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query sensor visibility exclusions v1 too many requests response has a 4xx status code
func (o *QuerySensorVisibilityExclusionsV1TooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this query sensor visibility exclusions v1 too many requests response has a 5xx status code
func (o *QuerySensorVisibilityExclusionsV1TooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this query sensor visibility exclusions v1 too many requests response a status code equal to that given
func (o *QuerySensorVisibilityExclusionsV1TooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the query sensor visibility exclusions v1 too many requests response
func (o *QuerySensorVisibilityExclusionsV1TooManyRequests) Code() int {
	return 429
}

func (o *QuerySensorVisibilityExclusionsV1TooManyRequests) Error() string {
	return fmt.Sprintf("[GET /policy/queries/sv-exclusions/v1][%d] querySensorVisibilityExclusionsV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *QuerySensorVisibilityExclusionsV1TooManyRequests) String() string {
	return fmt.Sprintf("[GET /policy/queries/sv-exclusions/v1][%d] querySensorVisibilityExclusionsV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *QuerySensorVisibilityExclusionsV1TooManyRequests) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *QuerySensorVisibilityExclusionsV1TooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header X-RateLimit-RetryAfter
	hdrXRateLimitRetryAfter := response.GetHeader("X-RateLimit-RetryAfter")

	if hdrXRateLimitRetryAfter != "" {
		valxRateLimitRetryAfter, err := swag.ConvertInt64(hdrXRateLimitRetryAfter)
		if err != nil {
			return errors.InvalidType("X-RateLimit-RetryAfter", "header", "int64", hdrXRateLimitRetryAfter)
		}
		o.XRateLimitRetryAfter = valxRateLimitRetryAfter
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQuerySensorVisibilityExclusionsV1InternalServerError creates a QuerySensorVisibilityExclusionsV1InternalServerError with default headers values
func NewQuerySensorVisibilityExclusionsV1InternalServerError() *QuerySensorVisibilityExclusionsV1InternalServerError {
	return &QuerySensorVisibilityExclusionsV1InternalServerError{}
}

/*
QuerySensorVisibilityExclusionsV1InternalServerError describes a response with status code 500, with default header values.

Internal Server Error
*/
type QuerySensorVisibilityExclusionsV1InternalServerError struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaQueryResponse
}

// IsSuccess returns true when this query sensor visibility exclusions v1 internal server error response has a 2xx status code
func (o *QuerySensorVisibilityExclusionsV1InternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this query sensor visibility exclusions v1 internal server error response has a 3xx status code
func (o *QuerySensorVisibilityExclusionsV1InternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this query sensor visibility exclusions v1 internal server error response has a 4xx status code
func (o *QuerySensorVisibilityExclusionsV1InternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this query sensor visibility exclusions v1 internal server error response has a 5xx status code
func (o *QuerySensorVisibilityExclusionsV1InternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this query sensor visibility exclusions v1 internal server error response a status code equal to that given
func (o *QuerySensorVisibilityExclusionsV1InternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the query sensor visibility exclusions v1 internal server error response
func (o *QuerySensorVisibilityExclusionsV1InternalServerError) Code() int {
	return 500
}

func (o *QuerySensorVisibilityExclusionsV1InternalServerError) Error() string {
	return fmt.Sprintf("[GET /policy/queries/sv-exclusions/v1][%d] querySensorVisibilityExclusionsV1InternalServerError  %+v", 500, o.Payload)
}

func (o *QuerySensorVisibilityExclusionsV1InternalServerError) String() string {
	return fmt.Sprintf("[GET /policy/queries/sv-exclusions/v1][%d] querySensorVisibilityExclusionsV1InternalServerError  %+v", 500, o.Payload)
}

func (o *QuerySensorVisibilityExclusionsV1InternalServerError) GetPayload() *models.MsaQueryResponse {
	return o.Payload
}

func (o *QuerySensorVisibilityExclusionsV1InternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaQueryResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewQuerySensorVisibilityExclusionsV1Default creates a QuerySensorVisibilityExclusionsV1Default with default headers values
func NewQuerySensorVisibilityExclusionsV1Default(code int) *QuerySensorVisibilityExclusionsV1Default {
	return &QuerySensorVisibilityExclusionsV1Default{
		_statusCode: code,
	}
}

/*
QuerySensorVisibilityExclusionsV1Default describes a response with status code -1, with default header values.

OK
*/
type QuerySensorVisibilityExclusionsV1Default struct {
	_statusCode int

	Payload *models.MsaQueryResponse
}

// IsSuccess returns true when this query sensor visibility exclusions v1 default response has a 2xx status code
func (o *QuerySensorVisibilityExclusionsV1Default) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this query sensor visibility exclusions v1 default response has a 3xx status code
func (o *QuerySensorVisibilityExclusionsV1Default) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this query sensor visibility exclusions v1 default response has a 4xx status code
func (o *QuerySensorVisibilityExclusionsV1Default) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this query sensor visibility exclusions v1 default response has a 5xx status code
func (o *QuerySensorVisibilityExclusionsV1Default) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this query sensor visibility exclusions v1 default response a status code equal to that given
func (o *QuerySensorVisibilityExclusionsV1Default) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the query sensor visibility exclusions v1 default response
func (o *QuerySensorVisibilityExclusionsV1Default) Code() int {
	return o._statusCode
}

func (o *QuerySensorVisibilityExclusionsV1Default) Error() string {
	return fmt.Sprintf("[GET /policy/queries/sv-exclusions/v1][%d] querySensorVisibilityExclusionsV1 default  %+v", o._statusCode, o.Payload)
}

func (o *QuerySensorVisibilityExclusionsV1Default) String() string {
	return fmt.Sprintf("[GET /policy/queries/sv-exclusions/v1][%d] querySensorVisibilityExclusionsV1 default  %+v", o._statusCode, o.Payload)
}

func (o *QuerySensorVisibilityExclusionsV1Default) GetPayload() *models.MsaQueryResponse {
	return o.Payload
}

func (o *QuerySensorVisibilityExclusionsV1Default) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.MsaQueryResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
