// Code generated by go-swagger; DO NOT EDIT.

package tailored_intelligence

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/strfmt"
)

// NewGetEventsBodyParams creates a new GetEventsBodyParams object,
// with the default timeout for this client.
//
// Default values are not hydrated, since defaults are normally applied by the API server side.
//
// To enforce default values in parameter, use SetDefaults or WithDefaults.
func NewGetEventsBodyParams() *GetEventsBodyParams {
	return &GetEventsBodyParams{
		timeout: cr.DefaultTimeout,
	}
}

// NewGetEventsBodyParamsWithTimeout creates a new GetEventsBodyParams object
// with the ability to set a timeout on a request.
func NewGetEventsBodyParamsWithTimeout(timeout time.Duration) *GetEventsBodyParams {
	return &GetEventsBodyParams{
		timeout: timeout,
	}
}

// NewGetEventsBodyParamsWithContext creates a new GetEventsBodyParams object
// with the ability to set a context for a request.
func NewGetEventsBodyParamsWithContext(ctx context.Context) *GetEventsBodyParams {
	return &GetEventsBodyParams{
		Context: ctx,
	}
}

// NewGetEventsBodyParamsWithHTTPClient creates a new GetEventsBodyParams object
// with the ability to set a custom HTTPClient for a request.
func NewGetEventsBodyParamsWithHTTPClient(client *http.Client) *GetEventsBodyParams {
	return &GetEventsBodyParams{
		HTTPClient: client,
	}
}

/*
GetEventsBodyParams contains all the parameters to send to the API endpoint

	for the get events body operation.

	Typically these are written to a http.Request.
*/
type GetEventsBodyParams struct {

	/* ID.

	   Return the event body for event id.
	*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithDefaults hydrates default values in the get events body params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetEventsBodyParams) WithDefaults() *GetEventsBodyParams {
	o.SetDefaults()
	return o
}

// SetDefaults hydrates default values in the get events body params (not the query body).
//
// All values with no default are reset to their zero value.
func (o *GetEventsBodyParams) SetDefaults() {
	// no default values defined for this parameter
}

// WithTimeout adds the timeout to the get events body params
func (o *GetEventsBodyParams) WithTimeout(timeout time.Duration) *GetEventsBodyParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the get events body params
func (o *GetEventsBodyParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the get events body params
func (o *GetEventsBodyParams) WithContext(ctx context.Context) *GetEventsBodyParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the get events body params
func (o *GetEventsBodyParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the get events body params
func (o *GetEventsBodyParams) WithHTTPClient(client *http.Client) *GetEventsBodyParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the get events body params
func (o *GetEventsBodyParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the get events body params
func (o *GetEventsBodyParams) WithID(id string) *GetEventsBodyParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the get events body params
func (o *GetEventsBodyParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *GetEventsBodyParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// query param id
	qrID := o.ID
	qID := qrID
	if qID != "" {

		if err := r.SetQueryParam("id", qID); err != nil {
			return err
		}
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
