// Code generated by go-swagger; DO NOT EDIT.

package user_management

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// RetrieveUsersGETV1Reader is a Reader for the RetrieveUsersGETV1 structure.
type RetrieveUsersGETV1Reader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *RetrieveUsersGETV1Reader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewRetrieveUsersGETV1OK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewRetrieveUsersGETV1BadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewRetrieveUsersGETV1Forbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 429:
		result := NewRetrieveUsersGETV1TooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewRetrieveUsersGETV1InternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewRetrieveUsersGETV1Default(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewRetrieveUsersGETV1OK creates a RetrieveUsersGETV1OK with default headers values
func NewRetrieveUsersGETV1OK() *RetrieveUsersGETV1OK {
	return &RetrieveUsersGETV1OK{}
}

/*
RetrieveUsersGETV1OK describes a response with status code 200, with default header values.

OK
*/
type RetrieveUsersGETV1OK struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.DomainMsaEntitiesUsersResponse
}

// IsSuccess returns true when this retrieve users g e t v1 o k response has a 2xx status code
func (o *RetrieveUsersGETV1OK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this retrieve users g e t v1 o k response has a 3xx status code
func (o *RetrieveUsersGETV1OK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this retrieve users g e t v1 o k response has a 4xx status code
func (o *RetrieveUsersGETV1OK) IsClientError() bool {
	return false
}

// IsServerError returns true when this retrieve users g e t v1 o k response has a 5xx status code
func (o *RetrieveUsersGETV1OK) IsServerError() bool {
	return false
}

// IsCode returns true when this retrieve users g e t v1 o k response a status code equal to that given
func (o *RetrieveUsersGETV1OK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the retrieve users g e t v1 o k response
func (o *RetrieveUsersGETV1OK) Code() int {
	return 200
}

func (o *RetrieveUsersGETV1OK) Error() string {
	return fmt.Sprintf("[POST /user-management/entities/users/GET/v1][%d] retrieveUsersGETV1OK  %+v", 200, o.Payload)
}

func (o *RetrieveUsersGETV1OK) String() string {
	return fmt.Sprintf("[POST /user-management/entities/users/GET/v1][%d] retrieveUsersGETV1OK  %+v", 200, o.Payload)
}

func (o *RetrieveUsersGETV1OK) GetPayload() *models.DomainMsaEntitiesUsersResponse {
	return o.Payload
}

func (o *RetrieveUsersGETV1OK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.DomainMsaEntitiesUsersResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewRetrieveUsersGETV1BadRequest creates a RetrieveUsersGETV1BadRequest with default headers values
func NewRetrieveUsersGETV1BadRequest() *RetrieveUsersGETV1BadRequest {
	return &RetrieveUsersGETV1BadRequest{}
}

/*
RetrieveUsersGETV1BadRequest describes a response with status code 400, with default header values.

Bad Request
*/
type RetrieveUsersGETV1BadRequest struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.DomainMsaEntitiesUsersResponse
}

// IsSuccess returns true when this retrieve users g e t v1 bad request response has a 2xx status code
func (o *RetrieveUsersGETV1BadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this retrieve users g e t v1 bad request response has a 3xx status code
func (o *RetrieveUsersGETV1BadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this retrieve users g e t v1 bad request response has a 4xx status code
func (o *RetrieveUsersGETV1BadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this retrieve users g e t v1 bad request response has a 5xx status code
func (o *RetrieveUsersGETV1BadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this retrieve users g e t v1 bad request response a status code equal to that given
func (o *RetrieveUsersGETV1BadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the retrieve users g e t v1 bad request response
func (o *RetrieveUsersGETV1BadRequest) Code() int {
	return 400
}

func (o *RetrieveUsersGETV1BadRequest) Error() string {
	return fmt.Sprintf("[POST /user-management/entities/users/GET/v1][%d] retrieveUsersGETV1BadRequest  %+v", 400, o.Payload)
}

func (o *RetrieveUsersGETV1BadRequest) String() string {
	return fmt.Sprintf("[POST /user-management/entities/users/GET/v1][%d] retrieveUsersGETV1BadRequest  %+v", 400, o.Payload)
}

func (o *RetrieveUsersGETV1BadRequest) GetPayload() *models.DomainMsaEntitiesUsersResponse {
	return o.Payload
}

func (o *RetrieveUsersGETV1BadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.DomainMsaEntitiesUsersResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewRetrieveUsersGETV1Forbidden creates a RetrieveUsersGETV1Forbidden with default headers values
func NewRetrieveUsersGETV1Forbidden() *RetrieveUsersGETV1Forbidden {
	return &RetrieveUsersGETV1Forbidden{}
}

/*
RetrieveUsersGETV1Forbidden describes a response with status code 403, with default header values.

Forbidden
*/
type RetrieveUsersGETV1Forbidden struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.DomainMsaEntitiesUsersResponse
}

// IsSuccess returns true when this retrieve users g e t v1 forbidden response has a 2xx status code
func (o *RetrieveUsersGETV1Forbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this retrieve users g e t v1 forbidden response has a 3xx status code
func (o *RetrieveUsersGETV1Forbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this retrieve users g e t v1 forbidden response has a 4xx status code
func (o *RetrieveUsersGETV1Forbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this retrieve users g e t v1 forbidden response has a 5xx status code
func (o *RetrieveUsersGETV1Forbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this retrieve users g e t v1 forbidden response a status code equal to that given
func (o *RetrieveUsersGETV1Forbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the retrieve users g e t v1 forbidden response
func (o *RetrieveUsersGETV1Forbidden) Code() int {
	return 403
}

func (o *RetrieveUsersGETV1Forbidden) Error() string {
	return fmt.Sprintf("[POST /user-management/entities/users/GET/v1][%d] retrieveUsersGETV1Forbidden  %+v", 403, o.Payload)
}

func (o *RetrieveUsersGETV1Forbidden) String() string {
	return fmt.Sprintf("[POST /user-management/entities/users/GET/v1][%d] retrieveUsersGETV1Forbidden  %+v", 403, o.Payload)
}

func (o *RetrieveUsersGETV1Forbidden) GetPayload() *models.DomainMsaEntitiesUsersResponse {
	return o.Payload
}

func (o *RetrieveUsersGETV1Forbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.DomainMsaEntitiesUsersResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewRetrieveUsersGETV1TooManyRequests creates a RetrieveUsersGETV1TooManyRequests with default headers values
func NewRetrieveUsersGETV1TooManyRequests() *RetrieveUsersGETV1TooManyRequests {
	return &RetrieveUsersGETV1TooManyRequests{}
}

/*
RetrieveUsersGETV1TooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type RetrieveUsersGETV1TooManyRequests struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	/* Too many requests, retry after this time (as milliseconds since epoch)
	 */
	XRateLimitRetryAfter int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this retrieve users g e t v1 too many requests response has a 2xx status code
func (o *RetrieveUsersGETV1TooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this retrieve users g e t v1 too many requests response has a 3xx status code
func (o *RetrieveUsersGETV1TooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this retrieve users g e t v1 too many requests response has a 4xx status code
func (o *RetrieveUsersGETV1TooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this retrieve users g e t v1 too many requests response has a 5xx status code
func (o *RetrieveUsersGETV1TooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this retrieve users g e t v1 too many requests response a status code equal to that given
func (o *RetrieveUsersGETV1TooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the retrieve users g e t v1 too many requests response
func (o *RetrieveUsersGETV1TooManyRequests) Code() int {
	return 429
}

func (o *RetrieveUsersGETV1TooManyRequests) Error() string {
	return fmt.Sprintf("[POST /user-management/entities/users/GET/v1][%d] retrieveUsersGETV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *RetrieveUsersGETV1TooManyRequests) String() string {
	return fmt.Sprintf("[POST /user-management/entities/users/GET/v1][%d] retrieveUsersGETV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *RetrieveUsersGETV1TooManyRequests) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *RetrieveUsersGETV1TooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header X-RateLimit-RetryAfter
	hdrXRateLimitRetryAfter := response.GetHeader("X-RateLimit-RetryAfter")

	if hdrXRateLimitRetryAfter != "" {
		valxRateLimitRetryAfter, err := swag.ConvertInt64(hdrXRateLimitRetryAfter)
		if err != nil {
			return errors.InvalidType("X-RateLimit-RetryAfter", "header", "int64", hdrXRateLimitRetryAfter)
		}
		o.XRateLimitRetryAfter = valxRateLimitRetryAfter
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewRetrieveUsersGETV1InternalServerError creates a RetrieveUsersGETV1InternalServerError with default headers values
func NewRetrieveUsersGETV1InternalServerError() *RetrieveUsersGETV1InternalServerError {
	return &RetrieveUsersGETV1InternalServerError{}
}

/*
RetrieveUsersGETV1InternalServerError describes a response with status code 500, with default header values.

Internal Server Error
*/
type RetrieveUsersGETV1InternalServerError struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.DomainMsaEntitiesUsersResponse
}

// IsSuccess returns true when this retrieve users g e t v1 internal server error response has a 2xx status code
func (o *RetrieveUsersGETV1InternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this retrieve users g e t v1 internal server error response has a 3xx status code
func (o *RetrieveUsersGETV1InternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this retrieve users g e t v1 internal server error response has a 4xx status code
func (o *RetrieveUsersGETV1InternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this retrieve users g e t v1 internal server error response has a 5xx status code
func (o *RetrieveUsersGETV1InternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this retrieve users g e t v1 internal server error response a status code equal to that given
func (o *RetrieveUsersGETV1InternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the retrieve users g e t v1 internal server error response
func (o *RetrieveUsersGETV1InternalServerError) Code() int {
	return 500
}

func (o *RetrieveUsersGETV1InternalServerError) Error() string {
	return fmt.Sprintf("[POST /user-management/entities/users/GET/v1][%d] retrieveUsersGETV1InternalServerError  %+v", 500, o.Payload)
}

func (o *RetrieveUsersGETV1InternalServerError) String() string {
	return fmt.Sprintf("[POST /user-management/entities/users/GET/v1][%d] retrieveUsersGETV1InternalServerError  %+v", 500, o.Payload)
}

func (o *RetrieveUsersGETV1InternalServerError) GetPayload() *models.DomainMsaEntitiesUsersResponse {
	return o.Payload
}

func (o *RetrieveUsersGETV1InternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.DomainMsaEntitiesUsersResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewRetrieveUsersGETV1Default creates a RetrieveUsersGETV1Default with default headers values
func NewRetrieveUsersGETV1Default(code int) *RetrieveUsersGETV1Default {
	return &RetrieveUsersGETV1Default{
		_statusCode: code,
	}
}

/*
RetrieveUsersGETV1Default describes a response with status code -1, with default header values.

OK
*/
type RetrieveUsersGETV1Default struct {
	_statusCode int

	Payload *models.DomainMsaEntitiesUsersResponse
}

// IsSuccess returns true when this retrieve users g e t v1 default response has a 2xx status code
func (o *RetrieveUsersGETV1Default) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this retrieve users g e t v1 default response has a 3xx status code
func (o *RetrieveUsersGETV1Default) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this retrieve users g e t v1 default response has a 4xx status code
func (o *RetrieveUsersGETV1Default) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this retrieve users g e t v1 default response has a 5xx status code
func (o *RetrieveUsersGETV1Default) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this retrieve users g e t v1 default response a status code equal to that given
func (o *RetrieveUsersGETV1Default) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the retrieve users g e t v1 default response
func (o *RetrieveUsersGETV1Default) Code() int {
	return o._statusCode
}

func (o *RetrieveUsersGETV1Default) Error() string {
	return fmt.Sprintf("[POST /user-management/entities/users/GET/v1][%d] retrieveUsersGETV1 default  %+v", o._statusCode, o.Payload)
}

func (o *RetrieveUsersGETV1Default) String() string {
	return fmt.Sprintf("[POST /user-management/entities/users/GET/v1][%d] retrieveUsersGETV1 default  %+v", o._statusCode, o.Payload)
}

func (o *RetrieveUsersGETV1Default) GetPayload() *models.DomainMsaEntitiesUsersResponse {
	return o.Payload
}

func (o *RetrieveUsersGETV1Default) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.DomainMsaEntitiesUsersResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
