// Code generated by go-swagger; DO NOT EDIT.

package user_management

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// UserRolesActionV1Reader is a Reader for the UserRolesActionV1 structure.
type UserRolesActionV1Reader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *UserRolesActionV1Reader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewUserRolesActionV1OK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewUserRolesActionV1BadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewUserRolesActionV1Forbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 429:
		result := NewUserRolesActionV1TooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewUserRolesActionV1InternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewUserRolesActionV1Default(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewUserRolesActionV1OK creates a UserRolesActionV1OK with default headers values
func NewUserRolesActionV1OK() *UserRolesActionV1OK {
	return &UserRolesActionV1OK{}
}

/*
UserRolesActionV1OK describes a response with status code 200, with default header values.

OK
*/
type UserRolesActionV1OK struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this user roles action v1 o k response has a 2xx status code
func (o *UserRolesActionV1OK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this user roles action v1 o k response has a 3xx status code
func (o *UserRolesActionV1OK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this user roles action v1 o k response has a 4xx status code
func (o *UserRolesActionV1OK) IsClientError() bool {
	return false
}

// IsServerError returns true when this user roles action v1 o k response has a 5xx status code
func (o *UserRolesActionV1OK) IsServerError() bool {
	return false
}

// IsCode returns true when this user roles action v1 o k response a status code equal to that given
func (o *UserRolesActionV1OK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the user roles action v1 o k response
func (o *UserRolesActionV1OK) Code() int {
	return 200
}

func (o *UserRolesActionV1OK) Error() string {
	return fmt.Sprintf("[POST /user-management/entities/user-role-actions/v1][%d] userRolesActionV1OK  %+v", 200, o.Payload)
}

func (o *UserRolesActionV1OK) String() string {
	return fmt.Sprintf("[POST /user-management/entities/user-role-actions/v1][%d] userRolesActionV1OK  %+v", 200, o.Payload)
}

func (o *UserRolesActionV1OK) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *UserRolesActionV1OK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUserRolesActionV1BadRequest creates a UserRolesActionV1BadRequest with default headers values
func NewUserRolesActionV1BadRequest() *UserRolesActionV1BadRequest {
	return &UserRolesActionV1BadRequest{}
}

/*
UserRolesActionV1BadRequest describes a response with status code 400, with default header values.

Bad Request
*/
type UserRolesActionV1BadRequest struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this user roles action v1 bad request response has a 2xx status code
func (o *UserRolesActionV1BadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this user roles action v1 bad request response has a 3xx status code
func (o *UserRolesActionV1BadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this user roles action v1 bad request response has a 4xx status code
func (o *UserRolesActionV1BadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this user roles action v1 bad request response has a 5xx status code
func (o *UserRolesActionV1BadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this user roles action v1 bad request response a status code equal to that given
func (o *UserRolesActionV1BadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the user roles action v1 bad request response
func (o *UserRolesActionV1BadRequest) Code() int {
	return 400
}

func (o *UserRolesActionV1BadRequest) Error() string {
	return fmt.Sprintf("[POST /user-management/entities/user-role-actions/v1][%d] userRolesActionV1BadRequest  %+v", 400, o.Payload)
}

func (o *UserRolesActionV1BadRequest) String() string {
	return fmt.Sprintf("[POST /user-management/entities/user-role-actions/v1][%d] userRolesActionV1BadRequest  %+v", 400, o.Payload)
}

func (o *UserRolesActionV1BadRequest) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *UserRolesActionV1BadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUserRolesActionV1Forbidden creates a UserRolesActionV1Forbidden with default headers values
func NewUserRolesActionV1Forbidden() *UserRolesActionV1Forbidden {
	return &UserRolesActionV1Forbidden{}
}

/*
UserRolesActionV1Forbidden describes a response with status code 403, with default header values.

Forbidden
*/
type UserRolesActionV1Forbidden struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaErrorsOnly
}

// IsSuccess returns true when this user roles action v1 forbidden response has a 2xx status code
func (o *UserRolesActionV1Forbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this user roles action v1 forbidden response has a 3xx status code
func (o *UserRolesActionV1Forbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this user roles action v1 forbidden response has a 4xx status code
func (o *UserRolesActionV1Forbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this user roles action v1 forbidden response has a 5xx status code
func (o *UserRolesActionV1Forbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this user roles action v1 forbidden response a status code equal to that given
func (o *UserRolesActionV1Forbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the user roles action v1 forbidden response
func (o *UserRolesActionV1Forbidden) Code() int {
	return 403
}

func (o *UserRolesActionV1Forbidden) Error() string {
	return fmt.Sprintf("[POST /user-management/entities/user-role-actions/v1][%d] userRolesActionV1Forbidden  %+v", 403, o.Payload)
}

func (o *UserRolesActionV1Forbidden) String() string {
	return fmt.Sprintf("[POST /user-management/entities/user-role-actions/v1][%d] userRolesActionV1Forbidden  %+v", 403, o.Payload)
}

func (o *UserRolesActionV1Forbidden) GetPayload() *models.MsaErrorsOnly {
	return o.Payload
}

func (o *UserRolesActionV1Forbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaErrorsOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUserRolesActionV1TooManyRequests creates a UserRolesActionV1TooManyRequests with default headers values
func NewUserRolesActionV1TooManyRequests() *UserRolesActionV1TooManyRequests {
	return &UserRolesActionV1TooManyRequests{}
}

/*
UserRolesActionV1TooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type UserRolesActionV1TooManyRequests struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	/* Too many requests, retry after this time (as milliseconds since epoch)
	 */
	XRateLimitRetryAfter int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this user roles action v1 too many requests response has a 2xx status code
func (o *UserRolesActionV1TooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this user roles action v1 too many requests response has a 3xx status code
func (o *UserRolesActionV1TooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this user roles action v1 too many requests response has a 4xx status code
func (o *UserRolesActionV1TooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this user roles action v1 too many requests response has a 5xx status code
func (o *UserRolesActionV1TooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this user roles action v1 too many requests response a status code equal to that given
func (o *UserRolesActionV1TooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the user roles action v1 too many requests response
func (o *UserRolesActionV1TooManyRequests) Code() int {
	return 429
}

func (o *UserRolesActionV1TooManyRequests) Error() string {
	return fmt.Sprintf("[POST /user-management/entities/user-role-actions/v1][%d] userRolesActionV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *UserRolesActionV1TooManyRequests) String() string {
	return fmt.Sprintf("[POST /user-management/entities/user-role-actions/v1][%d] userRolesActionV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *UserRolesActionV1TooManyRequests) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *UserRolesActionV1TooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header X-RateLimit-RetryAfter
	hdrXRateLimitRetryAfter := response.GetHeader("X-RateLimit-RetryAfter")

	if hdrXRateLimitRetryAfter != "" {
		valxRateLimitRetryAfter, err := swag.ConvertInt64(hdrXRateLimitRetryAfter)
		if err != nil {
			return errors.InvalidType("X-RateLimit-RetryAfter", "header", "int64", hdrXRateLimitRetryAfter)
		}
		o.XRateLimitRetryAfter = valxRateLimitRetryAfter
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUserRolesActionV1InternalServerError creates a UserRolesActionV1InternalServerError with default headers values
func NewUserRolesActionV1InternalServerError() *UserRolesActionV1InternalServerError {
	return &UserRolesActionV1InternalServerError{}
}

/*
UserRolesActionV1InternalServerError describes a response with status code 500, with default header values.

Internal Server Error
*/
type UserRolesActionV1InternalServerError struct {

	/* Trace-ID: submit to support if resolving an issue
	 */
	XCSTRACEID string

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this user roles action v1 internal server error response has a 2xx status code
func (o *UserRolesActionV1InternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this user roles action v1 internal server error response has a 3xx status code
func (o *UserRolesActionV1InternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this user roles action v1 internal server error response has a 4xx status code
func (o *UserRolesActionV1InternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this user roles action v1 internal server error response has a 5xx status code
func (o *UserRolesActionV1InternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this user roles action v1 internal server error response a status code equal to that given
func (o *UserRolesActionV1InternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the user roles action v1 internal server error response
func (o *UserRolesActionV1InternalServerError) Code() int {
	return 500
}

func (o *UserRolesActionV1InternalServerError) Error() string {
	return fmt.Sprintf("[POST /user-management/entities/user-role-actions/v1][%d] userRolesActionV1InternalServerError  %+v", 500, o.Payload)
}

func (o *UserRolesActionV1InternalServerError) String() string {
	return fmt.Sprintf("[POST /user-management/entities/user-role-actions/v1][%d] userRolesActionV1InternalServerError  %+v", 500, o.Payload)
}

func (o *UserRolesActionV1InternalServerError) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *UserRolesActionV1InternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-CS-TRACEID
	hdrXCSTRACEID := response.GetHeader("X-CS-TRACEID")

	if hdrXCSTRACEID != "" {
		o.XCSTRACEID = hdrXCSTRACEID
	}

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewUserRolesActionV1Default creates a UserRolesActionV1Default with default headers values
func NewUserRolesActionV1Default(code int) *UserRolesActionV1Default {
	return &UserRolesActionV1Default{
		_statusCode: code,
	}
}

/*
UserRolesActionV1Default describes a response with status code -1, with default header values.

OK
*/
type UserRolesActionV1Default struct {
	_statusCode int

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this user roles action v1 default response has a 2xx status code
func (o *UserRolesActionV1Default) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this user roles action v1 default response has a 3xx status code
func (o *UserRolesActionV1Default) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this user roles action v1 default response has a 4xx status code
func (o *UserRolesActionV1Default) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this user roles action v1 default response has a 5xx status code
func (o *UserRolesActionV1Default) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this user roles action v1 default response a status code equal to that given
func (o *UserRolesActionV1Default) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the user roles action v1 default response
func (o *UserRolesActionV1Default) Code() int {
	return o._statusCode
}

func (o *UserRolesActionV1Default) Error() string {
	return fmt.Sprintf("[POST /user-management/entities/user-role-actions/v1][%d] userRolesActionV1 default  %+v", o._statusCode, o.Payload)
}

func (o *UserRolesActionV1Default) String() string {
	return fmt.Sprintf("[POST /user-management/entities/user-role-actions/v1][%d] userRolesActionV1 default  %+v", o._statusCode, o.Payload)
}

func (o *UserRolesActionV1Default) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *UserRolesActionV1Default) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
