// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// DomainFileDetailsV1 domain file details v1
//
// swagger:model domain.FileDetailsV1
type DomainFileDetailsV1 struct {

	// (Boolean) If it's a complete dataset or not.
	// Required: true
	CompleteDataSet *bool `json:"complete_data_set"`

	// A list of download urls for this file.
	// Required: true
	DownloadUrls []string `json:"download_urls"`

	// The name of the file containing the exposed record(s).
	// Required: true
	Name *string `json:"name"`

	// The size of the file.
	// Required: true
	Size *int32 `json:"size"`
}

// Validate validates this domain file details v1
func (m *DomainFileDetailsV1) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateCompleteDataSet(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDownloadUrls(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSize(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *DomainFileDetailsV1) validateCompleteDataSet(formats strfmt.Registry) error {

	if err := validate.Required("complete_data_set", "body", m.CompleteDataSet); err != nil {
		return err
	}

	return nil
}

func (m *DomainFileDetailsV1) validateDownloadUrls(formats strfmt.Registry) error {

	if err := validate.Required("download_urls", "body", m.DownloadUrls); err != nil {
		return err
	}

	return nil
}

func (m *DomainFileDetailsV1) validateName(formats strfmt.Registry) error {

	if err := validate.Required("name", "body", m.Name); err != nil {
		return err
	}

	return nil
}

func (m *DomainFileDetailsV1) validateSize(formats strfmt.Registry) error {

	if err := validate.Required("size", "body", m.Size); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this domain file details v1 based on context it is used
func (m *DomainFileDetailsV1) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *DomainFileDetailsV1) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *DomainFileDetailsV1) UnmarshalBinary(b []byte) error {
	var res DomainFileDetailsV1
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
