// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// ExternalChange external change
//
// swagger:model external.Change
type ExternalChange struct {

	// action timestamp
	// Required: true
	ActionTimestamp *string `json:"action_timestamp"`

	// Possible values: UNKNOWN, CREATE, WRITE, DELETE, SET, RENAME.
	// Required: true
	ActionType *string `json:"action_type"`

	// aid
	// Required: true
	Aid *string `json:"aid"`

	// cid
	// Required: true
	Cid *string `json:"cid"`

	// command line
	// Required: true
	CommandLine *string `json:"command_line"`

	// diff
	Diff *ExternalDiff `json:"diff,omitempty"`

	// entity path
	// Required: true
	EntityPath *string `json:"entity_path"`

	// entity path new
	EntityPathNew string `json:"entity_path_new,omitempty"`

	// Possible values: UNKNOWN, FILE, DIR, REGKEY,  REGVAL.
	// Required: true
	EntityType *string `json:"entity_type"`

	// host
	Host *ExternalHost `json:"host,omitempty"`

	// id
	// Required: true
	ID *string `json:"id"`

	// ingestion timestamp
	// Required: true
	IngestionTimestamp *string `json:"ingestion_timestamp"`

	// is suppressed
	// Required: true
	IsSuppressed *bool `json:"is_suppressed"`

	// platform name
	// Required: true
	PlatformName *string `json:"platform_name"`

	// policy
	Policy *ExternalPolicy `json:"policy,omitempty"`

	// process id
	// Required: true
	ProcessID *string `json:"process_id"`

	// process image file name
	// Required: true
	ProcessImageFileName *string `json:"process_image_file_name"`

	// Possible values: UNKNOWN, LOW, MEDIUM, HIGH, CRITICAL
	// Required: true
	Severity *string `json:"severity"`

	// user id
	// Required: true
	UserID *string `json:"user_id"`

	// user name
	// Required: true
	UserName *string `json:"user_name"`
}

// Validate validates this external change
func (m *ExternalChange) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateActionTimestamp(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateActionType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateAid(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCid(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateCommandLine(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateDiff(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateEntityPath(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateEntityType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateHost(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateID(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIngestionTimestamp(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateIsSuppressed(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePlatformName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePolicy(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateProcessID(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateProcessImageFileName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSeverity(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateUserID(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateUserName(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ExternalChange) validateActionTimestamp(formats strfmt.Registry) error {

	if err := validate.Required("action_timestamp", "body", m.ActionTimestamp); err != nil {
		return err
	}

	return nil
}

func (m *ExternalChange) validateActionType(formats strfmt.Registry) error {

	if err := validate.Required("action_type", "body", m.ActionType); err != nil {
		return err
	}

	return nil
}

func (m *ExternalChange) validateAid(formats strfmt.Registry) error {

	if err := validate.Required("aid", "body", m.Aid); err != nil {
		return err
	}

	return nil
}

func (m *ExternalChange) validateCid(formats strfmt.Registry) error {

	if err := validate.Required("cid", "body", m.Cid); err != nil {
		return err
	}

	return nil
}

func (m *ExternalChange) validateCommandLine(formats strfmt.Registry) error {

	if err := validate.Required("command_line", "body", m.CommandLine); err != nil {
		return err
	}

	return nil
}

func (m *ExternalChange) validateDiff(formats strfmt.Registry) error {
	if swag.IsZero(m.Diff) { // not required
		return nil
	}

	if m.Diff != nil {
		if err := m.Diff.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("diff")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("diff")
			}
			return err
		}
	}

	return nil
}

func (m *ExternalChange) validateEntityPath(formats strfmt.Registry) error {

	if err := validate.Required("entity_path", "body", m.EntityPath); err != nil {
		return err
	}

	return nil
}

func (m *ExternalChange) validateEntityType(formats strfmt.Registry) error {

	if err := validate.Required("entity_type", "body", m.EntityType); err != nil {
		return err
	}

	return nil
}

func (m *ExternalChange) validateHost(formats strfmt.Registry) error {
	if swag.IsZero(m.Host) { // not required
		return nil
	}

	if m.Host != nil {
		if err := m.Host.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("host")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("host")
			}
			return err
		}
	}

	return nil
}

func (m *ExternalChange) validateID(formats strfmt.Registry) error {

	if err := validate.Required("id", "body", m.ID); err != nil {
		return err
	}

	return nil
}

func (m *ExternalChange) validateIngestionTimestamp(formats strfmt.Registry) error {

	if err := validate.Required("ingestion_timestamp", "body", m.IngestionTimestamp); err != nil {
		return err
	}

	return nil
}

func (m *ExternalChange) validateIsSuppressed(formats strfmt.Registry) error {

	if err := validate.Required("is_suppressed", "body", m.IsSuppressed); err != nil {
		return err
	}

	return nil
}

func (m *ExternalChange) validatePlatformName(formats strfmt.Registry) error {

	if err := validate.Required("platform_name", "body", m.PlatformName); err != nil {
		return err
	}

	return nil
}

func (m *ExternalChange) validatePolicy(formats strfmt.Registry) error {
	if swag.IsZero(m.Policy) { // not required
		return nil
	}

	if m.Policy != nil {
		if err := m.Policy.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("policy")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("policy")
			}
			return err
		}
	}

	return nil
}

func (m *ExternalChange) validateProcessID(formats strfmt.Registry) error {

	if err := validate.Required("process_id", "body", m.ProcessID); err != nil {
		return err
	}

	return nil
}

func (m *ExternalChange) validateProcessImageFileName(formats strfmt.Registry) error {

	if err := validate.Required("process_image_file_name", "body", m.ProcessImageFileName); err != nil {
		return err
	}

	return nil
}

func (m *ExternalChange) validateSeverity(formats strfmt.Registry) error {

	if err := validate.Required("severity", "body", m.Severity); err != nil {
		return err
	}

	return nil
}

func (m *ExternalChange) validateUserID(formats strfmt.Registry) error {

	if err := validate.Required("user_id", "body", m.UserID); err != nil {
		return err
	}

	return nil
}

func (m *ExternalChange) validateUserName(formats strfmt.Registry) error {

	if err := validate.Required("user_name", "body", m.UserName); err != nil {
		return err
	}

	return nil
}

// ContextValidate validate this external change based on the context it is used
func (m *ExternalChange) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateDiff(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidateHost(ctx, formats); err != nil {
		res = append(res, err)
	}

	if err := m.contextValidatePolicy(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ExternalChange) contextValidateDiff(ctx context.Context, formats strfmt.Registry) error {

	if m.Diff != nil {
		if err := m.Diff.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("diff")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("diff")
			}
			return err
		}
	}

	return nil
}

func (m *ExternalChange) contextValidateHost(ctx context.Context, formats strfmt.Registry) error {

	if m.Host != nil {
		if err := m.Host.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("host")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("host")
			}
			return err
		}
	}

	return nil
}

func (m *ExternalChange) contextValidatePolicy(ctx context.Context, formats strfmt.Registry) error {

	if m.Policy != nil {
		if err := m.Policy.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("policy")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("policy")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *ExternalChange) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ExternalChange) UnmarshalBinary(b []byte) error {
	var res ExternalChange
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
