// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// RequestsCreateFirewallPolicyV1 requests create firewall policy v1
//
// swagger:model requests.CreateFirewallPolicyV1
type RequestsCreateFirewallPolicyV1 struct {

	// If specified the firewall rules of the firewall policy identified by the id will be used
	CloneID string `json:"clone_id,omitempty"`

	// The description to use when creating the policy
	Description string `json:"description,omitempty"`

	// The name to use when creating the policy
	// Required: true
	Name *string `json:"name"`

	// The name of the platform
	// Required: true
	// Enum: [Windows Mac Linux]
	PlatformName *string `json:"platform_name"`
}

// Validate validates this requests create firewall policy v1
func (m *RequestsCreateFirewallPolicyV1) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePlatformName(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *RequestsCreateFirewallPolicyV1) validateName(formats strfmt.Registry) error {

	if err := validate.Required("name", "body", m.Name); err != nil {
		return err
	}

	return nil
}

var requestsCreateFirewallPolicyV1TypePlatformNamePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["Windows","Mac","Linux"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		requestsCreateFirewallPolicyV1TypePlatformNamePropEnum = append(requestsCreateFirewallPolicyV1TypePlatformNamePropEnum, v)
	}
}

const (

	// RequestsCreateFirewallPolicyV1PlatformNameWindows captures enum value "Windows"
	RequestsCreateFirewallPolicyV1PlatformNameWindows string = "Windows"

	// RequestsCreateFirewallPolicyV1PlatformNameMac captures enum value "Mac"
	RequestsCreateFirewallPolicyV1PlatformNameMac string = "Mac"

	// RequestsCreateFirewallPolicyV1PlatformNameLinux captures enum value "Linux"
	RequestsCreateFirewallPolicyV1PlatformNameLinux string = "Linux"
)

// prop value enum
func (m *RequestsCreateFirewallPolicyV1) validatePlatformNameEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, requestsCreateFirewallPolicyV1TypePlatformNamePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *RequestsCreateFirewallPolicyV1) validatePlatformName(formats strfmt.Registry) error {

	if err := validate.Required("platform_name", "body", m.PlatformName); err != nil {
		return err
	}

	// value enum
	if err := m.validatePlatformNameEnum("platform_name", "body", *m.PlatformName); err != nil {
		return err
	}

	return nil
}

// ContextValidate validates this requests create firewall policy v1 based on context it is used
func (m *RequestsCreateFirewallPolicyV1) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	return nil
}

// MarshalBinary interface implementation
func (m *RequestsCreateFirewallPolicyV1) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *RequestsCreateFirewallPolicyV1) UnmarshalBinary(b []byte) error {
	var res RequestsCreateFirewallPolicyV1
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
