// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// RequestsCreateSensorUpdatePolicyV2 requests create sensor update policy v2
//
// swagger:model requests.CreateSensorUpdatePolicyV2
type RequestsCreateSensorUpdatePolicyV2 struct {

	// The description to use when creating the policy
	Description string `json:"description,omitempty"`

	// The name to use when creating the policy
	// Required: true
	Name *string `json:"name"`

	// The name of the platform
	// Required: true
	// Enum: [Windows Mac Linux]
	PlatformName *string `json:"platform_name"`

	// The settings to create the policy with
	Settings *RequestsSensorUpdateSettingsV2 `json:"settings,omitempty"`
}

// Validate validates this requests create sensor update policy v2
func (m *RequestsCreateSensorUpdatePolicyV2) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePlatformName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSettings(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *RequestsCreateSensorUpdatePolicyV2) validateName(formats strfmt.Registry) error {

	if err := validate.Required("name", "body", m.Name); err != nil {
		return err
	}

	return nil
}

var requestsCreateSensorUpdatePolicyV2TypePlatformNamePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["Windows","Mac","Linux"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		requestsCreateSensorUpdatePolicyV2TypePlatformNamePropEnum = append(requestsCreateSensorUpdatePolicyV2TypePlatformNamePropEnum, v)
	}
}

const (

	// RequestsCreateSensorUpdatePolicyV2PlatformNameWindows captures enum value "Windows"
	RequestsCreateSensorUpdatePolicyV2PlatformNameWindows string = "Windows"

	// RequestsCreateSensorUpdatePolicyV2PlatformNameMac captures enum value "Mac"
	RequestsCreateSensorUpdatePolicyV2PlatformNameMac string = "Mac"

	// RequestsCreateSensorUpdatePolicyV2PlatformNameLinux captures enum value "Linux"
	RequestsCreateSensorUpdatePolicyV2PlatformNameLinux string = "Linux"
)

// prop value enum
func (m *RequestsCreateSensorUpdatePolicyV2) validatePlatformNameEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, requestsCreateSensorUpdatePolicyV2TypePlatformNamePropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *RequestsCreateSensorUpdatePolicyV2) validatePlatformName(formats strfmt.Registry) error {

	if err := validate.Required("platform_name", "body", m.PlatformName); err != nil {
		return err
	}

	// value enum
	if err := m.validatePlatformNameEnum("platform_name", "body", *m.PlatformName); err != nil {
		return err
	}

	return nil
}

func (m *RequestsCreateSensorUpdatePolicyV2) validateSettings(formats strfmt.Registry) error {
	if swag.IsZero(m.Settings) { // not required
		return nil
	}

	if m.Settings != nil {
		if err := m.Settings.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("settings")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("settings")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this requests create sensor update policy v2 based on the context it is used
func (m *RequestsCreateSensorUpdatePolicyV2) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSettings(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *RequestsCreateSensorUpdatePolicyV2) contextValidateSettings(ctx context.Context, formats strfmt.Registry) error {

	if m.Settings != nil {
		if err := m.Settings.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("settings")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("settings")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *RequestsCreateSensorUpdatePolicyV2) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *RequestsCreateSensorUpdatePolicyV2) UnmarshalBinary(b []byte) error {
	var res RequestsCreateSensorUpdatePolicyV2
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
