// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// RequestsSensorUpdateSettingsV2 requests sensor update settings v2
//
// swagger:model requests.SensorUpdateSettingsV2
type RequestsSensorUpdateSettingsV2 struct {

	// The target build to apply to the policy
	Build string `json:"build,omitempty"`

	// The uninstall protection state to apply to the policy
	// Enum: [ENABLED DISABLED MAINTENANCE_MODE IGNORE UNKNOWN]
	UninstallProtection string `json:"uninstall_protection,omitempty"`

	// variants
	// Required: true
	Variants []*RequestsSensorUpdateBuildV1 `json:"variants"`
}

// Validate validates this requests sensor update settings v2
func (m *RequestsSensorUpdateSettingsV2) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateUninstallProtection(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateVariants(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

var requestsSensorUpdateSettingsV2TypeUninstallProtectionPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["ENABLED","DISABLED","MAINTENANCE_MODE","IGNORE","UNKNOWN"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		requestsSensorUpdateSettingsV2TypeUninstallProtectionPropEnum = append(requestsSensorUpdateSettingsV2TypeUninstallProtectionPropEnum, v)
	}
}

const (

	// RequestsSensorUpdateSettingsV2UninstallProtectionENABLED captures enum value "ENABLED"
	RequestsSensorUpdateSettingsV2UninstallProtectionENABLED string = "ENABLED"

	// RequestsSensorUpdateSettingsV2UninstallProtectionDISABLED captures enum value "DISABLED"
	RequestsSensorUpdateSettingsV2UninstallProtectionDISABLED string = "DISABLED"

	// RequestsSensorUpdateSettingsV2UninstallProtectionMAINTENANCEMODE captures enum value "MAINTENANCE_MODE"
	RequestsSensorUpdateSettingsV2UninstallProtectionMAINTENANCEMODE string = "MAINTENANCE_MODE"

	// RequestsSensorUpdateSettingsV2UninstallProtectionIGNORE captures enum value "IGNORE"
	RequestsSensorUpdateSettingsV2UninstallProtectionIGNORE string = "IGNORE"

	// RequestsSensorUpdateSettingsV2UninstallProtectionUNKNOWN captures enum value "UNKNOWN"
	RequestsSensorUpdateSettingsV2UninstallProtectionUNKNOWN string = "UNKNOWN"
)

// prop value enum
func (m *RequestsSensorUpdateSettingsV2) validateUninstallProtectionEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, requestsSensorUpdateSettingsV2TypeUninstallProtectionPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *RequestsSensorUpdateSettingsV2) validateUninstallProtection(formats strfmt.Registry) error {
	if swag.IsZero(m.UninstallProtection) { // not required
		return nil
	}

	// value enum
	if err := m.validateUninstallProtectionEnum("uninstall_protection", "body", m.UninstallProtection); err != nil {
		return err
	}

	return nil
}

func (m *RequestsSensorUpdateSettingsV2) validateVariants(formats strfmt.Registry) error {

	if err := validate.Required("variants", "body", m.Variants); err != nil {
		return err
	}

	for i := 0; i < len(m.Variants); i++ {
		if swag.IsZero(m.Variants[i]) { // not required
			continue
		}

		if m.Variants[i] != nil {
			if err := m.Variants[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("variants" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("variants" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this requests sensor update settings v2 based on the context it is used
func (m *RequestsSensorUpdateSettingsV2) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateVariants(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *RequestsSensorUpdateSettingsV2) contextValidateVariants(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Variants); i++ {

		if m.Variants[i] != nil {
			if err := m.Variants[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("variants" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("variants" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *RequestsSensorUpdateSettingsV2) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *RequestsSensorUpdateSettingsV2) UnmarshalBinary(b []byte) error {
	var res RequestsSensorUpdateSettingsV2
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
