// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// RequestsUpdateSensorUpdatePolicyV2 An update for a specific policy
//
// swagger:model requests.UpdateSensorUpdatePolicyV2
type RequestsUpdateSensorUpdatePolicyV2 struct {

	// The new description to assign to the policy
	Description string `json:"description,omitempty"`

	// The id of the policy to update
	// Required: true
	ID *string `json:"id"`

	// The new name to assign to the policy
	Name string `json:"name,omitempty"`

	// A collection of sensorUpdate policy settings to update
	Settings *RequestsSensorUpdateSettingsV2 `json:"settings,omitempty"`
}

// Validate validates this requests update sensor update policy v2
func (m *RequestsUpdateSensorUpdatePolicyV2) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateID(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSettings(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *RequestsUpdateSensorUpdatePolicyV2) validateID(formats strfmt.Registry) error {

	if err := validate.Required("id", "body", m.ID); err != nil {
		return err
	}

	return nil
}

func (m *RequestsUpdateSensorUpdatePolicyV2) validateSettings(formats strfmt.Registry) error {
	if swag.IsZero(m.Settings) { // not required
		return nil
	}

	if m.Settings != nil {
		if err := m.Settings.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("settings")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("settings")
			}
			return err
		}
	}

	return nil
}

// ContextValidate validate this requests update sensor update policy v2 based on the context it is used
func (m *RequestsUpdateSensorUpdatePolicyV2) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateSettings(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *RequestsUpdateSensorUpdatePolicyV2) contextValidateSettings(ctx context.Context, formats strfmt.Registry) error {

	if m.Settings != nil {
		if err := m.Settings.ContextValidate(ctx, formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("settings")
			} else if ce, ok := err.(*errors.CompositeError); ok {
				return ce.ValidateName("settings")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *RequestsUpdateSensorUpdatePolicyV2) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *RequestsUpdateSensorUpdatePolicyV2) UnmarshalBinary(b []byte) error {
	var res RequestsUpdateSensorUpdatePolicyV2
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
