// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"encoding/json"
	"strconv"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// ResponsesSensorUpdateSettingsV2 responses sensor update settings v2
//
// swagger:model responses.SensorUpdateSettingsV2
type ResponsesSensorUpdateSettingsV2 struct {

	// The target build applied to devices in the policy
	// Required: true
	Build *string `json:"build"`

	// sensor version
	// Required: true
	SensorVersion *string `json:"sensor_version"`

	// The uninstall protection setting to apply to devices in the policy
	// Required: true
	// Enum: [ENABLED DISABLED MAINTENANCE_MODE IGNORE UNKNOWN]
	UninstallProtection *string `json:"uninstall_protection"`

	// variants
	// Required: true
	Variants []*ResponsesSensorUpdateBuildV1 `json:"variants"`
}

// Validate validates this responses sensor update settings v2
func (m *ResponsesSensorUpdateSettingsV2) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateBuild(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateSensorVersion(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateUninstallProtection(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateVariants(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ResponsesSensorUpdateSettingsV2) validateBuild(formats strfmt.Registry) error {

	if err := validate.Required("build", "body", m.Build); err != nil {
		return err
	}

	return nil
}

func (m *ResponsesSensorUpdateSettingsV2) validateSensorVersion(formats strfmt.Registry) error {

	if err := validate.Required("sensor_version", "body", m.SensorVersion); err != nil {
		return err
	}

	return nil
}

var responsesSensorUpdateSettingsV2TypeUninstallProtectionPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["ENABLED","DISABLED","MAINTENANCE_MODE","IGNORE","UNKNOWN"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		responsesSensorUpdateSettingsV2TypeUninstallProtectionPropEnum = append(responsesSensorUpdateSettingsV2TypeUninstallProtectionPropEnum, v)
	}
}

const (

	// ResponsesSensorUpdateSettingsV2UninstallProtectionENABLED captures enum value "ENABLED"
	ResponsesSensorUpdateSettingsV2UninstallProtectionENABLED string = "ENABLED"

	// ResponsesSensorUpdateSettingsV2UninstallProtectionDISABLED captures enum value "DISABLED"
	ResponsesSensorUpdateSettingsV2UninstallProtectionDISABLED string = "DISABLED"

	// ResponsesSensorUpdateSettingsV2UninstallProtectionMAINTENANCEMODE captures enum value "MAINTENANCE_MODE"
	ResponsesSensorUpdateSettingsV2UninstallProtectionMAINTENANCEMODE string = "MAINTENANCE_MODE"

	// ResponsesSensorUpdateSettingsV2UninstallProtectionIGNORE captures enum value "IGNORE"
	ResponsesSensorUpdateSettingsV2UninstallProtectionIGNORE string = "IGNORE"

	// ResponsesSensorUpdateSettingsV2UninstallProtectionUNKNOWN captures enum value "UNKNOWN"
	ResponsesSensorUpdateSettingsV2UninstallProtectionUNKNOWN string = "UNKNOWN"
)

// prop value enum
func (m *ResponsesSensorUpdateSettingsV2) validateUninstallProtectionEnum(path, location string, value string) error {
	if err := validate.EnumCase(path, location, value, responsesSensorUpdateSettingsV2TypeUninstallProtectionPropEnum, true); err != nil {
		return err
	}
	return nil
}

func (m *ResponsesSensorUpdateSettingsV2) validateUninstallProtection(formats strfmt.Registry) error {

	if err := validate.Required("uninstall_protection", "body", m.UninstallProtection); err != nil {
		return err
	}

	// value enum
	if err := m.validateUninstallProtectionEnum("uninstall_protection", "body", *m.UninstallProtection); err != nil {
		return err
	}

	return nil
}

func (m *ResponsesSensorUpdateSettingsV2) validateVariants(formats strfmt.Registry) error {

	if err := validate.Required("variants", "body", m.Variants); err != nil {
		return err
	}

	for i := 0; i < len(m.Variants); i++ {
		if swag.IsZero(m.Variants[i]) { // not required
			continue
		}

		if m.Variants[i] != nil {
			if err := m.Variants[i].Validate(formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("variants" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("variants" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// ContextValidate validate this responses sensor update settings v2 based on the context it is used
func (m *ResponsesSensorUpdateSettingsV2) ContextValidate(ctx context.Context, formats strfmt.Registry) error {
	var res []error

	if err := m.contextValidateVariants(ctx, formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *ResponsesSensorUpdateSettingsV2) contextValidateVariants(ctx context.Context, formats strfmt.Registry) error {

	for i := 0; i < len(m.Variants); i++ {

		if m.Variants[i] != nil {
			if err := m.Variants[i].ContextValidate(ctx, formats); err != nil {
				if ve, ok := err.(*errors.Validation); ok {
					return ve.ValidateName("variants" + "." + strconv.Itoa(i))
				} else if ce, ok := err.(*errors.CompositeError); ok {
					return ce.ValidateName("variants" + "." + strconv.Itoa(i))
				}
				return err
			}
		}

	}

	return nil
}

// MarshalBinary interface implementation
func (m *ResponsesSensorUpdateSettingsV2) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *ResponsesSensorUpdateSettingsV2) UnmarshalBinary(b []byte) error {
	var res ResponsesSensorUpdateSettingsV2
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
