// Code generated by go-swagger; DO NOT EDIT.

package malquery

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"

	"github.com/crowdstrike/gofalcon/falcon/models"
)

// PostMalQueryFuzzySearchV1Reader is a Reader for the PostMalQueryFuzzySearchV1 structure.
type PostMalQueryFuzzySearchV1Reader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *PostMalQueryFuzzySearchV1Reader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewPostMalQueryFuzzySearchV1OK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 400:
		result := NewPostMalQueryFuzzySearchV1BadRequest()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 401:
		result := NewPostMalQueryFuzzySearchV1Unauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewPostMalQueryFuzzySearchV1Forbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 429:
		result := NewPostMalQueryFuzzySearchV1TooManyRequests()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewPostMalQueryFuzzySearchV1InternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		result := NewPostMalQueryFuzzySearchV1Default(response.Code())
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		if response.Code()/100 == 2 {
			return result, nil
		}
		return nil, result
	}
}

// NewPostMalQueryFuzzySearchV1OK creates a PostMalQueryFuzzySearchV1OK with default headers values
func NewPostMalQueryFuzzySearchV1OK() *PostMalQueryFuzzySearchV1OK {
	return &PostMalQueryFuzzySearchV1OK{}
}

/*
PostMalQueryFuzzySearchV1OK describes a response with status code 200, with default header values.

OK
*/
type PostMalQueryFuzzySearchV1OK struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MalqueryFuzzySearchResponse
}

// IsSuccess returns true when this post mal query fuzzy search v1 o k response has a 2xx status code
func (o *PostMalQueryFuzzySearchV1OK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this post mal query fuzzy search v1 o k response has a 3xx status code
func (o *PostMalQueryFuzzySearchV1OK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post mal query fuzzy search v1 o k response has a 4xx status code
func (o *PostMalQueryFuzzySearchV1OK) IsClientError() bool {
	return false
}

// IsServerError returns true when this post mal query fuzzy search v1 o k response has a 5xx status code
func (o *PostMalQueryFuzzySearchV1OK) IsServerError() bool {
	return false
}

// IsCode returns true when this post mal query fuzzy search v1 o k response a status code equal to that given
func (o *PostMalQueryFuzzySearchV1OK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the post mal query fuzzy search v1 o k response
func (o *PostMalQueryFuzzySearchV1OK) Code() int {
	return 200
}

func (o *PostMalQueryFuzzySearchV1OK) Error() string {
	return fmt.Sprintf("[POST /malquery/combined/fuzzy-search/v1][%d] postMalQueryFuzzySearchV1OK  %+v", 200, o.Payload)
}

func (o *PostMalQueryFuzzySearchV1OK) String() string {
	return fmt.Sprintf("[POST /malquery/combined/fuzzy-search/v1][%d] postMalQueryFuzzySearchV1OK  %+v", 200, o.Payload)
}

func (o *PostMalQueryFuzzySearchV1OK) GetPayload() *models.MalqueryFuzzySearchResponse {
	return o.Payload
}

func (o *PostMalQueryFuzzySearchV1OK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MalqueryFuzzySearchResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostMalQueryFuzzySearchV1BadRequest creates a PostMalQueryFuzzySearchV1BadRequest with default headers values
func NewPostMalQueryFuzzySearchV1BadRequest() *PostMalQueryFuzzySearchV1BadRequest {
	return &PostMalQueryFuzzySearchV1BadRequest{}
}

/*
PostMalQueryFuzzySearchV1BadRequest describes a response with status code 400, with default header values.

Bad Request
*/
type PostMalQueryFuzzySearchV1BadRequest struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MalqueryFuzzySearchResponse
}

// IsSuccess returns true when this post mal query fuzzy search v1 bad request response has a 2xx status code
func (o *PostMalQueryFuzzySearchV1BadRequest) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post mal query fuzzy search v1 bad request response has a 3xx status code
func (o *PostMalQueryFuzzySearchV1BadRequest) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post mal query fuzzy search v1 bad request response has a 4xx status code
func (o *PostMalQueryFuzzySearchV1BadRequest) IsClientError() bool {
	return true
}

// IsServerError returns true when this post mal query fuzzy search v1 bad request response has a 5xx status code
func (o *PostMalQueryFuzzySearchV1BadRequest) IsServerError() bool {
	return false
}

// IsCode returns true when this post mal query fuzzy search v1 bad request response a status code equal to that given
func (o *PostMalQueryFuzzySearchV1BadRequest) IsCode(code int) bool {
	return code == 400
}

// Code gets the status code for the post mal query fuzzy search v1 bad request response
func (o *PostMalQueryFuzzySearchV1BadRequest) Code() int {
	return 400
}

func (o *PostMalQueryFuzzySearchV1BadRequest) Error() string {
	return fmt.Sprintf("[POST /malquery/combined/fuzzy-search/v1][%d] postMalQueryFuzzySearchV1BadRequest  %+v", 400, o.Payload)
}

func (o *PostMalQueryFuzzySearchV1BadRequest) String() string {
	return fmt.Sprintf("[POST /malquery/combined/fuzzy-search/v1][%d] postMalQueryFuzzySearchV1BadRequest  %+v", 400, o.Payload)
}

func (o *PostMalQueryFuzzySearchV1BadRequest) GetPayload() *models.MalqueryFuzzySearchResponse {
	return o.Payload
}

func (o *PostMalQueryFuzzySearchV1BadRequest) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MalqueryFuzzySearchResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostMalQueryFuzzySearchV1Unauthorized creates a PostMalQueryFuzzySearchV1Unauthorized with default headers values
func NewPostMalQueryFuzzySearchV1Unauthorized() *PostMalQueryFuzzySearchV1Unauthorized {
	return &PostMalQueryFuzzySearchV1Unauthorized{}
}

/*
PostMalQueryFuzzySearchV1Unauthorized describes a response with status code 401, with default header values.

Unauthorized
*/
type PostMalQueryFuzzySearchV1Unauthorized struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaErrorsOnly
}

// IsSuccess returns true when this post mal query fuzzy search v1 unauthorized response has a 2xx status code
func (o *PostMalQueryFuzzySearchV1Unauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post mal query fuzzy search v1 unauthorized response has a 3xx status code
func (o *PostMalQueryFuzzySearchV1Unauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post mal query fuzzy search v1 unauthorized response has a 4xx status code
func (o *PostMalQueryFuzzySearchV1Unauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this post mal query fuzzy search v1 unauthorized response has a 5xx status code
func (o *PostMalQueryFuzzySearchV1Unauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this post mal query fuzzy search v1 unauthorized response a status code equal to that given
func (o *PostMalQueryFuzzySearchV1Unauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the post mal query fuzzy search v1 unauthorized response
func (o *PostMalQueryFuzzySearchV1Unauthorized) Code() int {
	return 401
}

func (o *PostMalQueryFuzzySearchV1Unauthorized) Error() string {
	return fmt.Sprintf("[POST /malquery/combined/fuzzy-search/v1][%d] postMalQueryFuzzySearchV1Unauthorized  %+v", 401, o.Payload)
}

func (o *PostMalQueryFuzzySearchV1Unauthorized) String() string {
	return fmt.Sprintf("[POST /malquery/combined/fuzzy-search/v1][%d] postMalQueryFuzzySearchV1Unauthorized  %+v", 401, o.Payload)
}

func (o *PostMalQueryFuzzySearchV1Unauthorized) GetPayload() *models.MsaErrorsOnly {
	return o.Payload
}

func (o *PostMalQueryFuzzySearchV1Unauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaErrorsOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostMalQueryFuzzySearchV1Forbidden creates a PostMalQueryFuzzySearchV1Forbidden with default headers values
func NewPostMalQueryFuzzySearchV1Forbidden() *PostMalQueryFuzzySearchV1Forbidden {
	return &PostMalQueryFuzzySearchV1Forbidden{}
}

/*
PostMalQueryFuzzySearchV1Forbidden describes a response with status code 403, with default header values.

Forbidden
*/
type PostMalQueryFuzzySearchV1Forbidden struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MsaErrorsOnly
}

// IsSuccess returns true when this post mal query fuzzy search v1 forbidden response has a 2xx status code
func (o *PostMalQueryFuzzySearchV1Forbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post mal query fuzzy search v1 forbidden response has a 3xx status code
func (o *PostMalQueryFuzzySearchV1Forbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post mal query fuzzy search v1 forbidden response has a 4xx status code
func (o *PostMalQueryFuzzySearchV1Forbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this post mal query fuzzy search v1 forbidden response has a 5xx status code
func (o *PostMalQueryFuzzySearchV1Forbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this post mal query fuzzy search v1 forbidden response a status code equal to that given
func (o *PostMalQueryFuzzySearchV1Forbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the post mal query fuzzy search v1 forbidden response
func (o *PostMalQueryFuzzySearchV1Forbidden) Code() int {
	return 403
}

func (o *PostMalQueryFuzzySearchV1Forbidden) Error() string {
	return fmt.Sprintf("[POST /malquery/combined/fuzzy-search/v1][%d] postMalQueryFuzzySearchV1Forbidden  %+v", 403, o.Payload)
}

func (o *PostMalQueryFuzzySearchV1Forbidden) String() string {
	return fmt.Sprintf("[POST /malquery/combined/fuzzy-search/v1][%d] postMalQueryFuzzySearchV1Forbidden  %+v", 403, o.Payload)
}

func (o *PostMalQueryFuzzySearchV1Forbidden) GetPayload() *models.MsaErrorsOnly {
	return o.Payload
}

func (o *PostMalQueryFuzzySearchV1Forbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MsaErrorsOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostMalQueryFuzzySearchV1TooManyRequests creates a PostMalQueryFuzzySearchV1TooManyRequests with default headers values
func NewPostMalQueryFuzzySearchV1TooManyRequests() *PostMalQueryFuzzySearchV1TooManyRequests {
	return &PostMalQueryFuzzySearchV1TooManyRequests{}
}

/*
PostMalQueryFuzzySearchV1TooManyRequests describes a response with status code 429, with default header values.

Too Many Requests
*/
type PostMalQueryFuzzySearchV1TooManyRequests struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	/* Too many requests, retry after this time (as milliseconds since epoch)
	 */
	XRateLimitRetryAfter int64

	Payload *models.MsaReplyMetaOnly
}

// IsSuccess returns true when this post mal query fuzzy search v1 too many requests response has a 2xx status code
func (o *PostMalQueryFuzzySearchV1TooManyRequests) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post mal query fuzzy search v1 too many requests response has a 3xx status code
func (o *PostMalQueryFuzzySearchV1TooManyRequests) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post mal query fuzzy search v1 too many requests response has a 4xx status code
func (o *PostMalQueryFuzzySearchV1TooManyRequests) IsClientError() bool {
	return true
}

// IsServerError returns true when this post mal query fuzzy search v1 too many requests response has a 5xx status code
func (o *PostMalQueryFuzzySearchV1TooManyRequests) IsServerError() bool {
	return false
}

// IsCode returns true when this post mal query fuzzy search v1 too many requests response a status code equal to that given
func (o *PostMalQueryFuzzySearchV1TooManyRequests) IsCode(code int) bool {
	return code == 429
}

// Code gets the status code for the post mal query fuzzy search v1 too many requests response
func (o *PostMalQueryFuzzySearchV1TooManyRequests) Code() int {
	return 429
}

func (o *PostMalQueryFuzzySearchV1TooManyRequests) Error() string {
	return fmt.Sprintf("[POST /malquery/combined/fuzzy-search/v1][%d] postMalQueryFuzzySearchV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *PostMalQueryFuzzySearchV1TooManyRequests) String() string {
	return fmt.Sprintf("[POST /malquery/combined/fuzzy-search/v1][%d] postMalQueryFuzzySearchV1TooManyRequests  %+v", 429, o.Payload)
}

func (o *PostMalQueryFuzzySearchV1TooManyRequests) GetPayload() *models.MsaReplyMetaOnly {
	return o.Payload
}

func (o *PostMalQueryFuzzySearchV1TooManyRequests) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	// hydrates response header X-RateLimit-RetryAfter
	hdrXRateLimitRetryAfter := response.GetHeader("X-RateLimit-RetryAfter")

	if hdrXRateLimitRetryAfter != "" {
		valxRateLimitRetryAfter, err := swag.ConvertInt64(hdrXRateLimitRetryAfter)
		if err != nil {
			return errors.InvalidType("X-RateLimit-RetryAfter", "header", "int64", hdrXRateLimitRetryAfter)
		}
		o.XRateLimitRetryAfter = valxRateLimitRetryAfter
	}

	o.Payload = new(models.MsaReplyMetaOnly)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostMalQueryFuzzySearchV1InternalServerError creates a PostMalQueryFuzzySearchV1InternalServerError with default headers values
func NewPostMalQueryFuzzySearchV1InternalServerError() *PostMalQueryFuzzySearchV1InternalServerError {
	return &PostMalQueryFuzzySearchV1InternalServerError{}
}

/*
PostMalQueryFuzzySearchV1InternalServerError describes a response with status code 500, with default header values.

Internal Server Error
*/
type PostMalQueryFuzzySearchV1InternalServerError struct {

	/* Request limit per minute.
	 */
	XRateLimitLimit int64

	/* The number of requests remaining for the sliding one minute window.
	 */
	XRateLimitRemaining int64

	Payload *models.MalqueryFuzzySearchResponse
}

// IsSuccess returns true when this post mal query fuzzy search v1 internal server error response has a 2xx status code
func (o *PostMalQueryFuzzySearchV1InternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this post mal query fuzzy search v1 internal server error response has a 3xx status code
func (o *PostMalQueryFuzzySearchV1InternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this post mal query fuzzy search v1 internal server error response has a 4xx status code
func (o *PostMalQueryFuzzySearchV1InternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this post mal query fuzzy search v1 internal server error response has a 5xx status code
func (o *PostMalQueryFuzzySearchV1InternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this post mal query fuzzy search v1 internal server error response a status code equal to that given
func (o *PostMalQueryFuzzySearchV1InternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the post mal query fuzzy search v1 internal server error response
func (o *PostMalQueryFuzzySearchV1InternalServerError) Code() int {
	return 500
}

func (o *PostMalQueryFuzzySearchV1InternalServerError) Error() string {
	return fmt.Sprintf("[POST /malquery/combined/fuzzy-search/v1][%d] postMalQueryFuzzySearchV1InternalServerError  %+v", 500, o.Payload)
}

func (o *PostMalQueryFuzzySearchV1InternalServerError) String() string {
	return fmt.Sprintf("[POST /malquery/combined/fuzzy-search/v1][%d] postMalQueryFuzzySearchV1InternalServerError  %+v", 500, o.Payload)
}

func (o *PostMalQueryFuzzySearchV1InternalServerError) GetPayload() *models.MalqueryFuzzySearchResponse {
	return o.Payload
}

func (o *PostMalQueryFuzzySearchV1InternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header X-RateLimit-Limit
	hdrXRateLimitLimit := response.GetHeader("X-RateLimit-Limit")

	if hdrXRateLimitLimit != "" {
		valxRateLimitLimit, err := swag.ConvertInt64(hdrXRateLimitLimit)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Limit", "header", "int64", hdrXRateLimitLimit)
		}
		o.XRateLimitLimit = valxRateLimitLimit
	}

	// hydrates response header X-RateLimit-Remaining
	hdrXRateLimitRemaining := response.GetHeader("X-RateLimit-Remaining")

	if hdrXRateLimitRemaining != "" {
		valxRateLimitRemaining, err := swag.ConvertInt64(hdrXRateLimitRemaining)
		if err != nil {
			return errors.InvalidType("X-RateLimit-Remaining", "header", "int64", hdrXRateLimitRemaining)
		}
		o.XRateLimitRemaining = valxRateLimitRemaining
	}

	o.Payload = new(models.MalqueryFuzzySearchResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewPostMalQueryFuzzySearchV1Default creates a PostMalQueryFuzzySearchV1Default with default headers values
func NewPostMalQueryFuzzySearchV1Default(code int) *PostMalQueryFuzzySearchV1Default {
	return &PostMalQueryFuzzySearchV1Default{
		_statusCode: code,
	}
}

/*
PostMalQueryFuzzySearchV1Default describes a response with status code -1, with default header values.

OK
*/
type PostMalQueryFuzzySearchV1Default struct {
	_statusCode int

	Payload *models.MalqueryFuzzySearchResponse
}

// IsSuccess returns true when this post mal query fuzzy search v1 default response has a 2xx status code
func (o *PostMalQueryFuzzySearchV1Default) IsSuccess() bool {
	return o._statusCode/100 == 2
}

// IsRedirect returns true when this post mal query fuzzy search v1 default response has a 3xx status code
func (o *PostMalQueryFuzzySearchV1Default) IsRedirect() bool {
	return o._statusCode/100 == 3
}

// IsClientError returns true when this post mal query fuzzy search v1 default response has a 4xx status code
func (o *PostMalQueryFuzzySearchV1Default) IsClientError() bool {
	return o._statusCode/100 == 4
}

// IsServerError returns true when this post mal query fuzzy search v1 default response has a 5xx status code
func (o *PostMalQueryFuzzySearchV1Default) IsServerError() bool {
	return o._statusCode/100 == 5
}

// IsCode returns true when this post mal query fuzzy search v1 default response a status code equal to that given
func (o *PostMalQueryFuzzySearchV1Default) IsCode(code int) bool {
	return o._statusCode == code
}

// Code gets the status code for the post mal query fuzzy search v1 default response
func (o *PostMalQueryFuzzySearchV1Default) Code() int {
	return o._statusCode
}

func (o *PostMalQueryFuzzySearchV1Default) Error() string {
	return fmt.Sprintf("[POST /malquery/combined/fuzzy-search/v1][%d] PostMalQueryFuzzySearchV1 default  %+v", o._statusCode, o.Payload)
}

func (o *PostMalQueryFuzzySearchV1Default) String() string {
	return fmt.Sprintf("[POST /malquery/combined/fuzzy-search/v1][%d] PostMalQueryFuzzySearchV1 default  %+v", o._statusCode, o.Payload)
}

func (o *PostMalQueryFuzzySearchV1Default) GetPayload() *models.MalqueryFuzzySearchResponse {
	return o.Payload
}

func (o *PostMalQueryFuzzySearchV1Default) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.MalqueryFuzzySearchResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
